--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-0.15.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Create Database Lock Table
CREATE TABLE DATABASECHANGELOGLOCK (ID INT NOT NULL, `LOCKED` BIT(1) NOT NULL, LOCKGRANTED datetime NULL, LOCKEDBY VARCHAR(255) NULL, CONSTRAINT PK_DATABASECHANGELOGLOCK PRIMARY KEY (ID));

--  Initialize Database Lock Table
DELETE FROM DATABASECHANGELOGLOCK;

INSERT INTO DATABASECHANGELOGLOCK (ID, `LOCKED`) VALUES (1, 0);

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Create Database Change Log Table
CREATE TABLE DATABASECHANGELOG (ID VARCHAR(255) NOT NULL, AUTHOR VARCHAR(255) NOT NULL, FILENAME VARCHAR(255) NOT NULL, DATEEXECUTED datetime NOT NULL, ORDEREXECUTED INT NOT NULL, EXECTYPE VARCHAR(10) NOT NULL, MD5SUM VARCHAR(35) NULL, `DESCRIPTION` VARCHAR(255) NULL, COMMENTS VARCHAR(255) NULL, TAG VARCHAR(255) NULL, LIQUIBASE VARCHAR(20) NULL, CONTEXTS VARCHAR(255) NULL, LABELS VARCHAR(255) NULL, DEPLOYMENT_ID VARCHAR(10) NULL);

--  Changeset ../core/core.changelog-0.15.0.xml::1::gfouquet
CREATE TABLE CORE_USER (ID BIGINT AUTO_INCREMENT NOT NULL, LOGIN VARCHAR(50) NOT NULL COMMENT 'The user''s login as provided by the authentication system', FIRST_NAME VARCHAR(50) DEFAULT '' NOT NULL COMMENT 'The user''s first name', LAST_NAME VARCHAR(50) DEFAULT '' NOT NULL COMMENT 'The user''s last name', EMAIL VARCHAR(50) DEFAULT '' NOT NULL COMMENT 'The user''s e-mail', ACTIVE BIT(1) DEFAULT 0 NOT NULL COMMENT 'User is active or not', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'nom du createur de cet utilisateur.', CREATED_ON datetime NOT NULL COMMENT 'Date de creation de cet utilisateur. Il s''agit de la date de creation de l''entree dans       la base, non d''une date metier.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere mise a jour de cette instance.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis a jour cet instance.', CONSTRAINT PK_CORE_USER PRIMARY KEY (ID), CONSTRAINT CT_UNIQUE_USER_LOGIN UNIQUE (LOGIN));

CREATE UNIQUE INDEX DX_USER_LOGIN ON CORE_USER(LOGIN);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('1', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 1, '8:055dd90ad38219f8193c6a49a1791387', 'createTable tableName=CORE_USER; createIndex indexName=DX_USER_LOGIN, tableName=CORE_USER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::2::gfouquet
CREATE TABLE CORE_GROUP (ID BIGINT AUTO_INCREMENT NOT NULL, QUALIFIED_NAME VARCHAR(255) NOT NULL COMMENT 'Qualified name of the group, both used as a functional key and a localization key. Should be something like ''squashtest.authz.group._app module_._GroupName_''', CONSTRAINT PK_CORE_GROUP PRIMARY KEY (ID), CONSTRAINT CT_UN_GRP_QUAL_NAME UNIQUE (QUALIFIED_NAME));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('2', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 2, '8:3524c5f35c59cdac07e97f678410c887', 'createTable tableName=CORE_GROUP', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::3::gfouquet
CREATE TABLE CORE_GROUP_AUTHORITY (GROUP_ID BIGINT NOT NULL COMMENT 'Shared key with CORE_GROUP table', AUTHORITY VARCHAR(50) NOT NULL COMMENT 'The authority', CONSTRAINT FK_GRP_AUTH_GRP FOREIGN KEY (GROUP_ID) REFERENCES CORE_GROUP(ID));

CREATE INDEX DX_GRP_ID ON CORE_GROUP_AUTHORITY(GROUP_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('3', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 3, '8:37a3be801f407c743188a5c35ddab6fb', 'createTable tableName=CORE_GROUP_AUTHORITY; createIndex indexName=DX_GRP_ID, tableName=CORE_GROUP_AUTHORITY', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::4::gfouquet
CREATE TABLE CORE_GROUP_MEMBER (USER_ID BIGINT NOT NULL, GROUP_ID BIGINT NOT NULL, CONSTRAINT FK_GRP_MEMBER_USR FOREIGN KEY (USER_ID) REFERENCES CORE_USER(ID), CONSTRAINT FK_GRP_MEMBER_GRP FOREIGN KEY (GROUP_ID) REFERENCES CORE_GROUP(ID));

CREATE UNIQUE INDEX DX_GRP_MEMBER ON CORE_GROUP_MEMBER(USER_ID, GROUP_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('4', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 4, '8:8ed24313055b9c1061e6598f1ecfb40d', 'createTable tableName=CORE_GROUP_MEMBER; createIndex indexName=DX_GRP_MEMBER, tableName=CORE_GROUP_MEMBER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::5::gfouquet
INSERT INTO CORE_GROUP (QUALIFIED_NAME) VALUES ('squashtest.authz.group.core.Admin');

INSERT INTO CORE_GROUP_AUTHORITY (GROUP_ID, AUTHORITY) VALUES ((select max(ID) from CORE_GROUP), 'ROLE_ADMIN');

INSERT INTO CORE_GROUP_AUTHORITY (GROUP_ID, AUTHORITY) VALUES ((select max(ID) from CORE_GROUP), 'ROLE_USER');

INSERT INTO CORE_USER (LOGIN, LAST_NAME, EMAIL, CREATED_ON, CREATED_BY) VALUES ('admin', 'Squash Administrator', 'admin@squashtest.org', NOW(), 'liquibase');

INSERT INTO CORE_GROUP_MEMBER (USER_ID, GROUP_ID) VALUES ((select max(ID) from CORE_USER), (select max(ID) from CORE_GROUP));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('5', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 5, '8:498253d8a7b4423f27ab556d6b567e1d', 'insert tableName=CORE_GROUP; insert tableName=CORE_GROUP_AUTHORITY; insert tableName=CORE_GROUP_AUTHORITY; insert tableName=CORE_USER; insert tableName=CORE_GROUP_MEMBER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::7::gfouquet
CREATE TABLE ACL_CLASS (ID BIGINT AUTO_INCREMENT NOT NULL, CLASSNAME VARCHAR(255) NOT NULL COMMENT 'Fully qualified classname', CONSTRAINT PK_ACL_CLASS PRIMARY KEY (ID), CONSTRAINT CT_UN_CLASSNAME UNIQUE (CLASSNAME));

CREATE UNIQUE INDEX DX_CLASS_NAME ON ACL_CLASS(CLASSNAME);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('7', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 6, '8:17b7a3610b14cac414514bd80adfbe60', 'createTable tableName=ACL_CLASS; createIndex indexName=DX_CLASS_NAME, tableName=ACL_CLASS', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::8::gfouquet
CREATE TABLE ACL_OBJECT_IDENTITY (ID BIGINT AUTO_INCREMENT NOT NULL, IDENTITY BIGINT NOT NULL COMMENT 'The id of the target entity', CLASS_ID BIGINT NOT NULL, CONSTRAINT PK_ACL_OBJECT_ID PRIMARY KEY (ID), CONSTRAINT FK_ACL_OBJ_ID_ACL_CLASS FOREIGN KEY (CLASS_ID) REFERENCES ACL_CLASS(ID));

ALTER TABLE ACL_OBJECT_IDENTITY ADD UNIQUE (IDENTITY, CLASS_ID);

CREATE INDEX DX_OBJ_ID_IDENTITY ON ACL_OBJECT_IDENTITY(IDENTITY);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('8', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 7, '8:6430e03210e17fc411d599f1c44ed253', 'createTable tableName=ACL_OBJECT_IDENTITY; addUniqueConstraint tableName=ACL_OBJECT_IDENTITY; createIndex indexName=DX_OBJ_ID_IDENTITY, tableName=ACL_OBJECT_IDENTITY', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::9::gfouquet
CREATE TABLE ACL_GROUP (ID BIGINT AUTO_INCREMENT NOT NULL, QUALIFIED_NAME VARCHAR(255) NOT NULL COMMENT 'Group''s qualified name, both used as a functional key and a localization key. Should be something like ''squashtest.acl.group._app module_._GroupName_''', CONSTRAINT PK_ACL_GRP PRIMARY KEY (ID), CONSTRAINT CT_UN_ACL_GRP_QUAL_NAME UNIQUE (QUALIFIED_NAME));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('9', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 8, '8:484cb95f2ebb0b80cbc9e84a82326b71', 'createTable tableName=ACL_GROUP', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::10::gfouquet
CREATE TABLE ACL_GROUP_PERMISSION (ACL_GROUP_ID BIGINT NOT NULL, PERMISSION_MASK INT DEFAULT 0 NOT NULL COMMENT 'Mask of permissions as defined by spring security', CLASS_ID BIGINT NOT NULL COMMENT 'The class to which the permissions apply', PERMISSION_ORDER INT DEFAULT 0 NOT NULL, GRANTING BIT(1) DEFAULT 1 NOT NULL, CONSTRAINT FK_SC_AUTH_ACL_CLASS FOREIGN KEY (CLASS_ID) REFERENCES ACL_CLASS(ID), CONSTRAINT FK_ACL_GRP_PERMISSION_ACL_GRP FOREIGN KEY (ACL_GROUP_ID) REFERENCES ACL_GROUP(ID));

ALTER TABLE ACL_GROUP_PERMISSION ADD PRIMARY KEY (ACL_GROUP_ID, CLASS_ID, PERMISSION_MASK);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('10', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 9, '8:b20818cdcce60e485ac93f35dff82fa6', 'createTable tableName=ACL_GROUP_PERMISSION; addPrimaryKey constraintName=PK_ACL_GRP_PERMISSION, tableName=ACL_GROUP_PERMISSION', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../core/core.changelog-0.15.0.xml::11::gfouquet
CREATE TABLE ACL_RESPONSIBILITY_SCOPE_ENTRY (ID BIGINT AUTO_INCREMENT NOT NULL, USER_ID BIGINT NOT NULL, ACL_GROUP_ID BIGINT NOT NULL, OBJECT_IDENTITY_ID BIGINT NOT NULL, CONSTRAINT PK_RESP_SCOPE_ENTRY PRIMARY KEY (ID), CONSTRAINT FK_RESP_SCOPE_ACL_GRP FOREIGN KEY (ACL_GROUP_ID) REFERENCES ACL_GROUP(ID), CONSTRAINT FK_RESP_SCOPE_OBJ_ID FOREIGN KEY (OBJECT_IDENTITY_ID) REFERENCES ACL_OBJECT_IDENTITY(ID), CONSTRAINT FK_RESP_SCOPE_USER FOREIGN KEY (USER_ID) REFERENCES CORE_USER(ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('11', 'gfouquet', '../core/core.changelog-0.15.0.xml', NOW(), 10, '8:72cc4523a501dbbe41a564861b9f781d', 'createTable tableName=ACL_RESPONSIBILITY_SCOPE_ENTRY', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.01::bsiri
--  This table maintains the mapping between an issue in Squash and an
--  			issue in the remote bugtracker
CREATE TABLE ISSUE (ISSUE_ID BIGINT AUTO_INCREMENT NOT NULL, REMOTE_ISSUE_ID VARCHAR(255) NOT NULL COMMENT 'considering the different types    a bugtracker may use for its own primary keys, we use here a varchar type as it is generic enough', CONSTRAINT PK_ISSUE PRIMARY KEY (ISSUE_ID));

CREATE INDEX idx_issue ON ISSUE(ISSUE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.01', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 11, '8:5d3b93c579ca3e2716f45d1e1860fb7f', 'createTable tableName=ISSUE; createIndex indexName=idx_issue, tableName=ISSUE', 'This table maintains the mapping between an issue in Squash and an
			issue in the remote bugtracker', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.02::bsiri
--  each Squash entity that may be attached to one or several bugs will be given an issue list. This table will maintain that list, an entry means that some entity refering to it have several.
CREATE TABLE ISSUE_LIST (ISSUE_LIST_ID BIGINT AUTO_INCREMENT NOT NULL, CONSTRAINT PK_ISSUE_LIST PRIMARY KEY (ISSUE_LIST_ID));

CREATE INDEX idx_issue_list ON ISSUE_LIST(ISSUE_LIST_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.02', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 12, '8:3ab8c4e40f4a554ed9bb8aec931e9f8e', 'createTable tableName=ISSUE_LIST; createIndex indexName=idx_issue_list, tableName=ISSUE_LIST', 'each Squash entity that may be attached to one or several bugs will be given an issue list. This table will maintain that list, an entry means that some entity refering to it have several.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.03::bsiri
--  This table will map one issue_list to (0,several) issues
CREATE TABLE ISSUE_LIST_CONTENT (ISSUE_LIST_ID BIGINT NOT NULL COMMENT 'fk to the issue list', ISSUE_ID BIGINT NOT NULL COMMENT 'fk to an issue', CONSTRAINT fk_list_issue_list FOREIGN KEY (ISSUE_LIST_ID) REFERENCES ISSUE_LIST(ISSUE_LIST_ID), CONSTRAINT fk_list_issue_issue FOREIGN KEY (ISSUE_ID) REFERENCES ISSUE(ISSUE_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.03', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 13, '8:2020ecc2a7f9697b1bcbcdc950764a11', 'createTable tableName=ISSUE_LIST_CONTENT', 'This table will map one issue_list to (0,several) issues', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.04::bsiri
--  Cette table contient le contenu d'une pièce jointe, dont les meta infos sont stockees dans la
--  			table ATTACHMENT. La relation entre les deux tables est 1-1
CREATE TABLE ATTACHMENT_CONTENT (ATTACHMENT_CONTENT_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'clé primaire du contenu de la piece jointe. Devrait être autogénérée.', STREAM_CONTENT BLOB DEFAULT 'NULL' NULL COMMENT 'Le contenu de la piece jointe.', CONSTRAINT PK_ATTACHMENT_CONTENT PRIMARY KEY (ATTACHMENT_CONTENT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.04', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 14, '8:7d216543a6e43252c9d9a6c7f39f4b2b', 'createTable tableName=ATTACHMENT_CONTENT', 'Cette table contient le contenu d''une pièce jointe, dont les meta infos sont stockees dans la
			table ATTACHMENT. La relation entre les deux tables est 1-1', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.05::bsiri
--  Cette table stockera les pieces jointes. La piece elle même est un blob stocke a part dans
--  					la table ATTACHMENT_CONTENT. La relation entre les deux tables est 1-1
CREATE TABLE ATTACHMENT (ATTACHMENT_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'clé primaire de la piece jointe. Devrait être autogénérée.', NAME VARCHAR(255) NOT NULL COMMENT 'nom de la piece jointe', TYPE VARCHAR(10) NOT NULL COMMENT 'type de la piece jointe. Cette information pourrait etre trivialement deduite du nom de fichier', SIZE BIGINT NOT NULL COMMENT 'taille de la piece jointe en octet. Cette information est déterminée au moment de l''upload et doit etre fournie a la base     dès sa création', ADDED_ON datetime NOT NULL COMMENT 'Date de l''ajout de la piece jointe.', CONTENT_ID BIGINT NULL COMMENT 'cle etrangere vers la table ATTACHMENT_CONTENT', CONSTRAINT PK_ATTACHMENT PRIMARY KEY (ATTACHMENT_ID), CONSTRAINT fk_attachment_content FOREIGN KEY (CONTENT_ID) REFERENCES ATTACHMENT_CONTENT(ATTACHMENT_CONTENT_ID));

CREATE INDEX idx_attachment ON ATTACHMENT(ATTACHMENT_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.05', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 15, '8:4f375dd25e0120e0392f4869f59e92d1', 'createTable tableName=ATTACHMENT; createIndex indexName=idx_attachment, tableName=ATTACHMENT', 'Cette table stockera les pieces jointes. La piece elle même est un blob stocke a part dans
					la table ATTACHMENT_CONTENT. La relation entre les deux tables est 1-1', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.06::bsiri
--  Cette table matérialise une liste d'ATTACHMENT. Bien qu'elle ne contienne que sa clé primaire, sa raison d'exister est, au niveau de l'application, de fournir une entité indépendante des entités métier auquel on rajoute les pièces jointes.
CREATE TABLE ATTACHMENT_LIST (ATTACHMENT_LIST_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'clé primaire, devrait être autogénérée.', CONSTRAINT PK_ATTACHMENT_LIST PRIMARY KEY (ATTACHMENT_LIST_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.06', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 16, '8:5e04a2b804609a1feae02e24bd6a1500', 'createTable tableName=ATTACHMENT_LIST', 'Cette table matérialise une liste d''ATTACHMENT. Bien qu''elle ne contienne que sa clé primaire, sa raison d''exister est, au niveau de l''application, de fournir une entité indépendante des entités métier auquel on rajoute les pièces jointes.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.07::bsiri
--  Table d'association entre un cas de test et ses pieces jointes
CREATE TABLE ATTACHMENT_LIST_CONTENT (AL_ID BIGINT NOT NULL COMMENT 'clé étrangère vers ATTACHMENT_LIST.', ATTACHMENT_ID BIGINT NOT NULL COMMENT 'clé étrangère vers la table ATTACHMENT', CONSTRAINT fk_list_attachment_attachment FOREIGN KEY (ATTACHMENT_ID) REFERENCES ATTACHMENT(ATTACHMENT_ID), CONSTRAINT fk_list_attachment_list FOREIGN KEY (AL_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.07', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 17, '8:ecc4ab3f7d2a383d967c43687264b78b', 'createTable tableName=ATTACHMENT_LIST_CONTENT', 'Table d''association entre un cas de test et ses pieces jointes', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.08::ramoussou
--  Table representant les projets englobants les libraries d'entite que nous utilisons.
CREATE TABLE PROJECT (PROJECT_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'cle primaire de la table', NAME VARCHAR(255) NOT NULL COMMENT 'nom du projet', `DESCRIPTION` LONGTEXT NULL COMMENT 'description du projet', LABEL VARCHAR(255) NULL COMMENT 'Label du projet', ACTIVE BIT(1) DEFAULT 1 NOT NULL COMMENT 'si le projet est actif ou non', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'nom du createur du projet.', CREATED_ON datetime NOT NULL COMMENT 'Date de creation de ce projet. Il s''agit de la date de creation de l''entree dans la base, non d''une date metier.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis a jour cet instance.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere mise a jour de cette instance.', CL_ID BIGINT NULL COMMENT 'cle etrangere de la table campaign-Library', TCL_ID BIGINT NULL COMMENT 'cle etrangere de la table TESTCASE-Library', RL_ID BIGINT NULL COMMENT 'cle etrangere de la table REQUIREMENT-Library', CONSTRAINT PK_PROJECT PRIMARY KEY (PROJECT_ID));

CREATE INDEX idx_project ON PROJECT(PROJECT_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.08', 'ramoussou', '../tm/tm.changelog-0.15.0.xml', NOW(), 18, '8:a8b05b7b8080db15350f486b617a659c', 'createTable tableName=PROJECT; createIndex indexName=idx_project, tableName=PROJECT', 'Table representant les projets englobants les libraries d''entite que nous utilisons.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.09::bsiri
--  Cette table gere les bibliotheques de cas de test. Une bibliotheque de cas de test peut contenir plusieurs
--  		repertoires et/ou cas de test, ces deux entites etant regroupees sous l'appellation generique d'element de bibliotheque
--  		de cas de test (test case library nodes).
CREATE TABLE TEST_CASE_LIBRARY (TCL_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'cle primaire autogeneree', PROJECT_ID BIGINT NULL COMMENT 'cle etrangere de la table Project', CONSTRAINT PK_TEST_CASE_LIBRARY PRIMARY KEY (TCL_ID), CONSTRAINT fk_tcl_project FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

CREATE INDEX idx_test_case_library ON TEST_CASE_LIBRARY(TCL_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.09', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 19, '8:fd1c7bb9ed332c714dd2b5010e0b12c4', 'createTable tableName=TEST_CASE_LIBRARY; createIndex indexName=idx_test_case_library, tableName=TEST_CASE_LIBRARY', 'Cette table gere les bibliotheques de cas de test. Une bibliotheque de cas de test peut contenir plusieurs
		repertoires et/ou cas de test, ces deux entites etant regroupees sous l''appellation generique d''element de bibliotheque
		de cas de test (...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.10::bsiri
--  Cette table gere les bibliotheques d'exigences. Une bibliotheque d'exigences peut contenir plusieurs repertoires
--  				et/ou exigences, ces deux entites etant regroupees sous l'appellation generique d'element de bibliotheque d'exigences (requirement
--  				library nodes).
CREATE TABLE REQUIREMENT_LIBRARY (RL_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'cle primaire autogeneree', PROJECT_ID BIGINT NULL COMMENT 'cle etrangere de la table Project', CONSTRAINT PK_REQUIREMENT_LIBRARY PRIMARY KEY (RL_ID), CONSTRAINT fk_rl_project FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

CREATE INDEX idx_requirement_library ON REQUIREMENT_LIBRARY(RL_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.10', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 20, '8:016e5344da49c0996032a6e8906d01c6', 'createTable tableName=REQUIREMENT_LIBRARY; createIndex indexName=idx_requirement_library, tableName=REQUIREMENT_LIBRARY', 'Cette table gere les bibliotheques d''exigences. Une bibliotheque d''exigences peut contenir plusieurs repertoires
				et/ou exigences, ces deux entites etant regroupees sous l''appellation generique d''element de bibliotheque d''exigences (requirement...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.11::bsiri
--  Cette table gere les bibliotheques de campagnes. Une bibliotheque
--  		de campagnes peut contenir plusieurs repertoires et/ou campagnes, ces deux
--  		entites etant regroupees sous l'appellation generique d'element de bibliotheque
--  		de campagnes (campaign library nodes).
CREATE TABLE CAMPAIGN_LIBRARY (CL_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'cle primaire autogeneree', PROJECT_ID BIGINT NULL COMMENT 'cle etrangere de la table Project', CONSTRAINT PK_CAMPAIGN_LIBRARY PRIMARY KEY (CL_ID), CONSTRAINT fk_cl_project FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

CREATE INDEX idx_campaign_library ON CAMPAIGN_LIBRARY(CL_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.11', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 21, '8:d7c016fa07a3268e2c27c88b7e975a26', 'createTable tableName=CAMPAIGN_LIBRARY; createIndex indexName=idx_campaign_library, tableName=CAMPAIGN_LIBRARY', 'Cette table gere les bibliotheques de campagnes. Une bibliotheque
		de campagnes peut contenir plusieurs repertoires et/ou campagnes, ces deux
		entites etant regroupees sous l''appellation generique d''element de bibliotheque
		de campagnes (campai...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.12::ramoussou
ALTER TABLE PROJECT ADD CONSTRAINT fk_project_cl FOREIGN KEY (CL_ID) REFERENCES CAMPAIGN_LIBRARY (CL_ID);

ALTER TABLE PROJECT ADD CONSTRAINT fk_project_tcl FOREIGN KEY (TCL_ID) REFERENCES TEST_CASE_LIBRARY (TCL_ID);

ALTER TABLE PROJECT ADD CONSTRAINT fk_project_rl FOREIGN KEY (RL_ID) REFERENCES REQUIREMENT_LIBRARY (RL_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.12', 'ramoussou', '../tm/tm.changelog-0.15.0.xml', NOW(), 22, '8:36341a758e071e22a1ab1b8988c9f4a2', 'addForeignKeyConstraint baseTableName=PROJECT, constraintName=fk_project_cl, referencedTableName=CAMPAIGN_LIBRARY; addForeignKeyConstraint baseTableName=PROJECT, constraintName=fk_project_tcl, referencedTableName=TEST_CASE_LIBRARY; addForeignKeyCo...', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.13::bsiri
--  Cette table represente un element (generique) faisant partie d'une bibliotheque de cas de test. Cet element
--  		generique peut representer soit un repertoire, soit un cas de test. Pour cette raison, que l'utilisateur cree l'un ou
--  		l'autre cette table sera necessairement alimentee, et contiendra la cle primaire de l'element en question.
--  		Toutefois le type reel de l'element cas de test ou repertoire) n'est pas renseigne, il est necessaire de rechercher
--  		si la cle est referencee dans la table TEST_CASE_FOLDER ou TEST_CASE pour determiner si cet element releve de l'un ou l'autre.
CREATE TABLE TEST_CASE_LIBRARY_NODE (TCLN_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'cle primaire autogeneree.', DELETED_ON datetime DEFAULT null NULL COMMENT 'drapeau indiquant si l''element est actif (NULL) ou logiquement supprime (not NULL).', `DESCRIPTION` LONGTEXT DEFAULT null NULL COMMENT 'Une description associee a cet element. Devrait etre un champ texte long ou un clob.', NAME VARCHAR(255) NOT NULL COMMENT 'Le nom/label de l''element en question.', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'nom du createur de ce cas de test.', CREATED_ON datetime NOT NULL COMMENT 'Date de creation de ce cas de test. Il s''agit de la date de creation de l''entree dans la base, non d''une date metier.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis a jour cet instance.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere mise a jour de cette instance.', PROJECT_ID BIGINT NULL COMMENT 'FK to the Project to which belongs this resource', CONSTRAINT PK_TEST_CASE_LIBRARY_NODE PRIMARY KEY (TCLN_ID), CONSTRAINT fk_tcln_project FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.13', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 23, '8:e79b3efcef7b253333fd8bfab54ba5bf', 'createTable tableName=TEST_CASE_LIBRARY_NODE', 'Cette table represente un element (generique) faisant partie d''une bibliotheque de cas de test. Cet element
		generique peut representer soit un repertoire, soit un cas de test. Pour cette raison, que l''utilisateur cree l''un ou
		l''autre cette tab...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.14::bsiri
--  Cette table represente un element (generique) faisant partie d'une bibliotheque d'exigences. Cet element
--  				generique peut representer soit un repertoire, soit une exigence. Pour cette raison, que l'utilisateur cree l'un ou l'autre
--  				cette table sera necessairement alimentee, et contiendra la cle primaire de l'element en question. Toutefois le type reel
--  				de l'element (exigence ou repertoire) n'est pas renseigne, il est necessaire de rechercher si la cle est referencee dans
--  				la table REQUIREMENT_FOLDER ou REQUIREMENT pour determiner si cet element releve de l'un ou l'autre.
CREATE TABLE REQUIREMENT_LIBRARY_NODE (RLN_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'cle primaire autogeneree', DELETED_ON datetime DEFAULT null NULL COMMENT 'drapeau indiquant si l''element est actif (NULL) ou logiquement supprime (not NULL).', `DESCRIPTION` LONGTEXT DEFAULT null NULL COMMENT 'Une description associee a cet element. Devrait etre un champ texte long ou un clob.', NAME VARCHAR(255) NOT NULL COMMENT 'Le nom/label de l''element en question.', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'nom du createur de ce cas de test.', CREATED_ON datetime NOT NULL COMMENT 'Date de creation de cette exigence. Il s''agit de la date de creation de l''entree dans la base, non d''une date metier.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis a jour cet instance.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere mise a jour de cette instance.', PROJECT_ID BIGINT NULL COMMENT 'FK to the Project to which belongs this resource', CONSTRAINT PK_REQUIREMENT_LIBRARY_NODE PRIMARY KEY (RLN_ID), CONSTRAINT fk_rln_project FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.14', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 24, '8:40263cfeea6dcd999fb700b91afd9196', 'createTable tableName=REQUIREMENT_LIBRARY_NODE', 'Cette table represente un element (generique) faisant partie d''une bibliotheque d''exigences. Cet element
				generique peut representer soit un repertoire, soit une exigence. Pour cette raison, que l''utilisateur cree l''un ou l''autre
				cette tabl...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.15::bsiri
--  Cette table represente un element (generique) faisant partie
--  				d'une bibliotheque de campagne. Cet element generique peut representer soit
--  				un repertoire, soit une campagne. Pour cette raison, que l'utilisateur cree
--  				l'un ou l'autre cette table sera necessairement alimentee, et contiendra
--  				la cle primaire de l'element en question. Toutefois le type reel de l'element
--  				(campagne ou repertoire) n'est pas renseigne, il est necessaire de rechercher
--  				si la cle est referencee dans la table CAMPAIGN_FOLDER ou CAMPAIGN pour determiner
--  				si cet element releve de l'un ou l'autre.
CREATE TABLE CAMPAIGN_LIBRARY_NODE (CLN_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'cle primaire autogeneree', DELETED_ON datetime DEFAULT null NULL COMMENT 'drapeau indiquant si l''element est actif (NULL) ou logiquement supprime (not NULL).', `DESCRIPTION` LONGTEXT DEFAULT null NULL COMMENT 'Une description associee a cet element. Devrait etre un champ texte long ou un clob.', NAME VARCHAR(255) NOT NULL COMMENT 'Le nom/label de l''element en question.', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'nom du createur de cette campagne.', CREATED_ON datetime NOT NULL COMMENT 'Date de creation de cette campagne. Il s''agit de la date de creation de l''entree dans    la base, non d''une date metier.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere mise a jour de cette instance.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis a jour cet instance.', PROJECT_ID BIGINT DEFAULT null NULL COMMENT 'FK to the Project to which belongs this resource', CONSTRAINT PK_CAMPAIGN_LIBRARY_NODE PRIMARY KEY (CLN_ID), CONSTRAINT fk_cln_project FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.15', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 25, '8:8bdf4f59505a4bdecf8b5e030079cd27', 'createTable tableName=CAMPAIGN_LIBRARY_NODE', 'Cette table represente un element (generique) faisant partie
				d''une bibliotheque de campagne. Cet element generique peut representer soit
				un repertoire, soit une campagne. Pour cette raison, que l''utilisateur cree
				l''un ou l''autre cette ...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.16::bsiri
--  Cette table gere les cas de test proprement dits. Une entree dans cette table indique que l'element reference dans la table TEST_CASE_LIBRARY_NODE par la cle primaire (egalement cle etrangere) est de type cas de test.
CREATE TABLE TEST_CASE (TCLN_ID BIGINT NOT NULL COMMENT 'cle primaire, qui est aussi une cle etrangere vers la table TEST_CASE_LIBRARY_NODE. Ne doit donc pas etre autogeneree.', VERSION INT NOT NULL COMMENT 'Le numero de version de ce cas de test', EXECUTION_MODE VARCHAR(255) DEFAULT null NULL COMMENT 'Mode d''execution du test case. Bien que ce champs soit caractere variable, les donnees reelles seront la representation texte d''un type enumere.', ATTACHMENT_LIST_ID BIGINT NOT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes. ', CONSTRAINT PK_TEST_CASSE PRIMARY KEY (TCLN_ID), CONSTRAINT fk_test_case_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID), CONSTRAINT fk_test_case_test_case_node FOREIGN KEY (TCLN_ID) REFERENCES TEST_CASE_LIBRARY_NODE(TCLN_ID));

CREATE INDEX idx_test_case ON TEST_CASE(TCLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.16', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 26, '8:4abfcdf848e74b00431338408a53f696', 'createTable tableName=TEST_CASE; createIndex indexName=idx_test_case, tableName=TEST_CASE', 'Cette table gere les cas de test proprement dits. Une entree dans cette table indique que l''element reference dans la table TEST_CASE_LIBRARY_NODE par la cle primaire (egalement cle etrangere) est de type cas de test.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.17::bsiri
--  Cette table est rudimentaire. La cle primaire est simplement une cle etrangere vers la table TEST_CASE_LIBRARY_NODE (relation qualifiante).
--  		Une entree dans cette table indique que l'element indexe par cette cle est de type repertoire.
CREATE TABLE TEST_CASE_FOLDER (TCLN_ID BIGINT NOT NULL COMMENT 'cle primaire, qui est une cle etrangere vers la table CAMPAIGN_LIBRARY_NODE. Ne doit donc pas etre autogeneree.', CONSTRAINT PK_TEST_CASE_FOLDER PRIMARY KEY (TCLN_ID), CONSTRAINT fk_folder_test_case_node FOREIGN KEY (TCLN_ID) REFERENCES TEST_CASE_LIBRARY_NODE(TCLN_ID));

CREATE INDEX idx_tc_folder ON TEST_CASE_FOLDER(TCLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.17', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 27, '8:f23e095ddd7fb06a8ed0d7e8c38eb496', 'createTable tableName=TEST_CASE_FOLDER; createIndex indexName=idx_tc_folder, tableName=TEST_CASE_FOLDER', 'Cette table est rudimentaire. La cle primaire est simplement une cle etrangere vers la table TEST_CASE_LIBRARY_NODE (relation qualifiante).
		Une entree dans cette table indique que l''element indexe par cette cle est de type repertoire.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.18::bsiri
--  Cette table associe les bibliotheques de cas de test a leur contenu (elements de bibliotheques de cas de test).
--  		Le contenu d'une bibliotheque de cas de test est arborescent et est represente suivant un patron composite
--  		(voire TEST_CASE_LIBRARY_NODE, TEST_CASE_FOLDER, TEST_CASE). Par defaut la presente table peut contenir uniquement
--  		les references vers les elements fils directs; on peut aussi mettre en relation une bibliotheque de cas de test avec
--  		n'importe quel element de son contenu (quelque soit sa profondeur hierarchique) pour des raisons d'optimisation.
CREATE TABLE TEST_CASE_LIBRARY_CONTENT (LIBRARY_ID BIGINT NOT NULL COMMENT 'cle etrangere vers une bibliotheque de cas de test.', CONTENT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers un noeud de la bibliotheque de cas de test.', CONSTRAINT fk_test_case_lib_content_content FOREIGN KEY (CONTENT_ID) REFERENCES TEST_CASE_LIBRARY_NODE(TCLN_ID), CONSTRAINT fk_test_case_lib_content_lib FOREIGN KEY (LIBRARY_ID) REFERENCES TEST_CASE_LIBRARY(TCL_ID), UNIQUE (CONTENT_ID));

CREATE INDEX idx_test_case_lib_content_content ON TEST_CASE_LIBRARY_CONTENT(CONTENT_ID);

CREATE INDEX idx_test_case_lib_content_lib ON TEST_CASE_LIBRARY_CONTENT(LIBRARY_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.18', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 28, '8:84a56cc824a8768759d99b80cd666d1e', 'createTable tableName=TEST_CASE_LIBRARY_CONTENT; createIndex indexName=idx_test_case_lib_content_content, tableName=TEST_CASE_LIBRARY_CONTENT; createIndex indexName=idx_test_case_lib_content_lib, tableName=TEST_CASE_LIBRARY_CONTENT', 'Cette table associe les bibliotheques de cas de test a leur contenu (elements de bibliotheques de cas de test).
		Le contenu d''une bibliotheque de cas de test est arborescent et est represente suivant un patron composite
		(voire TEST_CASE_LIBRARY...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.19::bsiri
--  Cette table gere la hierarchie entre elements d'une bibliotheque de cas de test, associant un element fils a
--  		un repertoire parent (si non NULL) ou eventuellement aucun (NULL, dans le cas ou l'element est a la racine de la bibliotheque
--  		de cas de test).
CREATE TABLE TCLN_RELATIONSHIP (ANCESTOR_ID BIGINT NOT NULL COMMENT 'cle etrangere vers le repertoire parent (il s''agit necessairement d''un repertoire).', DESCENDANT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers l''element fils. ', CONSTRAINT fk_tcln_relationship_ancestor FOREIGN KEY (ANCESTOR_ID) REFERENCES TEST_CASE_FOLDER(TCLN_ID), CONSTRAINT fk_tcln_relationship_descendant FOREIGN KEY (DESCENDANT_ID) REFERENCES TEST_CASE_LIBRARY_NODE(TCLN_ID), UNIQUE (DESCENDANT_ID));

CREATE INDEX idx_tcln_relationship_descendant ON TCLN_RELATIONSHIP(DESCENDANT_ID);

CREATE INDEX idx_tcln_relationship_ancestor ON TCLN_RELATIONSHIP(ANCESTOR_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.19', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 29, '8:3148598af5a9a91deeed6281bb250afa', 'createTable tableName=TCLN_RELATIONSHIP; createIndex indexName=idx_tcln_relationship_descendant, tableName=TCLN_RELATIONSHIP; createIndex indexName=idx_tcln_relationship_ancestor, tableName=TCLN_RELATIONSHIP', 'Cette table gere la hierarchie entre elements d''une bibliotheque de cas de test, associant un element fils a
		un repertoire parent (si non NULL) ou eventuellement aucun (NULL, dans le cas ou l''element est a la racine de la bibliotheque
		de cas d...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.20::bsiri
--  Cette table gere les campagnes proprement dites. Une entree
--  				dans cette table indique que l'element reference dans la table CAMPAIGN_LIBRARY_NODE
--  				par la cle primaire (egalement cle etrangere) est de type campagne.
CREATE TABLE CAMPAIGN (CLN_ID BIGINT NOT NULL, ACTUAL_END_AUTO BIT(1) NOT NULL COMMENT 'Drapeau indiquant si l''utilisateur a choisit une determination automatique de la date de depart effective ou non.', ACTUAL_END_DATE datetime DEFAULT null NULL COMMENT 'Date de fin effective (reelle) de la campagne.', ACTUAL_START_AUTO BIT(1) NOT NULL COMMENT 'Drapeau indiquant si l''utilisateur a choisit une determination automatique de la date de fin effective ou non.', ACTUAL_START_DATE datetime DEFAULT null NULL COMMENT 'Date de depar effective (reelle) de la campagne.', SCHEDULED_END_DATE datetime DEFAULT null NULL COMMENT 'Date planifiee de fin de la campagne.', SCHEDULED_START_DATE datetime DEFAULT null NULL COMMENT 'Date planifiee de debut de la campagne.', ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes. ', CONSTRAINT PK_CAMPAIGN PRIMARY KEY (CLN_ID), CONSTRAINT FK_CAMPAIGN_CL_NODE FOREIGN KEY (CLN_ID) REFERENCES CAMPAIGN_LIBRARY_NODE(CLN_ID), CONSTRAINT fk_campaign_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.20', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 30, '8:1e3cbed34f0726277e26243cda1bacdd', 'createTable tableName=CAMPAIGN', 'Cette table gere les campagnes proprement dites. Une entree
				dans cette table indique que l''element reference dans la table CAMPAIGN_LIBRARY_NODE
				par la cle primaire (egalement cle etrangere) est de type campagne.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.21::bsiri
--  Cette table est rudimentaire. La cle primaire est simplement
--  				une cle etrangere vers la table CAMPAIGN_LIBRARY_NODE (relation qualifiante).
--  				Une entree dans cette table indique que l'element indexe par cette cle est
--  				de type repertoire.
CREATE TABLE CAMPAIGN_FOLDER (CLN_ID BIGINT NOT NULL COMMENT 'cle primaire, qui est une cle etrangere vers la table CAMPAIGN_LIBRARY_NODE. Ne doit donc pas etre autogeneree.', CONSTRAINT PK_CAMPAIGN_FOLDER PRIMARY KEY (CLN_ID), CONSTRAINT FK_CAMPAIGN_FOLDER_CL_NODE FOREIGN KEY (CLN_ID) REFERENCES CAMPAIGN_LIBRARY_NODE(CLN_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.21', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 31, '8:08391f23434a77a19409938d033a4840', 'createTable tableName=CAMPAIGN_FOLDER', 'Cette table est rudimentaire. La cle primaire est simplement
				une cle etrangere vers la table CAMPAIGN_LIBRARY_NODE (relation qualifiante).
				Une entree dans cette table indique que l''element indexe par cette cle est
				de type repertoire.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.22::bsiri
--  Cette table gere les bibliotheques de campagnes. Une bibliotheque
--  				de campagnes peut contenir plusieurs repertoires et/ou campagnes, ces deux
--  				entites etant regroupees sous l'appellation generique d'element de bibliotheque
--  				de campagnes (campaign library nodes).
CREATE TABLE CAMPAIGN_LIBRARY_CONTENT (LIBRARY_ID BIGINT NOT NULL COMMENT 'cle etrangere vers une bibliotheque de campagnes.', CONTENT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers un noeud de la bibliotheque de campagnes.', CONSTRAINT fk_cl_content_lib FOREIGN KEY (LIBRARY_ID) REFERENCES CAMPAIGN_LIBRARY(CL_ID), CONSTRAINT fk_cl_content_content FOREIGN KEY (CONTENT_ID) REFERENCES CAMPAIGN_LIBRARY_NODE(CLN_ID), UNIQUE (CONTENT_ID));

CREATE UNIQUE INDEX dx_cl_content_cl_node ON CAMPAIGN_LIBRARY_CONTENT(CONTENT_ID);

CREATE INDEX dx_cl_content_campaign_lib ON CAMPAIGN_LIBRARY_CONTENT(LIBRARY_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.22', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 32, '8:f9f47b93e7c62712769f4e658b49ba0d', 'createTable tableName=CAMPAIGN_LIBRARY_CONTENT; createIndex indexName=dx_cl_content_cl_node, tableName=CAMPAIGN_LIBRARY_CONTENT; createIndex indexName=dx_cl_content_campaign_lib, tableName=CAMPAIGN_LIBRARY_CONTENT', 'Cette table gere les bibliotheques de campagnes. Une bibliotheque
				de campagnes peut contenir plusieurs repertoires et/ou campagnes, ces deux
				entites etant regroupees sous l''appellation generique d''element de bibliotheque
				de campagnes (...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.23::bsiri
--  Cette table gere la hierarchie entre elements d'une bibliotheque
--  				de campagne, associant un element fils a un repertoire parent (si non NULL)
--  				ou eventuellement aucun (NULL, dans le cas ou l'element est a la racine de
--  				la bibliotheque de campagne).
CREATE TABLE CLN_RELATIONSHIP (ANCESTOR_ID BIGINT NOT NULL COMMENT 'cle etrangere vers le repertoire parent (il s''agit necessairement d''un repertoire).', DESCENDANT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers l''element fils.', CONSTRAINT idx_cln_relationship_descendant FOREIGN KEY (DESCENDANT_ID) REFERENCES CAMPAIGN_LIBRARY_NODE(CLN_ID), CONSTRAINT fk_cln_relationship_ancestor FOREIGN KEY (ANCESTOR_ID) REFERENCES CAMPAIGN_FOLDER(CLN_ID), UNIQUE (DESCENDANT_ID));

CREATE INDEX dx_cln_relationship_descendant ON CLN_RELATIONSHIP(DESCENDANT_ID);

CREATE INDEX dx_cln_relationship_ancestor ON CLN_RELATIONSHIP(ANCESTOR_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.23', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 33, '8:610f40da3f5d51f9c509df03a469cf89', 'createTable tableName=CLN_RELATIONSHIP; createIndex indexName=dx_cln_relationship_descendant, tableName=CLN_RELATIONSHIP; createIndex indexName=dx_cln_relationship_ancestor, tableName=CLN_RELATIONSHIP', 'Cette table gere la hierarchie entre elements d''une bibliotheque
				de campagne, associant un element fils a un repertoire parent (si non NULL)
				ou eventuellement aucun (NULL, dans le cas ou l''element est a la racine de
				la bibliotheque de ...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.24::bsiri
CREATE TABLE ITERATION (ITERATION_ID BIGINT AUTO_INCREMENT NOT NULL, DELETED_ON datetime DEFAULT null NULL, `DESCRIPTION` LONGTEXT DEFAULT null NULL, NAME VARCHAR(255) NOT NULL, CREATED_BY VARCHAR(50) NOT NULL, CREATED_ON datetime NOT NULL, LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL, LAST_MODIFIED_ON datetime DEFAULT null NULL, ACTUAL_END_AUTO BIT(1) NOT NULL, ACTUAL_END_DATE datetime DEFAULT null NULL, ACTUAL_START_AUTO BIT(1) NOT NULL, ACTUAL_START_DATE datetime DEFAULT null NULL, SCHEDULED_END_DATE datetime DEFAULT null NULL, SCHEDULED_START_DATE datetime DEFAULT null NULL, ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes. ', CONSTRAINT PK_ITERATION PRIMARY KEY (ITERATION_ID), CONSTRAINT fk_iteration__attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.24', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 34, '8:df334bc9e9238ad2869a538b20e056a7', 'createTable tableName=ITERATION', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.25::bsiri
CREATE TABLE CAMPAIGN_ITERATION (CAMPAIGN_ID BIGINT NOT NULL, ITERATION_ID BIGINT NOT NULL, ITERATION_ORDER INT NOT NULL, CONSTRAINT fk_camp_iter_campaign FOREIGN KEY (CAMPAIGN_ID) REFERENCES CAMPAIGN(CLN_ID), CONSTRAINT fk_camp_iter_iteration FOREIGN KEY (ITERATION_ID) REFERENCES ITERATION(ITERATION_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.25', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 35, '8:c139a8e6808bf6ea2a43a0de3557b7ac', 'createTable tableName=CAMPAIGN_ITERATION', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.26::bsiri
--  Cette table gere les pas de test d'un cas de test.
CREATE TABLE TEST_STEP (TEST_STEP_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'cle primaire autogeneree.', EXPECTED_RESULT LONGTEXT DEFAULT null NULL COMMENT 'le resultat attendu de l''action effectuee.', ACTION LONGTEXT NOT NULL COMMENT 'action a realiser dans ce pas de test.', ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes. ', CONSTRAINT PK_TEST_STEP PRIMARY KEY (TEST_STEP_ID), CONSTRAINT fk_test_step__attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.26', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 36, '8:4e9bed3b356f31dda9baa615f8cc6371', 'createTable tableName=TEST_STEP', 'Cette table gere les pas de test d''un cas de test.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.27::bsiri
--  Cette table associe un cas de test a ses pas de test. Cette table d'association existe pour ajouter un attribut d'ordre (la liste des pas de test est ordonnee). La cle primaire est ici composite, et ne doit pas etre autogeneree.
CREATE TABLE TEST_CASE_STEPS (TEST_CASE_ID BIGINT NOT NULL COMMENT 'cle etrangere vers TEST_CASE.', STEP_ID BIGINT NOT NULL COMMENT 'cle etrangere vers la table TEST_STEP.', STEP_ORDER INT NOT NULL COMMENT 'numero d''ordre d''un pas de test dans la liste des pas de test d''un cas de test.', CONSTRAINT fk_tc_steps_tc FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID), CONSTRAINT fk_tc_steps_step FOREIGN KEY (STEP_ID) REFERENCES TEST_STEP(TEST_STEP_ID));

CREATE INDEX idx_tc_steps_step ON TEST_CASE_STEPS(STEP_ID);

CREATE INDEX idx_tc_steps_tc ON TEST_CASE_STEPS(TEST_CASE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.27', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 37, '8:d21e2ddc45e4d0d37921acafcf001819', 'createTable tableName=TEST_CASE_STEPS; createIndex indexName=idx_tc_steps_step, tableName=TEST_CASE_STEPS; createIndex indexName=idx_tc_steps_tc, tableName=TEST_CASE_STEPS', 'Cette table associe un cas de test a ses pas de test. Cette table d''association existe pour ajouter un attribut d''ordre (la liste des pas de test est ordonnee). La cle primaire est ici composite, et ne doit pas etre autogeneree.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.28::xpr
CREATE TABLE PROJECT_FILTER (PROJECT_FILTER_ID BIGINT AUTO_INCREMENT NOT NULL, ACTIVATED BIT(1) DEFAULT 0 NOT NULL COMMENT 'filter activated yes or no', USER_LOGIN VARCHAR(255) NOT NULL COMMENT 'unique user login', CONSTRAINT PK_PROJECT_FILTER PRIMARY KEY (PROJECT_FILTER_ID));

CREATE INDEX DX_UN_PROJECT_FILTER_USER ON PROJECT_FILTER(USER_LOGIN);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.28', 'xpr', '../tm/tm.changelog-0.15.0.xml', NOW(), 38, '8:6751ed9d2dc5a49ebde66b5840692425', 'createTable tableName=PROJECT_FILTER; createIndex indexName=DX_UN_PROJECT_FILTER_USER, tableName=PROJECT_FILTER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.29::xpr
CREATE TABLE PROJECT_FILTER_ENTRY (PROJECT_ID BIGINT NOT NULL COMMENT 'foreign key to project', FILTER_ID BIGINT NOT NULL COMMENT 'foreign key to filter', CONSTRAINT FK_PROJ_FILTER_ENTRY_PROJ_FILTER FOREIGN KEY (FILTER_ID) REFERENCES PROJECT_FILTER(PROJECT_FILTER_ID), CONSTRAINT FK_PROJ_FILTER_ENTRY_PROJ FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

ALTER TABLE PROJECT_FILTER_ENTRY ADD PRIMARY KEY (PROJECT_ID, FILTER_ID);

CREATE INDEX dx_pfp_project ON PROJECT_FILTER_ENTRY(PROJECT_ID);

CREATE INDEX dx_pfp_filter ON PROJECT_FILTER_ENTRY(FILTER_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.29', 'xpr', '../tm/tm.changelog-0.15.0.xml', NOW(), 39, '8:e834c57168097eaac73da92840dd6303', 'createTable tableName=PROJECT_FILTER_ENTRY; addPrimaryKey constraintName=PK_PROJ_FILTER_ENTRY, tableName=PROJECT_FILTER_ENTRY; createIndex indexName=dx_pfp_project, tableName=PROJECT_FILTER_ENTRY; createIndex indexName=dx_pfp_filter, tableName=PRO...', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.30::bsiri
--  Cette table gere les exigences proprement dites. Une entree dans cette table indique que l'element reference
--  				dans la table REQUIREMENT_LIBRARY_NODE par la cle primaire (egalement cle etrangere) est de type exigence.
CREATE TABLE REQUIREMENT (RLN_ID BIGINT NOT NULL COMMENT 'cle primaire, qui est aussi une cle etrangere vers la table REQUIREMENT_LIBRARY_NODE. Ne doit donc pas etre autogeneree.', `REFERENCE` VARCHAR(20) NULL COMMENT 'Identifiant de l''exigence', CRITICALITY VARCHAR(255) DEFAULT 'UNDEFINED' NOT NULL COMMENT 'Requirement criticality. Althought this field is a variable character, the data will be the text representation of an enumeration', ATTACHMENT_LIST_ID BIGINT NOT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes. ', CONSTRAINT PK_REQUIREMENT PRIMARY KEY (RLN_ID), CONSTRAINT fk_requirement_requirement_node FOREIGN KEY (RLN_ID) REFERENCES REQUIREMENT_LIBRARY_NODE(RLN_ID), CONSTRAINT fk_requirement_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

CREATE INDEX idx_requirement ON REQUIREMENT(RLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.30', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 40, '8:f11d50d3c4ba925807be95b3da868cd4', 'createTable tableName=REQUIREMENT; createIndex indexName=idx_requirement, tableName=REQUIREMENT', 'Cette table gere les exigences proprement dites. Une entree dans cette table indique que l''element reference
				dans la table REQUIREMENT_LIBRARY_NODE par la cle primaire (egalement cle etrangere) est de type exigence.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.31::bsiri
--  Cette table est rudimentaire. La cle primaire est simplement une cle etrangere vers la table REQUIREMENT_LIBRARY_NODE
--  				(relation qualifiante). Une entree dans cette table indique que l'element indexe par cette cle est de type repertoire.
CREATE TABLE REQUIREMENT_FOLDER (RLN_ID BIGINT NOT NULL COMMENT 'cle primaire, qui est une cle etrangere vers la table REQUIREMENT_LIBRARY_NODE. Ne doit donc pas etre autogeneree.', CONSTRAINT PK_REQUIREMENT_FOLDER PRIMARY KEY (RLN_ID), CONSTRAINT fk_folder_requirement_node FOREIGN KEY (RLN_ID) REFERENCES REQUIREMENT_LIBRARY_NODE(RLN_ID));

CREATE INDEX idx_req_folder ON REQUIREMENT_FOLDER(RLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.31', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 41, '8:05a1d246c9664dc19a17e52bd07ce978', 'createTable tableName=REQUIREMENT_FOLDER; createIndex indexName=idx_req_folder, tableName=REQUIREMENT_FOLDER', 'Cette table est rudimentaire. La cle primaire est simplement une cle etrangere vers la table REQUIREMENT_LIBRARY_NODE
				(relation qualifiante). Une entree dans cette table indique que l''element indexe par cette cle est de type repertoire.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.32::bsiri
--  Cette table associe les bibliotheques d'exigences a leur contenu (elements de bibliotheques d'exigence).
--  		Le contenu d'une bibliotheque d'exigence est arborescent et est represente suivant un patron composite (voire REQUIREMENT_LIBRARY_NODE,
--  		REQUIREMENT_FOLDER, REQUIREMENT). Par defaut la presente table peut contenir uniquement les references vers les elements
--  		fils directs; on peut aussi mettre en relation une bibliotheque d'exigence avec n'importe quel element de son contenu (quelque
--  		soit sa profondeur hierarchique) pour des raisons d'optimisation.
CREATE TABLE REQUIREMENT_LIBRARY_CONTENT (LIBRARY_ID BIGINT NOT NULL COMMENT 'cle etrangere vers une bibliotheque d''exigence.', CONTENT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers un noeud de la bibliotheque d''exigences.', CONSTRAINT fk_requirement_lib_content_lib FOREIGN KEY (LIBRARY_ID) REFERENCES REQUIREMENT_LIBRARY(RL_ID), CONSTRAINT fk_requirement_lib_content_content FOREIGN KEY (CONTENT_ID) REFERENCES REQUIREMENT_LIBRARY_NODE(RLN_ID), UNIQUE (CONTENT_ID));

CREATE INDEX idx_requirement_lib_content_content ON REQUIREMENT_LIBRARY_CONTENT(CONTENT_ID);

CREATE INDEX idx_requirement_lib_content_lib ON REQUIREMENT_LIBRARY_CONTENT(LIBRARY_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.32', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 42, '8:8991560988f2b0dac1c7cc5eec4c02a8', 'createTable tableName=REQUIREMENT_LIBRARY_CONTENT; createIndex indexName=idx_requirement_lib_content_content, tableName=REQUIREMENT_LIBRARY_CONTENT; createIndex indexName=idx_requirement_lib_content_lib, tableName=REQUIREMENT_LIBRARY_CONTENT', 'Cette table associe les bibliotheques d''exigences a leur contenu (elements de bibliotheques d''exigence).
		Le contenu d''une bibliotheque d''exigence est arborescent et est represente suivant un patron composite (voire REQUIREMENT_LIBRARY_NODE,
		RE...', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.33::bsiri
--  Cette table gere la hierarchie entre elements d'une bibliotheque d'exigences, associant un element fils
--  				a un repertoire parent.
CREATE TABLE RLN_RELATIONSHIP (ANCESTOR_ID BIGINT NOT NULL COMMENT 'cle etrangere vers le repertoire parent (il s''agit necessairement d''un repertoire).', DESCENDANT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers l''element fils.', CONSTRAINT fk_rln_relationship_ancestor FOREIGN KEY (ANCESTOR_ID) REFERENCES REQUIREMENT_FOLDER(RLN_ID), CONSTRAINT fk_rln_relationship_descendant FOREIGN KEY (DESCENDANT_ID) REFERENCES REQUIREMENT_LIBRARY_NODE(RLN_ID), UNIQUE (DESCENDANT_ID));

CREATE INDEX idx_rln_relationship_descendant ON RLN_RELATIONSHIP(DESCENDANT_ID);

CREATE INDEX idx_rln_relationship_ancestor ON RLN_RELATIONSHIP(ANCESTOR_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.33', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 43, '8:854410f19a07111ac4eb5b10cf9cb66a', 'createTable tableName=RLN_RELATIONSHIP; createIndex indexName=idx_rln_relationship_descendant, tableName=RLN_RELATIONSHIP; createIndex indexName=idx_rln_relationship_ancestor, tableName=RLN_RELATIONSHIP', 'Cette table gere la hierarchie entre elements d''une bibliotheque d''exigences, associant un element fils
				a un repertoire parent.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.34::bsiri
--  Cette table associe un cas de test avec une liste d'execution. Elle conserve également
--  		en mémoire le status d'execution, qui devra sera mis à jour au fur et à mesure qu'une execution
--  		est ajoutée ou exécutée.
CREATE TABLE ITEM_TEST_PLAN (ITEM_TEST_PLAN_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'clé primaire du test plan. Devrait être autogénérée.', EXECUTION_STATUS VARCHAR(255) DEFAULT null NULL COMMENT 'Status d''execution de ce plan de test. Bien que ce champs soit caractère variable, les données réelles    seront la représentation texte d''un type énuméré. Sera recalculé en fonction du status de    sa derniere execution', LAST_EXECUTED_BY VARCHAR(255) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant execute cet instance.', LAST_EXECUTED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere execution de cette instance.', TCLN_ID BIGINT NULL COMMENT 'Clé étrangère vers le cas de test référencé', LABEL VARCHAR(255) NULL COMMENT 'Le label (duplicata du nom du cas de test) du test plan', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'nom du créateur du testplan', CREATED_ON datetime NOT NULL COMMENT 'Date de création du test plan. Il s''agit de la date de création de l''entrée dans la base, non d''une date métier.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis à jour cet instance.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de dernière mise à jour de cette instance.', CONSTRAINT PK_ITEM_TEST_PLAN PRIMARY KEY (ITEM_TEST_PLAN_ID), CONSTRAINT fk_itertestplan_test_case FOREIGN KEY (TCLN_ID) REFERENCES TEST_CASE(TCLN_ID));

CREATE INDEX idx_itertestplan ON ITEM_TEST_PLAN(ITEM_TEST_PLAN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.34', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 44, '8:4627a9de93c1c4a2147036f8c9d403a5', 'createTable tableName=ITEM_TEST_PLAN; createIndex indexName=idx_itertestplan, tableName=ITEM_TEST_PLAN', 'Cette table associe un cas de test avec une liste d''execution. Elle conserve également
		en mémoire le status d''execution, qui devra sera mis à jour au fur et à mesure qu''une execution
		est ajoutée ou exécutée.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.35::bsiri
--  Cette table associe une iteration a ses test plans. Cette table d'association existe pour ajouter un attribut d'ordre (la liste des test plans est ordonnée). La clé primaire est ici composite, et ne doit pas être autogénérée.
CREATE TABLE ITEM_TEST_PLAN_LIST (ITERATION_ID BIGINT NOT NULL COMMENT 'clé étrangère vers ITERATION.', ITEM_TEST_PLAN_ID BIGINT NOT NULL COMMENT 'clé étrangère vers la table ITEM_TEST_PLAN', ITEM_TEST_PLAN_ORDER INT NOT NULL COMMENT 'numéro d''ordre d''une execution dans la liste des test plans d''une itération.', CONSTRAINT fk_item_test_plan_iteration FOREIGN KEY (ITERATION_ID) REFERENCES ITERATION(ITERATION_ID), CONSTRAINT fk_ITEM_TESTplan_testplan FOREIGN KEY (ITEM_TEST_PLAN_ID) REFERENCES ITEM_TEST_PLAN(ITEM_TEST_PLAN_ID));

CREATE INDEX idx_ITEM_TESTplan_iteration ON ITEM_TEST_PLAN_LIST(ITERATION_ID);

CREATE INDEX idx_ITEM_TESTplan_testplan ON ITEM_TEST_PLAN_LIST(ITEM_TEST_PLAN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.35', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 45, '8:28a12dbdd4437ee8892579c9c9e22c6e', 'createTable tableName=ITEM_TEST_PLAN_LIST; createIndex indexName=idx_ITEM_TESTplan_iteration, tableName=ITEM_TEST_PLAN_LIST; createIndex indexName=idx_ITEM_TESTplan_testplan, tableName=ITEM_TEST_PLAN_LIST', 'Cette table associe une iteration a ses test plans. Cette table d''association existe pour ajouter un attribut d''ordre (la liste des test plans est ordonnée). La clé primaire est ici composite, et ne doit pas être autogénérée.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.36::bsiri
--  Table des executions. Une execution correspond à un cas de test, et ses pas d'execution correspondent à des pas de test. Pour assurer un contrôle sur les modifications de l'entité source une référence est gardée vers le cas de test source.
CREATE TABLE EXECUTION (EXECUTION_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'clé primaire de l''execution. Devrait être autogénérée.', TCLN_ID BIGINT NULL COMMENT 'Clé étrangère vers le cas de test référencé. Cette information est redondante puisque     il s''agit toujours du même que celui du test plan, cependant cette information ne devant     jamais évoluer il n''y a pas de risque à dénormaliser', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'nom du créateur de l''execution.', CREATED_ON datetime NOT NULL COMMENT 'Date de création de cette execution. Il s''agit de la date de création de l''entrée dans la base, non d''une date métier.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis à jour cet instance.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de dernière mise à jour de cette instance.', `DESCRIPTION` LONGTEXT DEFAULT null NULL COMMENT 'Une description associée à cet élément. Devrait être un champ texte long ou un clob.', NAME VARCHAR(255) NOT NULL COMMENT 'Le nom/label de l''élément en question.', EXECUTION_MODE VARCHAR(255) DEFAULT null NULL COMMENT 'Mode d''execution de cette execution. Bien que ce champs soit caractère variable, les données réelles    seront la représentation texte d''un type énuméré. C''est une copie du mode d''execution du cas de test référencé.', EXECUTION_STATUS VARCHAR(255) DEFAULT null NULL COMMENT 'Status d''execution de ce plan de test. Bien que ce champs soit caractère variable, les données réelles    seront la représentation texte d''un type énuméré. Sera recalculé en fonction du status de    sa derniere execution', LAST_EXECUTED_BY VARCHAR(255) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant execute cet instance.', LAST_EXECUTED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere execution de cette instance.', ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes. ', ISSUE_LIST_ID BIGINT NOT NULL COMMENT 'clé étrangère vers un ISSUE_LIST, l''entité qui gère les listes d''issues. ', CONSTRAINT PK_EXECUTION PRIMARY KEY (EXECUTION_ID), CONSTRAINT fk_execution_issue_list FOREIGN KEY (ISSUE_LIST_ID) REFERENCES ISSUE_LIST(ISSUE_LIST_ID), CONSTRAINT fk_execution_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID), CONSTRAINT fk_execution_test_case FOREIGN KEY (TCLN_ID) REFERENCES TEST_CASE(TCLN_ID));

CREATE INDEX idx_execution ON EXECUTION(EXECUTION_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.36', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 46, '8:d266e227f26cef64aa9d63917b89f4e4', 'createTable tableName=EXECUTION; createIndex indexName=idx_execution, tableName=EXECUTION', 'Table des executions. Une execution correspond à un cas de test, et ses pas d''execution correspondent à des pas de test. Pour assurer un contrôle sur les modifications de l''entité source une référence est gardée vers le cas de test source.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.37::bsiri
--  Associe les executions aux test plans
CREATE TABLE ITEM_TEST_PLAN_EXECUTION (ITEM_TEST_PLAN_ID BIGINT NOT NULL COMMENT 'clé étrangère vers ITEM_TEST_PLAN.', EXECUTION_ID BIGINT NOT NULL COMMENT 'clé étrangère vers la table EXECUTION', EXECUTION_ORDER INT NOT NULL COMMENT 'numéro d''ordre d''une execution dans la liste des test plans d''une itération.', CONSTRAINT fk_testplan_exec_exec FOREIGN KEY (EXECUTION_ID) REFERENCES EXECUTION(EXECUTION_ID), CONSTRAINT fk_testplan_exec_testplan FOREIGN KEY (ITEM_TEST_PLAN_ID) REFERENCES ITEM_TEST_PLAN(ITEM_TEST_PLAN_ID));

CREATE INDEX idx_testplan_exec_testplan ON ITEM_TEST_PLAN_EXECUTION(ITEM_TEST_PLAN_ID);

CREATE INDEX idx_testplan_exec_exec ON ITEM_TEST_PLAN_EXECUTION(EXECUTION_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.37', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 47, '8:f33084c7ffae3c6ed7a1d3e81b451973', 'createTable tableName=ITEM_TEST_PLAN_EXECUTION; createIndex indexName=idx_testplan_exec_testplan, tableName=ITEM_TEST_PLAN_EXECUTION; createIndex indexName=idx_testplan_exec_exec, tableName=ITEM_TEST_PLAN_EXECUTION', 'Associe les executions aux test plans', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.38::bsiri
--  Cette table gère les pas d'execution d'une execution. Voir la table EXECUTION pour plus de détails.
CREATE TABLE EXECUTION_STEP (EXECUTION_STEP_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'clé primaire autogénérée.', EXPECTED_RESULT LONGTEXT DEFAULT null NULL COMMENT 'le résultat attendu de l''action effectuée.', ACTION LONGTEXT NOT NULL COMMENT 'action à réaliser dans ce pas d''execution.', EXECUTION_STATUS VARCHAR(255) DEFAULT null NULL COMMENT 'Status de l''execution de ce pas d''execution. Bien que ce champs soit caractère variable, les données réelles    seront la représentation texte d''un type énuméré.', LAST_EXECUTED_BY VARCHAR(255) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant execute cet instance.', LAST_EXECUTED_ON datetime DEFAULT null NULL COMMENT 'Date de derniere execution de cette instance.', COMMENT LONGTEXT NULL COMMENT 'commentaire libre du recetteur.', TEST_STEP_ID BIGINT NULL COMMENT 'Clé étrangère vers le pas de test référencé', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'nom du créateur du pas d''execution.', CREATED_ON datetime NOT NULL COMMENT 'Date de création de ce pas d''execution. Il s''agit de la date de création de l''entrée dans la base, non d''une date métier.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Nom du dernier utilisateur ayant mis à jour cet instance.', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date de dernière mise à jour de cette instance.', ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes. ', ISSUE_LIST_ID BIGINT NOT NULL COMMENT 'clé étrangère vers un ISSUE_LIST, l''entité qui gère les listes d''issues. ', CONSTRAINT PK_EXECUTION_STEP PRIMARY KEY (EXECUTION_STEP_ID), CONSTRAINT fk_execution_step__attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID), CONSTRAINT fk_executionstep_teststep FOREIGN KEY (TEST_STEP_ID) REFERENCES TEST_STEP(TEST_STEP_ID), CONSTRAINT fk_execution_step_issue_list FOREIGN KEY (ISSUE_LIST_ID) REFERENCES ISSUE_LIST(ISSUE_LIST_ID));

CREATE INDEX idx_executionstep ON EXECUTION_STEP(EXECUTION_STEP_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.38', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 48, '8:3938ae5e9a0b4bd3212655e86fb2704d', 'createTable tableName=EXECUTION_STEP; createIndex indexName=idx_executionstep, tableName=EXECUTION_STEP', 'Cette table gère les pas d''execution d''une execution. Voir la table EXECUTION pour plus de détails.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.39::bsiri
--  Cette table associe une executions à ses pas d'execution. Cette table d'association existe pour ajouter un attribut d'ordre (la liste des pas executions est ordonnée). La clé primaire est ici composite, et ne doit pas être autogénérée.
CREATE TABLE EXECUTION_EXECUTION_STEPS (EXECUTION_ID BIGINT NOT NULL COMMENT 'clé étrangère vers la table EXECUTION.', EXECUTION_STEP_ID BIGINT NOT NULL COMMENT 'clé étrangère vers EXECUTION_STEP', EXECUTION_STEP_ORDER INT NOT NULL COMMENT 'numéro d''ordre d''un pas d''execution dans la liste des pas d''executions d''une execution.', CONSTRAINT fk_exec_exec_step_exec_step FOREIGN KEY (EXECUTION_STEP_ID) REFERENCES EXECUTION_STEP(EXECUTION_STEP_ID), CONSTRAINT fk_exec_exec_step_exec FOREIGN KEY (EXECUTION_ID) REFERENCES EXECUTION(EXECUTION_ID));

CREATE INDEX idx_exec_exec_step_exec ON EXECUTION_EXECUTION_STEPS(EXECUTION_ID);

CREATE INDEX idx_exec_exec_step_exec_step ON EXECUTION_EXECUTION_STEPS(EXECUTION_STEP_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.39', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 49, '8:bc70b347adec2a2ffb481e0d1dd7ba0f', 'createTable tableName=EXECUTION_EXECUTION_STEPS; createIndex indexName=idx_exec_exec_step_exec, tableName=EXECUTION_EXECUTION_STEPS; createIndex indexName=idx_exec_exec_step_exec_step, tableName=EXECUTION_EXECUTION_STEPS', 'Cette table associe une executions à ses pas d''execution. Cette table d''association existe pour ajouter un attribut d''ordre (la liste des pas executions est ordonnée). La clé primaire est ici composite, et ne doit pas être autogénérée.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.40::bsiri
--  Cette table gere les associations entre cas de test et exigences.
--  				La cle primaire est composite et ne doit pas etre autogeneree.
CREATE TABLE TEST_CASE_REQUIREMENT_LINK (TEST_CASE_ID BIGINT NOT NULL COMMENT 'cle etrangere vers TEST_CASE', REQUIREMENT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers REQUIREMENT', CONSTRAINT fk_tc_req_tc FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID), CONSTRAINT fk_tc_req_req FOREIGN KEY (REQUIREMENT_ID) REFERENCES REQUIREMENT(RLN_ID));

ALTER TABLE TEST_CASE_REQUIREMENT_LINK ADD PRIMARY KEY (TEST_CASE_ID, REQUIREMENT_ID);

CREATE INDEX idx_tc_req_tc ON TEST_CASE_REQUIREMENT_LINK(TEST_CASE_ID);

CREATE INDEX idx_tc_req_req ON TEST_CASE_REQUIREMENT_LINK(REQUIREMENT_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.40', 'bsiri', '../tm/tm.changelog-0.15.0.xml', NOW(), 50, '8:58262c6d8f1291e2eafb30508a7377cf', 'createTable tableName=TEST_CASE_REQUIREMENT_LINK; addPrimaryKey constraintName=pk_tc_req_link, tableName=TEST_CASE_REQUIREMENT_LINK; createIndex indexName=idx_tc_req_tc, tableName=TEST_CASE_REQUIREMENT_LINK; createIndex indexName=idx_tc_req_req, t...', 'Cette table gere les associations entre cas de test et exigences.
				La cle primaire est composite et ne doit pas etre autogeneree.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.41::adurand
--  Cette table gere les associations entre les campagnes et les cas de test (= les plans de test des campagnes).La cle primaire est composite et ne doit pas etre autogeneree.
CREATE TABLE CAMPAIGN_TEST_PLAN (CAMPAIGN_ID BIGINT NOT NULL COMMENT 'cle etrangere vers CAMPAIGN', TEST_CASE_ID BIGINT NOT NULL COMMENT 'cle etrangere vers TEST_CASE', CONSTRAINT fk_camp_tp_camp FOREIGN KEY (CAMPAIGN_ID) REFERENCES CAMPAIGN(CLN_ID), CONSTRAINT fk_camp_tp_tc FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID));

ALTER TABLE CAMPAIGN_TEST_PLAN ADD PRIMARY KEY (CAMPAIGN_ID, TEST_CASE_ID);

CREATE INDEX idx_camp_tp_camp ON CAMPAIGN_TEST_PLAN(CAMPAIGN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.41', 'adurand', '../tm/tm.changelog-0.15.0.xml', NOW(), 51, '8:afd6c698b88ab38465f010b2e15b1e6f', 'createTable tableName=CAMPAIGN_TEST_PLAN; addPrimaryKey constraintName=pk_camp_tp, tableName=CAMPAIGN_TEST_PLAN; createIndex indexName=idx_camp_tp_camp, tableName=CAMPAIGN_TEST_PLAN', 'Cette table gere les associations entre les campagnes et les cas de test (= les plans de test des campagnes).La cle primaire est composite et ne doit pas etre autogeneree.', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.42::bsiri
--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.43::xpr
alter table ATTACHMENT_CONTENT modify column STREAM_CONTENT MEDIUMBLOB;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.43', 'xpr', '../tm/tm.changelog-0.15.0.xml', NOW(), 52, '8:5d49f7b9a14768e1d2a69b901eb72369', 'sql', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.44::gfouquet
INSERT INTO CORE_GROUP_AUTHORITY (GROUP_ID, AUTHORITY) VALUES ((select ID from CORE_GROUP where QUALIFIED_NAME='squashtest.authz.group.core.Admin'), 'ROLE_TM_USER');

INSERT INTO CORE_GROUP (QUALIFIED_NAME) VALUES ('squashtest.tm.group.User');

INSERT INTO CORE_GROUP_AUTHORITY (GROUP_ID, AUTHORITY) VALUES ((select max(ID) from CORE_GROUP), 'ROLE_TM_USER');

INSERT INTO CORE_GROUP (QUALIFIED_NAME) VALUES ('squashtest.authz.group.tm.ProjectManager');

INSERT INTO CORE_GROUP_AUTHORITY (GROUP_ID, AUTHORITY) VALUES ((select max(ID) from CORE_GROUP), 'ROLE_TM_PROJECT_MANAGER');

INSERT INTO ACL_CLASS (CLASSNAME) VALUES ('org.squashtest.csp.tm.domain.project.Project');

INSERT INTO ACL_GROUP (QUALIFIED_NAME) VALUES ('squashtest.acl.group.tm.ProjectManager');

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.ProjectManager'), '15', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.ProjectManager'), '1', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.ProjectManager'), '2', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.ProjectManager'), '4', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.ProjectManager'), '8', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP (QUALIFIED_NAME) VALUES ('squashtest.acl.group.tm.TestEditor');

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.TestEditor'), '15', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.TestEditor'), '1', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.TestEditor'), '2', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.TestEditor'), '4', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.TestEditor'), '8', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO ACL_GROUP (QUALIFIED_NAME) VALUES ('squashtest.acl.group.tm.TestRunner');

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.TestRunner'), '1', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.44', 'gfouquet', '../tm/tm.changelog-0.15.0.xml', NOW(), 53, '8:84af8be16b16c30984d3a48cf12ff34c', 'insert tableName=CORE_GROUP_AUTHORITY; insert tableName=CORE_GROUP; insert tableName=CORE_GROUP_AUTHORITY; insert tableName=CORE_GROUP; insert tableName=CORE_GROUP_AUTHORITY; insert tableName=ACL_CLASS; insert tableName=ACL_GROUP; insert tableName...', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../tm/tm.changelog-0.15.0.xml::tm-0.14.0.45::gfouquet
INSERT INTO ACL_GROUP (QUALIFIED_NAME) VALUES ('squashtest.acl.group.tm.ProjectViewer');

INSERT INTO ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID) VALUES ((select ID from ACL_GROUP where QUALIFIED_NAME = 'squashtest.acl.group.tm.ProjectViewer'), '1', (select ID from ACL_CLASS where CLASSNAME = 'org.squashtest.csp.tm.domain.project.Project'));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-0.14.0.45', 'gfouquet', '../tm/tm.changelog-0.15.0.xml', NOW(), 54, '8:b87f2918468fac72651eccadb2898192', 'insert tableName=ACL_GROUP; insert tableName=ACL_GROUP_PERMISSION', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Changeset ../auth/auth.changelog-1.0.xml::1::gfouquet
CREATE TABLE AUTH_USER (LOGIN VARCHAR(50) NOT NULL COMMENT 'The user''s unique identifier', PASSWORD CHAR(40) NOT NULL COMMENT 'SHA-1 hash of the user''s password', ACTIVE BIT(1) DEFAULT 1 NOT NULL, CONSTRAINT PK_AUTH_USER PRIMARY KEY (LOGIN)) COMMENT='Stores users credentials';

CREATE UNIQUE INDEX IDX_AUTHENTICATION ON AUTH_USER(LOGIN);

INSERT INTO AUTH_USER (LOGIN, PASSWORD, ACTIVE) VALUES ('admin', 'd033e22ae348aeb5660fc2140aec35850c4da997', 1);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('1', 'gfouquet', '../auth/auth.changelog-1.0.xml', NOW(), 55, '8:3d9ef6ff908a32ab0bbf37a6a87b4998', 'createTable tableName=AUTH_USER; createIndex indexName=IDX_AUTHENTICATION, tableName=AUTH_USER; insert tableName=AUTH_USER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340183570');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

