--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.10.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0::bsiri
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.10.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0', 'bsiri', '../tm/tm.changelog-1.10.0.xml', NOW(), 1, '8:c9fb10720986837eae47c3661483c684', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-1::bsiri
--  before the cleanup, we need to relax some constraints
ALTER TABLE AUTOMATED_EXECUTION_EXTENDER MODIFY TEST_ID BIGINT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-1', 'bsiri', '../tm/tm.changelog-1.10.0.xml', NOW(), 2, '8:61f9a82add8930097376054289b700f4', 'dropNotNullConstraint columnName=TEST_ID, tableName=AUTOMATED_EXECUTION_EXTENDER', 'before the cleanup, we need to relax some constraints', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-2::bsiri
--  cleaning up unused entities
create temporary table UNUSED_TA_PROJECT as
  			(
  				select taproj.project_id as project_id
  				from TEST_AUTOMATION_PROJECT taproj
  				where taproj.project_id not in (
  					select ta_project_id from TM_TA_PROJECTS
  				)
  			);

update AUTOMATED_EXECUTION_EXTENDER extender
  			set result_url = null,
  				test_id = null
  			where extender.test_id in (
  				select tatest.test_id
  				from  AUTOMATED_TEST tatest
  				inner join UNUSED_TA_PROJECT unused on tatest.project_id = unused.project_id
  			);

update TEST_CASE tc
  			set ta_test = null
  			where tc.ta_test in (
  				select tatest.test_id
  				from AUTOMATED_TEST tatest
  				inner join UNUSED_TA_PROJECT unused on tatest.project_id = unused.project_id
  			);

delete from AUTOMATED_TEST
			where project_id in (
				select unused.project_id from UNUSED_TA_PROJECT unused
			);

delete from TEST_AUTOMATION_PROJECT
  			where project_id in (
  				select p.project_id from UNUSED_TA_PROJECT p
  			);

delete from TEST_AUTOMATION_SERVER
  			where server_id not in (
  				select distinct taproj.server_id
  				from TM_TA_PROJECTS binding
  				inner join TEST_AUTOMATION_PROJECT taproj on binding.ta_project_id = taproj.project_id
  			);

drop table UNUSED_TA_PROJECT;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-2', 'bsiri', '../tm/tm.changelog-1.10.0.xml', NOW(), 3, '8:ac8a755f09a91815588ee6fdc79b989c', 'sql; sql; sql; sql; sql; sql; sql', 'cleaning up unused entities', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-3::bsiri
--  The test automation servers are now 'auditable' (dates and authors of creation/modification are recorded) and has
--  		several other attributes
ALTER TABLE TEST_AUTOMATION_SERVER ADD NAME VARCHAR(50) NULL COMMENT 'The name of the server' , ADD `DESCRIPTION` LONGTEXT NULL COMMENT 'A description for the server. Since its of type ''CLOB'' it might not be so short after all.' , ADD CREATED_BY VARCHAR(50) DEFAULT '(nobody)' NULL COMMENT 'Who created this test automation server' , ADD CREATED_ON datetime NULL COMMENT 'When was created that server' , ADD LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'Author of last edition' , ADD LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Last date of edition' , ADD MANUAL_SLAVE_SELECTION BIT(1) DEFAULT 0 NOT NULL COMMENT 'Should the user select which slave will run the tests (if there are some) ?';

update TEST_AUTOMATION_SERVER
			set name = concat_ws('-', base_url, server_id);

update TEST_AUTOMATION_SERVER
			set CREATED_ON = NOW();

ALTER TABLE TEST_AUTOMATION_SERVER MODIFY NAME VARCHAR(50) NOT NULL;

ALTER TABLE TEST_AUTOMATION_SERVER ADD UNIQUE (NAME);

ALTER TABLE TEST_AUTOMATION_SERVER MODIFY CREATED_ON datetime NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-3', 'bsiri', '../tm/tm.changelog-1.10.0.xml', NOW(), 4, '8:d70380277307269a80a90d9f420bf0a7', 'addColumn tableName=TEST_AUTOMATION_SERVER; sql; sql; addNotNullConstraint columnName=NAME, tableName=TEST_AUTOMATION_SERVER; addUniqueConstraint tableName=TEST_AUTOMATION_SERVER; addNotNullConstraint columnName=CREATED_ON, tableName=TEST_AUTOMATI...', 'The test automation servers are now ''auditable'' (dates and authors of creation/modification are recorded) and has
		several other attributes', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-4::bsiri
--  The associative table TM_TA_PROJECTS is totally re-purposed as TEST_AUTOMATION_PROJECT
--  			(and the former table is ditched).
CREATE TABLE PROTO_TEST_AUTOMATION_PROJECT (TA_PROJECT_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'the primary key', TM_PROJECT_ID BIGINT NOT NULL COMMENT 'the reference to the TM project', LABEL VARCHAR(50) NOT NULL COMMENT 'the (friendly) alias for that TA project ', REMOTE_NAME VARCHAR(50) NOT NULL COMMENT 'the (real) name of the remote test automation project', SERVER_ID BIGINT NOT NULL COMMENT 'foreign key to the automated test server', EXECUTION_ENVIRONMENTS VARCHAR(255) DEFAULT '' NOT NULL COMMENT 'the list of approved slaves servers', FORMER_ID BIGINT NOT NULL COMMENT 'the former primary key', CONSTRAINT PK_PROTO_TEST_AUTOMATION_PROJECT PRIMARY KEY (TA_PROJECT_ID), CONSTRAINT fk_ta_project_tm_project FOREIGN KEY (TM_PROJECT_ID) REFERENCES PROJECT(PROJECT_ID), CONSTRAINT fk_ta_project_ta_server FOREIGN KEY (SERVER_ID) REFERENCES TEST_AUTOMATION_SERVER(SERVER_ID));

insert into PROTO_TEST_AUTOMATION_PROJECT(TM_PROJECT_ID, LABEL, REMOTE_NAME, SERVER_ID, FORMER_ID)
			select binding.tm_project_id,
				   concat_ws('-', proj.name, binding.tm_project_id, binding.ta_project_id),
				   proj.name,
				   proj.server_id,
				   proj.project_id
			from TM_TA_PROJECTS binding
			inner join TEST_AUTOMATION_PROJECT proj on binding.ta_project_id = proj.project_id;

DROP TABLE TM_TA_PROJECTS;

ALTER TABLE AUTOMATED_TEST DROP FOREIGN KEY fk_automated_test_project;

DROP TABLE TEST_AUTOMATION_PROJECT;

ALTER TABLE PROTO_TEST_AUTOMATION_PROJECT RENAME TEST_AUTOMATION_PROJECT;

update AUTOMATED_TEST
			set PROJECT_ID = (
				select tap.TA_PROJECT_ID
				from TEST_AUTOMATION_PROJECT tap
                  inner join TEST_CASE_LIBRARY_NODE tcln on tcln.PROJECT_ID = tap.TM_PROJECT_ID
                  inner join TEST_CASE tc on tc.TCLN_ID = tcln.TCLN_ID
				where PROJECT_ID = tap.FORMER_ID
				  and TEST_ID = tc.TA_TEST
				group by tc.TA_TEST, tap.TA_PROJECT_ID
			);

ALTER TABLE TEST_AUTOMATION_PROJECT DROP COLUMN FORMER_ID;

ALTER TABLE AUTOMATED_TEST ADD CONSTRAINT fk_automated_test_project FOREIGN KEY (PROJECT_ID) REFERENCES TEST_AUTOMATION_PROJECT (TA_PROJECT_ID);

ALTER TABLE TEST_AUTOMATION_PROJECT ADD CONSTRAINT uniq_tm_ta_project_job UNIQUE (TM_PROJECT_ID, REMOTE_NAME, SERVER_ID);

ALTER TABLE TEST_AUTOMATION_PROJECT ADD CONSTRAINT uniq_tm_ta_project_label UNIQUE (TM_PROJECT_ID, LABEL);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-4', 'bsiri', '../tm/tm.changelog-1.10.0.xml', NOW(), 5, '8:a3af1d22d24b1669302c99277c43fcaa', 'createTable tableName=PROTO_TEST_AUTOMATION_PROJECT; sql; dropTable tableName=TM_TA_PROJECTS; dropForeignKeyConstraint baseTableName=AUTOMATED_TEST, constraintName=fk_automated_test_project; dropTable tableName=TEST_AUTOMATION_PROJECT; renameTable...', 'The associative table TM_TA_PROJECTS is totally re-purposed as TEST_AUTOMATION_PROJECT
			(and the former table is ditched).', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-5::bsiri
--  A TM project is now hard-bound to a TA server
ALTER TABLE PROJECT ADD TA_SERVER_ID BIGINT NULL COMMENT 'the reference to the test automation server';

ALTER TABLE PROJECT ADD CONSTRAINT tm_project_ta_server FOREIGN KEY (TA_SERVER_ID) REFERENCES TEST_AUTOMATION_SERVER (SERVER_ID);

ALTER TABLE PROJECT DROP COLUMN TEST_AUTOMATION_ENABLED;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-5', 'bsiri', '../tm/tm.changelog-1.10.0.xml', NOW(), 6, '8:fd037f2b007d78a30201b94b45d6474b', 'addColumn tableName=PROJECT; dropColumn columnName=TEST_AUTOMATION_ENABLED, tableName=PROJECT', 'A TM project is now hard-bound to a TA server', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-6::bsiri
--  migrating existing data to the new schema
update PROJECT
			set ta_server_id = (
				select max(server.server_id)
				from TEST_AUTOMATION_SERVER server
				inner join TEST_AUTOMATION_PROJECT taproj on server.server_id = taproj.server_id
				where taproj.tm_project_id = project_id
			);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-6', 'bsiri', '../tm/tm.changelog-1.10.0.xml', NOW(), 7, '8:7de916fc08d5d87e6c2fe34026c35886', 'sql', 'migrating existing data to the new schema', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-6::gfouquet
ALTER TABLE AUTOMATED_EXECUTION_EXTENDER ADD NODE_NAME VARCHAR(50) DEFAULT '' NULL COMMENT 'Name of the node which ran the test';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-6', 'gfouquet', '../tm/tm.changelog-1.10.0.xml', NOW(), 8, '8:39460d77595f309783bb7344142d2174', 'addColumn tableName=AUTOMATED_EXECUTION_EXTENDER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-7::flaurens
ALTER TABLE AUTOMATED_EXECUTION_EXTENDER ADD EXECUTION_EXTENDER_ORDER BIGINT NULL COMMENT 'order of automated executions extenders within an automated suite';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-7', 'flaurens', '../tm/tm.changelog-1.10.0.xml', NOW(), 9, '8:827045ccc204c7f602bddfc6869147f2', 'addColumn tableName=AUTOMATED_EXECUTION_EXTENDER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-8::flaurens
--  Creating default order which is identical with the alphabetical order
create table TEMP_EXECUTION_EXTENDER_ORDER(
	        EXECUTION_EXTENDER_ORDER BIGINT NOT NULL,
	        SUITE_ID BIGINT NOT NULL,
	        EXTENDER_ID BIGINT NOT NULL,
	        DUMMY BIGINT NOT NULL
	      );

insert into TEMP_EXECUTION_EXTENDER_ORDER (EXECUTION_EXTENDER_ORDER, SUITE_ID, EXTENDER_ID, DUMMY)
	      select
	        if(@prevtcs=SUITE_ID, @rownum:=@rownum+1, @rownum:=0) as RANK,
	        clnr.SUITE_ID,
	        clnr.EXTENDER_ID,
	        (@prevtcs:=SUITE_ID)
	      from (
	      	select cr.SUITE_ID, cr.EXTENDER_ID
	      	from AUTOMATED_EXECUTION_EXTENDER cr
	        order by cr.SUITE_ID, cr.EXTENDER_ID
	       ) as clnr,
	        (SELECT @rownum:=0) r,
	        (SELECT @prevtcs:=0) s;

update AUTOMATED_EXECUTION_EXTENDER
	      set EXECUTION_EXTENDER_ORDER = (
	        select TEMP_EXECUTION_EXTENDER_ORDER.EXECUTION_EXTENDER_ORDER
	        from TEMP_EXECUTION_EXTENDER_ORDER
	        where TEMP_EXECUTION_EXTENDER_ORDER.SUITE_ID = AUTOMATED_EXECUTION_EXTENDER.SUITE_ID
	          and TEMP_EXECUTION_EXTENDER_ORDER.EXTENDER_ID = AUTOMATED_EXECUTION_EXTENDER.EXTENDER_ID
	      );

drop table TEMP_EXECUTION_EXTENDER_ORDER;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.10.0.feature-3481-8', 'flaurens', '../tm/tm.changelog-1.10.0.xml', NOW(), 10, '8:70da0f476b1b6dec60cd259db677686e', 'sql', 'Creating default order which is identical with the alphabetical order', 'EXECUTED', NULL, NULL, '4.17.2', '9340184573');

--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-9::flaurens
--  Creating default order which is identical with the alphabetical order
--  Changeset ../tm/tm.changelog-1.10.0.xml::tm-1.10.0.feature-3481-postgresql::mpagnon
--  Creating default order which is identical with the alphabetical order
--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

