--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.12.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0::jsimon
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.12.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0', 'jsimon', '../tm/tm.changelog-1.12.0.xml', NOW(), 1, '8:88dcb691497aee7858074ead96323310', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feature-3607-1::jsimon
--  Table for Milestones
CREATE TABLE MILESTONE (MILESTONE_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'Primary key', LABEL VARCHAR(30) NOT NULL COMMENT 'Milestone label', STATUS VARCHAR(30) NULL COMMENT 'Milestone status', END_DATE datetime NOT NULL COMMENT 'Term date', `DESCRIPTION` LONGTEXT NULL COMMENT 'Milestone description', M_RANGE VARCHAR(30) NOT NULL COMMENT 'Milestone range', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'Name of the milestone creator', CREATED_ON datetime NOT NULL COMMENT 'Date of creation.', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'last modified by', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Date of last update', USER_ID BIGINT NOT NULL COMMENT 'the user that own the milestone', CONSTRAINT PK_MILESTONE PRIMARY KEY (MILESTONE_ID), CONSTRAINT fk_milestone_owner FOREIGN KEY (USER_ID) REFERENCES CORE_USER(PARTY_ID), UNIQUE (LABEL));

CREATE INDEX idx_milestone ON MILESTONE(MILESTONE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feature-3607-1', 'jsimon', '../tm/tm.changelog-1.12.0.xml', NOW(), 2, '8:ff298f12a8e741d51cb3663d01d766b9', 'createTable tableName=MILESTONE; createIndex indexName=idx_milestone, tableName=MILESTONE', 'Table for Milestones', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feature-3608-1::jsimon
--  Table for MilestoneBinding
CREATE TABLE MILESTONE_BINDING (MILESTONE_BINDING_ID BIGINT AUTO_INCREMENT NOT NULL, MILESTONE_ID BIGINT NOT NULL, PROJECT_ID BIGINT NOT NULL, CONSTRAINT PK_MILESTONE_BINDING PRIMARY KEY (MILESTONE_BINDING_ID), CONSTRAINT FK_MILESTONE_BINDING_MILESTONE FOREIGN KEY (MILESTONE_ID) REFERENCES MILESTONE(MILESTONE_ID), CONSTRAINT FK_MILESTONE_BINDING_PROJECT FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feature-3608-1', 'jsimon', '../tm/tm.changelog-1.12.0.xml', NOW(), 3, '8:7014f97d59bcedceceffac2ed37cb395', 'createTable tableName=MILESTONE_BINDING', 'Table for MilestoneBinding', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feature-3609-1::jsimon
--  Table for MilestoneBindingPerimeter
CREATE TABLE MILESTONE_BINDING_PERIMETER (MILESTONE_BINDING_PERIMETER_ID BIGINT AUTO_INCREMENT NOT NULL, MILESTONE_ID BIGINT NOT NULL, PROJECT_ID BIGINT NOT NULL, CONSTRAINT PK_MILESTONE_BINDING_PERIMETER PRIMARY KEY (MILESTONE_BINDING_PERIMETER_ID), CONSTRAINT FK_MILESTONE_BINDING_PERIMETER_PROJECT FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID), CONSTRAINT FK_MILESTONE_BINDING_PERIMETER_MILESTONE FOREIGN KEY (MILESTONE_ID) REFERENCES MILESTONE(MILESTONE_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feature-3609-1', 'jsimon', '../tm/tm.changelog-1.12.0.xml', NOW(), 4, '8:2e3d1a102954dddc6cc105b918d2f0dd', 'createTable tableName=MILESTONE_BINDING_PERIMETER', 'Table for MilestoneBindingPerimeter', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feature-3823-1::bsiri
--  Creating the values table for multi-valued custom fields, much like CUSTOM_FIELD_OPTION is. 
--    	Note : the DELETE CASCADE on the foreign key is necessary because Hibernate won't do it (as specified, see HHH-5529)
CREATE TABLE CUSTOM_FIELD_VALUE_OPTION (CFV_ID BIGINT NOT NULL, LABEL VARCHAR(255) NOT NULL, POSITION INT NOT NULL, CONSTRAINT fk_cfv_option_cfv FOREIGN KEY (CFV_ID) REFERENCES CUSTOM_FIELD_VALUE(CFV_ID) ON DELETE CASCADE) COMMENT='The table.';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feature-3823-1', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 5, '8:bbcf8622b215aa6f1c3c19862268a45e', 'createTable tableName=CUSTOM_FIELD_VALUE_OPTION', 'Creating the values table for multi-valued custom fields, much like CUSTOM_FIELD_OPTION is. 
  	Note : the DELETE CASCADE on the foreign key is necessary because Hibernate won''t do it (as specified, see HHH-5529)', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feature-3823-2::bsiri
--  Same table for the denormalized field values
CREATE TABLE DENORMALIZED_FIELD_VALUE_OPTION (DFV_ID BIGINT NOT NULL, LABEL VARCHAR(255) NOT NULL, POSITION INT NOT NULL, CONSTRAINT fk_dfv_option_dfv FOREIGN KEY (DFV_ID) REFERENCES DENORMALIZED_FIELD_VALUE(DFV_ID) ON DELETE CASCADE);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feature-3823-2', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 6, '8:c6894fb57d027f3243603da4a04e65ee', 'createTable tableName=DENORMALIZED_FIELD_VALUE_OPTION', 'Same table for the denormalized field values', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feature-3823-3::bsiri
--  tables CUSTOM_FIELD_OPTION and DENORMALIZED_FIELD_OPTION no longer enforce the option position.
ALTER TABLE CUSTOM_FIELD_OPTION MODIFY POSITION INT NULL;

ALTER TABLE DENORMALIZED_FIELD_OPTION MODIFY POSITION INT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feature-3823-3', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 7, '8:f3f4cbfade0669a80a7b3eedf09efe65', 'dropNotNullConstraint columnName=POSITION, tableName=CUSTOM_FIELD_OPTION; dropNotNullConstraint columnName=POSITION, tableName=DENORMALIZED_FIELD_OPTION', 'tables CUSTOM_FIELD_OPTION and DENORMALIZED_FIELD_OPTION no longer enforce the option position.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.issue-4017-1::bsiri
--  Some columns in REQUIREMENT_PROPERTY_CHANGE are too short compared to what 
--    	they are supposed to store. This changeset makes them bigger.
ALTER TABLE REQUIREMENT_PROPERTY_CHANGE MODIFY OLD_VALUE VARCHAR(255);

ALTER TABLE REQUIREMENT_PROPERTY_CHANGE MODIFY NEW_VALUE VARCHAR(255);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.issue-4017-1', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 8, '8:fd4099f77e0d72f3912b5c487ca698ed', 'modifyDataType columnName=OLD_VALUE, tableName=REQUIREMENT_PROPERTY_CHANGE; modifyDataType columnName=NEW_VALUE, tableName=REQUIREMENT_PROPERTY_CHANGE', 'Some columns in REQUIREMENT_PROPERTY_CHANGE are too short compared to what 
  	they are supposed to store. This changeset makes them bigger.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-4068-1::bsiri
--  creating the table structure for parameterized list
CREATE TABLE INFO_LIST (INFO_LIST_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'the ID', LABEL VARCHAR(100) NULL COMMENT 'the label for this list. Would noly be displayed in the administration page as the name  actually displayed to regular uses would depend on the role of that list on a given projet (criticality, nature etc)', `DESCRIPTION` TEXT NULL COMMENT 'a description for that list', CODE VARCHAR(30) NOT NULL COMMENT 'a code that helps identifying that list', CREATED_BY VARCHAR(50) NOT NULL COMMENT 'username of the user who created that list', CREATED_ON datetime NOT NULL COMMENT 'the time at when that list was created', LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL COMMENT 'username of the last user who modified one of the list attributes', LAST_MODIFIED_ON datetime DEFAULT null NULL COMMENT 'Time when the list was touched last', CONSTRAINT PK_INFO_LIST PRIMARY KEY (INFO_LIST_ID), UNIQUE (LABEL), UNIQUE (CODE));

CREATE INDEX idx_info_list_code ON INFO_LIST(CODE);

CREATE TABLE INFO_LIST_ITEM (ITEM_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'an ID, what did you expect ?', ITEM_TYPE VARCHAR(3) NOT NULL COMMENT 'discriminator telling whether this item is user-made or builtin in the app. Pick one of ''USR'' or ''SYS''', LIST_ID BIGINT NULL COMMENT 'foreign key to the list this item belongs to. Allows ''NULL'' for Hibernate to work.', ITEM_INDEX INT NULL COMMENT 'the position of that item in the list. Allows ''NULL'' for Hibernate to work.', LABEL VARCHAR(100) NOT NULL COMMENT 'a label to be displayed. If the item is builtin this label will be a i18n key, else the label will be displayed verbatim', CODE VARCHAR(30) NOT NULL COMMENT 'a code that helps identifying that item', IS_DEFAULT BIT(1) DEFAULT 0 NOT NULL COMMENT 'whether this item is the default item for         its list. Only one item per list should have it true ', ICON_NAME VARCHAR(100) NULL COMMENT 'the identifier of the icon to be displayed', CONSTRAINT PK_INFO_LIST_ITEM PRIMARY KEY (ITEM_ID), CONSTRAINT fk_info_item_list FOREIGN KEY (LIST_ID) REFERENCES INFO_LIST(INFO_LIST_ID), UNIQUE (CODE));

CREATE INDEX idx_info_list_item_code ON INFO_LIST_ITEM(CODE);

CREATE INDEX idx_info_list_label ON INFO_LIST(LABEL);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-4068-1', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 9, '8:699c9f1d850fa6df903852d0ffe93348', 'createTable tableName=INFO_LIST; createIndex indexName=idx_info_list_code, tableName=INFO_LIST; createTable tableName=INFO_LIST_ITEM; createIndex indexName=idx_info_list_item_code, tableName=INFO_LIST_ITEM; createIndex indexName=idx_info_list_labe...', 'creating the table structure for parameterized list', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-4068-2::bsiri
--  Updating the definition of an execution
ALTER TABLE EXECUTION ADD TC_NAT_LABEL VARCHAR(100) NULL COMMENT 'a label to be displayed. If the item is builtin this label will be a i18n key, else the label will        be displayed verbatim' , ADD TC_NAT_CODE VARCHAR(30) NULL COMMENT 'a code that helps identifying that item. Note that unlike the original version the values for       that column will not be unique.' , ADD TC_NAT_ICON_NAME VARCHAR(100) NULL COMMENT 'the identifier of the icon to be displayed' , ADD TC_TYP_LABEL VARCHAR(100) NULL COMMENT 'a label to be displayed. If the item is builtin this label will be a i18n key, else the label will  be displayed verbatim' , ADD TC_TYP_CODE VARCHAR(30) NULL COMMENT 'a code that helps identifying that item. Note that unlike the original version the values for       that column will not be unique.' , ADD TC_TYP_ICON_NAME VARCHAR(100) NULL COMMENT 'the identifier of the icon to be displayed';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-4068-2', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 10, '8:227e13ef4bed0445d8266877b348765c', 'addColumn tableName=EXECUTION', 'Updating the definition of an execution', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-4068-3::bsiri
--  inserting the default lists in the database
INSERT INTO INFO_LIST (INFO_LIST_ID, LABEL, `DESCRIPTION`, CODE, CREATED_BY, CREATED_ON, LAST_MODIFIED_BY, LAST_MODIFIED_ON) VALUES ('1', 'infolist.category.default', '', 'DEF_REQ_CAT', 'system', '2010-01-01 00:00:00', 'system', '2010-01-01 00:00:00');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('1', 'SYS', '1', '0', 'requirement.category.CAT_FUNCTIONAL', 'CAT_FUNCTIONAL', 0, 'def_cat_functional');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('2', 'SYS', '1', '1', 'requirement.category.CAT_NON_FUNCTIONAL', 'CAT_NON_FUNCTIONAL', 0, 'def_cat_non-functional');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('3', 'SYS', '1', '2', 'requirement.category.CAT_USE_CASE', 'CAT_USE_CASE', 0, 'def_cat_use-case');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('4', 'SYS', '1', '3', 'requirement.category.CAT_BUSINESS', 'CAT_BUSINESS', 0, 'def_cat_business');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('5', 'SYS', '1', '4', 'requirement.category.CAT_TEST_REQUIREMENT', 'CAT_TEST_REQUIREMENT', 0, 'def_cat_test-requirement');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('6', 'SYS', '1', '5', 'requirement.category.CAT_UNDEFINED', 'CAT_UNDEFINED', 1, 'def_cat_undefined');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('7', 'SYS', '1', '6', 'requirement.category.CAT_ERGONOMIC', 'CAT_ERGONOMIC', 0, 'def_cat_ergonomic');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('8', 'SYS', '1', '7', 'requirement.category.CAT_PERFORMANCE', 'CAT_PERFORMANCE', 0, 'def_cat_performance');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('9', 'SYS', '1', '8', 'requirement.category.CAT_TECHNICAL', 'CAT_TECHNICAL', 0, 'def_cat_technical');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('10', 'SYS', '1', '9', 'requirement.category.CAT_USER_STORY', 'CAT_USER_STORY', 0, 'def_cat_user-story');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('11', 'SYS', '1', '10', 'requirement.category.CAT_SECURITY', 'CAT_SECURITY', 0, 'def_cat_security');

INSERT INTO INFO_LIST (INFO_LIST_ID, LABEL, `DESCRIPTION`, CODE, CREATED_BY, CREATED_ON, LAST_MODIFIED_BY, LAST_MODIFIED_ON) VALUES ('2', 'infolist.nature.default', '', 'DEF_TC_NAT', 'system', '2010-01-01 00:00:00', 'system', '2010-01-01 00:00:00');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('12', 'SYS', '2', '0', 'test-case.nature.NAT_UNDEFINED', 'NAT_UNDEFINED', 1, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('13', 'SYS', '2', '1', 'test-case.nature.NAT_FUNCTIONAL_TESTING', 'NAT_FUNCTIONAL_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('14', 'SYS', '2', '2', 'test-case.nature.NAT_BUSINESS_TESTING', 'NAT_BUSINESS_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('15', 'SYS', '2', '3', 'test-case.nature.NAT_USER_TESTING', 'NAT_USER_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('16', 'SYS', '2', '4', 'test-case.nature.NAT_NON_FUNCTIONAL_TESTING', 'NAT_NON_FUNCTIONAL_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('17', 'SYS', '2', '5', 'test-case.nature.NAT_PERFORMANCE_TESTING', 'NAT_PERFORMANCE_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('18', 'SYS', '2', '6', 'test-case.nature.NAT_SECURITY_TESTING', 'NAT_SECURITY_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('19', 'SYS', '2', '7', 'test-case.nature.NAT_ATDD', 'NAT_ATDD', 0, 'noicon');

INSERT INTO INFO_LIST (INFO_LIST_ID, LABEL, `DESCRIPTION`, CODE, CREATED_BY, CREATED_ON, LAST_MODIFIED_BY, LAST_MODIFIED_ON) VALUES ('3', 'infolist.type.default', '', 'DEF_TC_TYP', 'system', '2010-01-01 00:00:00', 'system', '2010-01-01 00:00:00');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('20', 'SYS', '3', '0', 'test-case.type.TYP_UNDEFINED', 'TYP_UNDEFINED', 1, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('21', 'SYS', '3', '1', 'test-case.type.TYP_COMPLIANCE_TESTING', 'TYP_COMPLIANCE_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('22', 'SYS', '3', '2', 'test-case.type.TYP_CORRECTION_TESTING', 'TYP_CORRECTION_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('23', 'SYS', '3', '3', 'test-case.type.TYP_EVOLUTION_TESTING', 'TYP_EVOLUTION_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('24', 'SYS', '3', '4', 'test-case.type.TYP_REGRESSION_TESTING', 'TYP_REGRESSION_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('25', 'SYS', '3', '5', 'test-case.type.TYP_END_TO_END_TESTING', 'TYP_END_TO_END_TESTING', 0, 'noicon');

INSERT INTO INFO_LIST_ITEM (ITEM_ID, ITEM_TYPE, LIST_ID, ITEM_INDEX, LABEL, CODE, IS_DEFAULT, ICON_NAME) VALUES ('26', 'SYS', '3', '6', 'test-case.type.TYP_PARTNER_TESTING', 'TYP_PARTNER_TESTING', 0, 'noicon');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-4068-3', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 11, '8:50774e205e67740e4e184d893efd86a3', 'insert tableName=INFO_LIST; insert tableName=INFO_LIST_ITEM; insert tableName=INFO_LIST_ITEM; insert tableName=INFO_LIST_ITEM; insert tableName=INFO_LIST_ITEM; insert tableName=INFO_LIST_ITEM; insert tableName=INFO_LIST_ITEM; insert tableName=INFO...', 'inserting the default lists in the database', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-4068-4::bsiri
--  other structural modifications
ALTER TABLE PROJECT ADD REQ_CATEGORIES_LIST BIGINT DEFAULT 1 NOT NULL COMMENT 'foreign key to the requirement categories used in that project' , ADD TC_NATURES_LIST BIGINT DEFAULT 2 NOT NULL COMMENT 'foreign key to the test case natures used in that project' , ADD TC_TYPES_LIST BIGINT DEFAULT 3 NOT NULL COMMENT 'foreign key to the test case types used in that project';

ALTER TABLE PROJECT ADD CONSTRAINT proj_req_categories FOREIGN KEY (REQ_CATEGORIES_LIST) REFERENCES INFO_LIST (INFO_LIST_ID);

ALTER TABLE PROJECT ADD CONSTRAINT proj_tc_natures FOREIGN KEY (TC_NATURES_LIST) REFERENCES INFO_LIST (INFO_LIST_ID);

ALTER TABLE PROJECT ADD CONSTRAINT proj_tc_types FOREIGN KEY (TC_TYPES_LIST) REFERENCES INFO_LIST (INFO_LIST_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-4068-4', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 12, '8:932e211beea488279ced250ca90e7797', 'addColumn tableName=PROJECT', 'other structural modifications', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-4068-6::bsiri
--  migrate the test cases
ALTER TABLE TEST_CASE CHANGE TC_NATURE TC_NATURE_OLD VARCHAR(30);

ALTER TABLE TEST_CASE ADD TC_NATURE BIGINT DEFAULT 12 NOT NULL COMMENT 'foreign key to the info list item';

ALTER TABLE TEST_CASE ADD CONSTRAINT fk_tc_nature FOREIGN KEY (TC_NATURE) REFERENCES INFO_LIST_ITEM (ITEM_ID);

update TEST_CASE set TC_NATURE = 12 where TC_NATURE_OLD = 'UNDEFINED';

update TEST_CASE set TC_NATURE = 13 where TC_NATURE_OLD = 'FUNCTIONAL_TESTING';

update TEST_CASE set TC_NATURE = 14 where TC_NATURE_OLD = 'BUSINESS_TESTING';

update TEST_CASE set TC_NATURE = 15 where TC_NATURE_OLD = 'USER_TESTING';

update TEST_CASE set TC_NATURE = 16 where TC_NATURE_OLD = 'NON_FUNCTIONAL_TESTING';

update TEST_CASE set TC_NATURE = 17 where TC_NATURE_OLD = 'PERFORMANCE_TESTING';

update TEST_CASE set TC_NATURE = 18 where TC_NATURE_OLD = 'SECURITY_TESTING';

update TEST_CASE set TC_NATURE = 19 where TC_NATURE_OLD = 'ATDD';

ALTER TABLE TEST_CASE DROP COLUMN TC_NATURE_OLD;

ALTER TABLE TEST_CASE CHANGE TC_TYPE TC_TYPE_OLD VARCHAR(30);

ALTER TABLE TEST_CASE ADD TC_TYPE BIGINT DEFAULT 20 NOT NULL COMMENT 'foreign key to the info list item';

ALTER TABLE TEST_CASE ADD CONSTRAINT fk_tc_type FOREIGN KEY (TC_TYPE) REFERENCES INFO_LIST_ITEM (ITEM_ID);

update TEST_CASE set TC_TYPE = 20 where TC_TYPE_OLD = 'UNDEFINED';

update TEST_CASE set TC_TYPE = 21 where TC_TYPE_OLD = 'COMPLIANCE_TESTING';

update TEST_CASE set TC_TYPE = 22 where TC_TYPE_OLD = 'CORRECTION_TESTING';

update TEST_CASE set TC_TYPE = 23 where TC_TYPE_OLD = 'EVOLUTION_TESTING';

update TEST_CASE set TC_TYPE = 24 where TC_TYPE_OLD = 'REGRESSION_TESTING';

update TEST_CASE set TC_TYPE = 25 where TC_TYPE_OLD = 'END_TO_END_TESTING';

update TEST_CASE set TC_TYPE = 26 where TC_TYPE_OLD = 'PARTNER_TESTING';

ALTER TABLE TEST_CASE DROP COLUMN TC_TYPE_OLD;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-4068-6', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 13, '8:97a9a415af4e8d507a458dc6fe0f379f', 'renameColumn newColumnName=TC_NATURE_OLD, oldColumnName=TC_NATURE, tableName=TEST_CASE; addColumn tableName=TEST_CASE; sql; dropColumn columnName=TC_NATURE_OLD, tableName=TEST_CASE; renameColumn newColumnName=TC_TYPE_OLD, oldColumnName=TC_TYPE, ta...', 'migrate the test cases', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-4068-7::bsiri
--  migrate the requirements
ALTER TABLE REQUIREMENT_VERSION CHANGE CATEGORY CATEGORY_OLD VARCHAR(30);

ALTER TABLE REQUIREMENT_VERSION ADD CATEGORY BIGINT DEFAULT 1 NOT NULL COMMENT 'foreign key to the info list item';

ALTER TABLE REQUIREMENT_VERSION ADD CONSTRAINT fk_req_nature FOREIGN KEY (CATEGORY) REFERENCES INFO_LIST_ITEM (ITEM_ID);

update REQUIREMENT_VERSION set CATEGORY = 1 where CATEGORY_OLD = 'FUNCTIONAL';

update REQUIREMENT_VERSION set CATEGORY = 2 where CATEGORY_OLD = 'NON_FUNCTIONAL';

update REQUIREMENT_VERSION set CATEGORY = 3 where CATEGORY_OLD = 'USE_CASE';

update REQUIREMENT_VERSION set CATEGORY = 4 where CATEGORY_OLD = 'BUSINESS';

update REQUIREMENT_VERSION set CATEGORY = 5 where CATEGORY_OLD = 'TEST_REQUIREMENT';

update REQUIREMENT_VERSION set CATEGORY = 6 where CATEGORY_OLD = 'UNDEFINED';

update REQUIREMENT_VERSION set CATEGORY = 7 where CATEGORY_OLD = 'ERGONOMIC';

update REQUIREMENT_VERSION set CATEGORY = 8 where CATEGORY_OLD = 'PERFORMANCE';

update REQUIREMENT_VERSION set CATEGORY = 9 where CATEGORY_OLD = 'TECHNICAL';

update REQUIREMENT_VERSION set CATEGORY = 10 where CATEGORY_OLD = 'USER_STORY';

update REQUIREMENT_VERSION set CATEGORY = 11 where CATEGORY_OLD = 'SECURITY';

ALTER TABLE REQUIREMENT_VERSION DROP COLUMN CATEGORY_OLD;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-4068-7', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 14, '8:6cf6f64c283662f01379ae8a0d0c25f9', 'renameColumn newColumnName=CATEGORY_OLD, oldColumnName=CATEGORY, tableName=REQUIREMENT_VERSION; addColumn tableName=REQUIREMENT_VERSION; sql; dropColumn columnName=CATEGORY_OLD, tableName=REQUIREMENT_VERSION', 'migrate the requirements', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-4068-8::bsiri
--  migrating the columns from EXECUTION
update EXECUTION
      set TC_NAT_LABEL = 'test-case.nature.NAT_UNDEFINED',
      TC_NAT_CODE = 'NAT_UNDEFINED',
      TC_NAT_ICON_NAME = 'noicon'
      where TC_NATURE='UNDEFINED';

update EXECUTION
      set TC_NAT_LABEL = 'test-case.nature.NAT_FUNCTIONAL_TESTING',
      TC_NAT_CODE = 'NAT_FUNCTIONAL_TESTING',
      TC_NAT_ICON_NAME = 'noicon'
      where TC_NATURE='FUNCTIONAL_TESTING';

update EXECUTION
      set TC_NAT_LABEL = 'test-case.nature.NAT_BUSINESS_TESTING',
      TC_NAT_CODE = 'NAT_BUSINESS_TESTING',
      TC_NAT_ICON_NAME = 'noicon'
      where TC_NATURE='BUSINESS_TESTING';

update EXECUTION
      set TC_NAT_LABEL = 'test-case.nature.NAT_USER_TESTING',
      TC_NAT_CODE = 'NAT_USER_TESTING',
      TC_NAT_ICON_NAME = 'noicon'
      where TC_NATURE='USER_TESTING';

update EXECUTION
      set TC_NAT_LABEL = 'test-case.nature.NAT_NON_FUNCTIONAL_TESTING',
      TC_NAT_CODE = 'NAT_NON_FUNCTIONAL_TESTING',
      TC_NAT_ICON_NAME = 'noicon'
      where TC_NATURE='NON_FUNCTIONAL_TESTING';

update EXECUTION
      set TC_NAT_LABEL = 'test-case.nature.NAT_PERFORMANCE_TESTING',
      TC_NAT_CODE = 'NAT_PERFORMANCE_TESTING',
      TC_NAT_ICON_NAME = 'noicon'
      where TC_NATURE='PERFORMANCE_TESTING';

update EXECUTION
      set TC_NAT_LABEL = 'test-case.nature.NAT_SECURITY_TESTING',
      TC_NAT_CODE = 'NAT_SECURITY_TESTING',
      TC_NAT_ICON_NAME = 'noicon'
      where TC_NATURE='SECURITY_TESTING';

update EXECUTION
      set TC_NAT_LABEL = 'test-case.nature.NAT_ATDD',
      TC_NAT_CODE = 'NAT_ATDD',
      TC_NAT_ICON_NAME = 'noicon'
      where TC_NATURE='ATDD';

update EXECUTION
      set TC_TYP_LABEL = 'test-case.type.TYP_UNDEFINED',
      TC_TYP_CODE = 'TYP_UNDEFINED',
      TC_TYP_ICON_NAME = 'noicon'
      where TC_TYPE='UNDEFINED';

update EXECUTION
      set TC_TYP_LABEL = 'test-case.type.TYP_COMPLIANCE_TESTING',
      TC_TYP_CODE = 'TYP_COMPLIANCE_TESTING',
      TC_TYP_ICON_NAME = 'noicon'
      where TC_TYPE='COMPLIANCE_TESTING';

update EXECUTION
      set TC_TYP_LABEL = 'test-case.type.TYP_CORRECTION_TESTING',
      TC_TYP_CODE = 'TYP_CORRECTION_TESTING',
      TC_TYP_ICON_NAME = 'noicon'
      where TC_TYPE='CORRECTION_TESTING';

update EXECUTION
      set TC_TYP_LABEL = 'test-case.type.TYP_EVOLUTION_TESTING',
      TC_TYP_CODE = 'TYP_EVOLUTION_TESTING',
      TC_TYP_ICON_NAME = 'noicon'
      where TC_TYPE='EVOLUTION_TESTING';

update EXECUTION
      set TC_TYP_LABEL = 'test-case.type.TYP_REGRESSION_TESTING',
      TC_TYP_CODE = 'TYP_REGRESSION_TESTING',
      TC_TYP_ICON_NAME = 'noicon'
      where TC_TYPE='REGRESSION_TESTING';

update EXECUTION
      set TC_TYP_LABEL = 'test-case.type.TYP_END_TO_END_TESTING',
      TC_TYP_CODE = 'TYP_END_TO_END_TESTING',
      TC_TYP_ICON_NAME = 'noicon'
      where TC_TYPE='END_TO_END_TESTING';

update EXECUTION
      set TC_TYP_LABEL = 'test-case.type.TYP_PARTNER_TESTING',
      TC_TYP_CODE = 'TYP_PARTNER_TESTING',
      TC_TYP_ICON_NAME = 'noicon'
      where TC_TYPE='PARTNER_TESTING';

ALTER TABLE EXECUTION DROP COLUMN TC_NATURE;

ALTER TABLE EXECUTION DROP COLUMN TC_TYPE;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-4068-8', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 15, '8:1989bab44697afb24e198d91d88c6a73', 'sql; dropColumn columnName=TC_NATURE, tableName=EXECUTION; dropColumn columnName=TC_TYPE, tableName=EXECUTION', 'migrating the columns from EXECUTION', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-3764-1::flaurens
--  Tables for OAuth2 Support
CREATE TABLE oauth_client_details (CLIENT_ID VARCHAR(255) NOT NULL, CLIENT_SECRET VARCHAR(255) NULL, RESOURCE_IDS VARCHAR(255) DEFAULT null NULL, SCOPE VARCHAR(255) DEFAULT 'location,locationhistory' NULL, AUTHORIZED_GRANT_TYPES VARCHAR(255) DEFAULT 'password,authorization_code,refresh_token,implicit' NULL, WEB_SERVER_REDIRECT_URI VARCHAR(255) DEFAULT null NULL, AUTHORITIES VARCHAR(255) DEFAULT 'ROLE_CLIENT, ROLE_TRUSTED_CLIENT' NULL, ACCESS_TOKEN_VALIDITY BIGINT DEFAULT 60 NULL, REFRESH_TOKEN_VALIDITY BIGINT DEFAULT null NULL, ADDITIONAL_INFORMATION LONGTEXT DEFAULT null NULL, AUTOAPPROVE VARCHAR(255) NULL, CONSTRAINT PK_OAUTH_CLIENT_DETAILS PRIMARY KEY (CLIENT_ID));

CREATE TABLE oauth_client_token (TOKEN_ID VARCHAR(255) NOT NULL, TOKEN LONGBLOB NULL, AUTHENTICATION_ID VARCHAR(255) NULL, USER_NAME VARCHAR(255) NULL, CLIENT_ID VARCHAR(255) NULL, CONSTRAINT PK_OAUTH_CLIENT_TOKEN PRIMARY KEY (TOKEN_ID), UNIQUE (AUTHENTICATION_ID));

CREATE TABLE oauth_access_token (TOKEN_ID VARCHAR(255) NOT NULL, TOKEN LONGBLOB NULL, AUTHENTICATION_ID VARCHAR(255) NULL, USER_NAME VARCHAR(255) NULL, CLIENT_ID VARCHAR(255) NULL, AUTHENTICATION LONGBLOB NULL, REFRESH_TOKEN VARCHAR(255) NULL, CONSTRAINT PK_OAUTH_ACCESS_TOKEN PRIMARY KEY (TOKEN_ID), UNIQUE (AUTHENTICATION_ID));

CREATE TABLE oauth_refresh_token (TOKEN_ID VARCHAR(255) NOT NULL, TOKEN LONGBLOB NULL, AUTHENTICATION LONGBLOB NULL, CONSTRAINT PK_OAUTH_REFRESH_TOKEN PRIMARY KEY (TOKEN_ID));

CREATE TABLE oauth_code (CODE VARCHAR(255) NOT NULL, AUTHENTICATION LONGBLOB NULL, CONSTRAINT PK_OAUTH_CODE PRIMARY KEY (CODE));

CREATE TABLE oauth_approvals (USERID VARCHAR(255) NOT NULL, CLIENTID VARCHAR(255) NOT NULL, SCOPE VARCHAR(255) NULL, STATUS VARCHAR(10) NULL, EXPIRESAT datetime NULL, LASTMODIFIEDAT datetime NULL);

ALTER TABLE oauth_approvals ADD PRIMARY KEY (USERID, CLIENTID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-3764-1', 'flaurens', '../tm/tm.changelog-1.12.0.xml', NOW(), 16, '8:e76f4c9d87bcdf267ec3edc0b42876da', 'createTable tableName=oauth_client_details; createTable tableName=oauth_client_token; createTable tableName=oauth_access_token; createTable tableName=oauth_refresh_token; createTable tableName=oauth_code; createTable tableName=oauth_approvals; add...', 'Tables for OAuth2 Support', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-4171-1::jsimon
INSERT INTO CORE_CONFIG (STR_KEY, VALUE) VALUES ('uploadfilter.fileExtensions.whitelist', 'txt, doc, xls, ppt, docx, xlsx, pptx, odt, ods, odp, pdf');

INSERT INTO CORE_CONFIG (STR_KEY, VALUE) VALUES ('uploadfilter.upload.sizeLimitInBytes', '4000000');

INSERT INTO CORE_CONFIG (STR_KEY, VALUE) VALUES ('uploadfilter.upload.import.sizeLimitInBytes', '2000000');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-4171-1', 'jsimon', '../tm/tm.changelog-1.12.0.xml', NOW(), 17, '8:ca6c8021a7f62cb1fdc93baf4e19470e', 'insert tableName=CORE_CONFIG; insert tableName=CORE_CONFIG; insert tableName=CORE_CONFIG', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Changeset ../tm/tm.changelog-1.12.0.xml::tm-1.12.0.feat-3611-1::bsiri
--  Creating the tables modeling the relationships between milestones and test cases, requirement versions 
--      		and campaigns
CREATE TABLE MILESTONE_TEST_CASE (MILESTONE_ID BIGINT NOT NULL COMMENT 'foreign key to table MILESTONE', TEST_CASE_ID BIGINT NOT NULL COMMENT 'foreign key to table TEST_CASE', CONSTRAINT milestone_tc_milestone FOREIGN KEY (MILESTONE_ID) REFERENCES MILESTONE(MILESTONE_ID), CONSTRAINT milestone_tc_tc FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASE(TCLN_ID));

CREATE TABLE MILESTONE_REQ_VERSION (MILESTONE_ID BIGINT NOT NULL COMMENT 'foreign key to table MILESTONE', REQ_VERSION_ID BIGINT NOT NULL COMMENT 'foreign key to table REQUIREMENT_VERSION', CONSTRAINT milestone_rqv_rqv FOREIGN KEY (REQ_VERSION_ID) REFERENCES REQUIREMENT_VERSION(RES_ID), CONSTRAINT milestone_rqv_milestone FOREIGN KEY (MILESTONE_ID) REFERENCES MILESTONE(MILESTONE_ID));

CREATE TABLE MILESTONE_CAMPAIGN (MILESTONE_ID BIGINT NOT NULL COMMENT 'foreign key to table MILESTONE', CAMPAIGN_ID BIGINT NOT NULL COMMENT 'foreign key to table CAMPAIGN', CONSTRAINT milestone_camp_camp FOREIGN KEY (CAMPAIGN_ID) REFERENCES CAMPAIGN(CLN_ID), CONSTRAINT milestone_camp_milestone FOREIGN KEY (MILESTONE_ID) REFERENCES MILESTONE(MILESTONE_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.0.feat-3611-1', 'bsiri', '../tm/tm.changelog-1.12.0.xml', NOW(), 18, '8:a8873f6339b44d8d0309c4b7c080e739', 'createTable tableName=MILESTONE_TEST_CASE; createTable tableName=MILESTONE_REQ_VERSION; createTable tableName=MILESTONE_CAMPAIGN', 'Creating the tables modeling the relationships between milestones and test cases, requirement versions 
    		and campaigns', 'EXECUTED', NULL, NULL, '4.17.2', '9340184695');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

