--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.12.3.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3::bsiri
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.12.3' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 1, '8:dc6d2d6170ded24cc95fc871d154fb67', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184740');

--  Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-5965-1-1-mysql::bsiri
--  Fixing data in TCLN_RELATIONSHIP_CLOSURE that need to be
create table CLOSURECOPY as
			select distinct * from TCLN_RELATIONSHIP_CLOSURE
			group by ancestor_id, descendant_id
			having count(*) > 1;

delete clos
			from TCLN_RELATIONSHIP_CLOSURE clos
			inner join CLOSURECOPY cop on (cop.ancestor_id = clos.ancestor_id
			and cop.descendant_id = clos.descendant_id
			and cop.depth = clos.depth);

insert into TCLN_RELATIONSHIP_CLOSURE
			select * from CLOSURECOPY;

drop table CLOSURECOPY;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-5965-1-1-mysql', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 2, '8:d503967dc40ddb816822f91c9f7b8dab', 'sql', 'Fixing data in TCLN_RELATIONSHIP_CLOSURE that need to be', 'EXECUTED', NULL, NULL, '4.17.2', '9340184740');

--  Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-5965-1-2-mysql::bsiri
--  Fixing data in RLN_RELATIONSHIP_CLOSURE that need to be
create table CLOSURECOPY as
			select distinct * from RLN_RELATIONSHIP_CLOSURE
			group by ancestor_id, descendant_id
			having count(*) > 1;

delete clos
			from RLN_RELATIONSHIP_CLOSURE clos
			inner join CLOSURECOPY cop on (cop.ancestor_id = clos.ancestor_id
			and cop.descendant_id = clos.descendant_id
			and cop.depth = clos.depth);

insert into RLN_RELATIONSHIP_CLOSURE
			select * from CLOSURECOPY;

drop table CLOSURECOPY;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-5965-1-2-mysql', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 3, '8:8caf1c706891a32c2dc5c03d4cab6b31', 'sql', 'Fixing data in RLN_RELATIONSHIP_CLOSURE that need to be', 'EXECUTED', NULL, NULL, '4.17.2', '9340184740');

--  Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-5965-1-3-mysql::bsiri
--  Fixing data in CLN_RELATIONSHIP_CLOSURE that need to be
create table CLOSURECOPY as
			select distinct * from CLN_RELATIONSHIP_CLOSURE
			group by ancestor_id, descendant_id
			having count(*) > 1;

delete clos
			from CLN_RELATIONSHIP_CLOSURE clos
			inner join CLOSURECOPY cop on (cop.ancestor_id = clos.ancestor_id
			and cop.descendant_id = clos.descendant_id
			and cop.depth = clos.depth);

insert into CLN_RELATIONSHIP_CLOSURE
			select * from CLOSURECOPY;

drop table CLOSURECOPY;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-5965-1-3-mysql', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 4, '8:1c2e6953ad3a54e81ac0e35bd7243a59', 'sql', 'Fixing data in CLN_RELATIONSHIP_CLOSURE that need to be', 'EXECUTED', NULL, NULL, '4.17.2', '9340184740');

--  Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-5965-2-1::bsiri
--  now we can add the unique constraints on the closure tables
ALTER TABLE TCLN_RELATIONSHIP_CLOSURE ADD CONSTRAINT uniq_tcln_clos UNIQUE (ancestor_id, descendant_id);

ALTER TABLE RLN_RELATIONSHIP_CLOSURE ADD CONSTRAINT uniq_rln_clos UNIQUE (ancestor_id, descendant_id);

ALTER TABLE CLN_RELATIONSHIP_CLOSURE ADD CONSTRAINT uniq_cln_clos UNIQUE (ancestor_id, descendant_id);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-5965-2-1', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 5, '8:6df9afbc155d2a2f2a8eeaa99293695a', 'addUniqueConstraint constraintName=uniq_tcln_clos, tableName=TCLN_RELATIONSHIP_CLOSURE; addUniqueConstraint constraintName=uniq_rln_clos, tableName=RLN_RELATIONSHIP_CLOSURE; addUniqueConstraint constraintName=uniq_cln_clos, tableName=CLN_RELATIONS...', 'now we can add the unique constraints on the closure tables', 'EXECUTED', NULL, NULL, '4.17.2', '9340184740');

--  Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-3-1::bsiri
--  redefining some triggers for table TCLN_RELATIONHIP and TEST_CASE_LIBRARY_NODE
drop trigger if exists ins_tcln_after;

create trigger ins_tcln_after after insert on
			TEST_CASE_LIBRARY_NODE
			for each row insert ignore into
			TCLN_RELATIONSHIP_CLOSURE values (new.tcln_id, new.tcln_id, 0);

drop trigger if exists attach_tcln_after;

create trigger attach_tcln_after after insert on
			TCLN_RELATIONSHIP
			for each row insert ignore into TCLN_RELATIONSHIP_CLOSURE
			select c1.ancestor_id, c2.descendant_id, c1.depth+c2.depth+1
			from
			TCLN_RELATIONSHIP_CLOSURE c1
			cross join TCLN_RELATIONSHIP_CLOSURE c2
			where c1.descendant_id = new.ancestor_id
			and c2.ancestor_id =
			new.descendant_id;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-3-1', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 6, '8:45f6005adfd2eb582c2a2e0363b2bd19', 'sql; sql', 'redefining some triggers for table TCLN_RELATIONHIP and TEST_CASE_LIBRARY_NODE', 'EXECUTED', NULL, NULL, '4.17.2', '9340184740');

--  Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-3-2::bsiri
--  redefining some triggers for table RLN_RELATIONHIP and REQUIREMENT_LIBRARY_NODE
drop trigger if exists ins_rln_after;

create trigger ins_rln_after after insert on
			REQUIREMENT_LIBRARY_NODE
			for each row insert ignore into
			RLN_RELATIONSHIP_CLOSURE values (new.rln_id, new.rln_id, 0);

drop trigger if exists attach_rln_after;

create trigger attach_rln_after after insert on RLN_RELATIONSHIP
			for each row insert ignore into RLN_RELATIONSHIP_CLOSURE
			select
			c1.ancestor_id, c2.descendant_id, c1.depth+c2.depth+1
			from
			RLN_RELATIONSHIP_CLOSURE c1
			cross join RLN_RELATIONSHIP_CLOSURE c2
			where c1.descendant_id = new.ancestor_id
			and c2.ancestor_id =
			new.descendant_id;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-3-2', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 7, '8:e96af54bacfc057629f3bb3467ff9b94', 'sql; sql', 'redefining some triggers for table RLN_RELATIONHIP and REQUIREMENT_LIBRARY_NODE', 'EXECUTED', NULL, NULL, '4.17.2', '9340184740');

--  Changeset ../tm/tm.changelog-1.12.3.xml::tm-1.12.3-issue-3-3::bsiri
--  redefining some triggers for table CLN_RELATIONHIP and CAMPAIGN_LIBRARY_NODE
drop trigger if exists ins_cln_after;

create trigger ins_cln_after after insert on
			CAMPAIGN_LIBRARY_NODE
			for each row insert ignore into
			CLN_RELATIONSHIP_CLOSURE values (new.cln_id, new.cln_id, 0);

drop trigger if exists attach_cln_after;

create trigger attach_cln_after after insert on CLN_RELATIONSHIP
			for each row insert ignore into CLN_RELATIONSHIP_CLOSURE
			select
			c1.ancestor_id, c2.descendant_id, c1.depth+c2.depth+1
			from
			CLN_RELATIONSHIP_CLOSURE c1
			cross join CLN_RELATIONSHIP_CLOSURE c2
			where c1.descendant_id = new.ancestor_id
			and c2.ancestor_id = new.descendant_id;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.12.3-issue-3-3', 'bsiri', '../tm/tm.changelog-1.12.3.xml', NOW(), 8, '8:6a6dc999aafc298928ad7355b260551f', 'sql; sql', 'redefining some triggers for table CLN_RELATIONHIP and CAMPAIGN_LIBRARY_NODE', 'EXECUTED', NULL, NULL, '4.17.2', '9340184740');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

