--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.14.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.14.0.xml::tm-1.14.0::bsiri
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.14.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.14.0', 'bsiri', '../tm/tm.changelog-1.14.0.xml', NOW(), 1, '8:b8a4cc8d0b66bdc42ac118684ecde133', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184928');

--  Changeset ../tm/tm.changelog-1.14.0.xml::tm-1.14.0-feature-5416::jthebault
CREATE TABLE PARTY_PREFERENCE (PREFERENCE_ID BIGINT AUTO_INCREMENT NOT NULL, PARTY_ID BIGINT NOT NULL COMMENT 'foreign key to the core_party table', PREFERENCE_KEY VARCHAR(50) NULL, PREFERENCE_VALUE VARCHAR(5000) NULL, CONSTRAINT PK_PARTY_PREFERENCE PRIMARY KEY (PREFERENCE_ID), CONSTRAINT fk_party_preference_core_party_party_id FOREIGN KEY (PARTY_ID) REFERENCES CORE_PARTY(PARTY_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.14.0-feature-5416', 'jthebault', '../tm/tm.changelog-1.14.0.xml', NOW(), 2, '8:fdc67ca09020a062cad0e5cde3c582c2', 'createTable tableName=PARTY_PREFERENCE', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184928');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

