--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.17.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-SQUASH-5232-add-databasechangelog-new-columns::jprioux
--  Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table
ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-SQUASH-5232-add-databasechangelog-new-columns', 'jprioux', '../tm/tm.changelog-1.17.0.xml', NOW(), 1, '8:aeea36396a9ec2a5a73082a8a593b123', 'sql', 'Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0::jthebault
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.17.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 2, '8:635106608f9ea0995f9c28da565b8652', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-feature-6921::zyang
--  Adds a status field to campaign and iteration
ALTER TABLE CAMPAIGN ADD CAMPAIGN_STATUS VARCHAR(30) DEFAULT 'UNDEFINED' NOT NULL;

ALTER TABLE ITERATION ADD ITERATION_STATUS VARCHAR(30) DEFAULT 'UNDEFINED' NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-feature-6921', 'zyang', '../tm/tm.changelog-1.17.0.xml', NOW(), 3, '8:7c2bee7c946ec37dcf1c94a8edeb197f', 'addColumn tableName=CAMPAIGN; addColumn tableName=ITERATION', 'Adds a status field to campaign and iteration', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0::zyang
CREATE TABLE REPORT_DEFINITION (REPORT_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'autogenerated ID', NAME VARCHAR(255) NULL COMMENT 'The name of this chart', `DESCRIPTION` LONGTEXT NULL COMMENT 'additional informations about this report', PLUGIN_NAMESPACE VARCHAR(255) NULL COMMENT 'The namespace of the report plugin', PARAMETERS LONGTEXT NULL COMMENT 'parameters to generate the report', USER_ID BIGINT NOT NULL COMMENT 'foreign key to the owner of this report definition', PROJECT_ID BIGINT NOT NULL COMMENT 'foreign key to the projet', CREATED_BY VARCHAR(50) NOT NULL, CREATED_ON datetime NOT NULL, LAST_MODIFIED_BY VARCHAR(50) DEFAULT null NULL, LAST_MODIFIED_ON datetime DEFAULT null NULL, CONSTRAINT PK_REPORT_DEFINITION PRIMARY KEY (REPORT_ID), CONSTRAINT fk_report_owner FOREIGN KEY (USER_ID) REFERENCES CORE_USER(PARTY_ID), CONSTRAINT fk_project_report_definition_project_id FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0', 'zyang', '../tm/tm.changelog-1.17.0.xml', NOW(), 4, '8:a51a3bbf6dfc42620313e2eef68df1cb', 'createTable tableName=REPORT_DEFINITION', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-feature-6921::cholc
--  Adds a execution status field to the test suites
ALTER TABLE TEST_SUITE ADD EXECUTION_STATUS VARCHAR(255) DEFAULT 'READY' NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-feature-6921', 'cholc', '../tm/tm.changelog-1.17.0.xml', NOW(), 5, '8:7ecf63ab62a5066758ac61daadb4b949', 'addColumn tableName=TEST_SUITE', 'Adds a execution status field to the test suites', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-feature-sqtm-167::bsiri
--  Adding the ability to use application-level credentials that allows Squash interact with a bugtracker on its own
--        (ie instead of requiring the current user to authenticate).
CREATE TABLE STORED_CREDENTIALS (CREDENTIAL_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'primary key', ENC_VERSION SMALLINT NULL COMMENT 'the version of encryption service used. Possibly the value will remain to 1 forever.', ENC_CREDENTIALS TEXT NULL COMMENT 'the credentials as an encrypted string', AUTHENTICATED_SERVER BIGINT NULL COMMENT 'foreign key to the server to authenticate', CONSTRAINT PK_STORED_CREDENTIALS PRIMARY KEY (CREDENTIAL_ID), CONSTRAINT fk_stored_credentials_authenticated_server FOREIGN KEY (AUTHENTICATED_SERVER) REFERENCES BUGTRACKER(BUGTRACKER_ID) ON DELETE CASCADE);

ALTER TABLE BUGTRACKER ADD AUTH_POLICY VARCHAR(30) DEFAULT 'USER' NULL COMMENT 'the policy that decides who needs to authenticate';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-feature-sqtm-167', 'bsiri', '../tm/tm.changelog-1.17.0.xml', NOW(), 6, '8:dae8f23fb21f93b77c6246708ce0d72d', 'createTable tableName=STORED_CREDENTIALS; addColumn tableName=BUGTRACKER', 'Adding the ability to use application-level credentials that allows Squash interact with a bugtracker on its own
      (ie instead of requiring the current user to authenticate).', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-jira-sync-01::jthebault
--  Add a remote synchronisation table in squash tm.
CREATE TABLE REMOTE_SYNCHRONISATION (REMOTE_SYNCHRONISATION_ID BIGINT AUTO_INCREMENT NOT NULL, PROJECT_ID BIGINT NOT NULL, SERVER_ID BIGINT NOT NULL, REMOTE_SYNCHRONISATION_NAME VARCHAR(255) NOT NULL, KIND VARCHAR(50) NOT NULL, REMOTE_SELECT_TYPE VARCHAR(50) NULL, REMOTE_SELECT_VALUE VARCHAR(1000) NULL, LAST_SUCCESSFUL_SYNC_DATE datetime NULL, LAST_SYNC_DATE datetime NULL, LAST_SYNC_STATUS VARCHAR(20) NULL, SYNC_STATUS VARCHAR(20) NULL, REMOTE_SYNCHRONISATION_OPTIONS LONGTEXT NULL, CONSTRAINT PK_REMOTE_SYNCHRONISATION PRIMARY KEY (REMOTE_SYNCHRONISATION_ID), CONSTRAINT fk_remote_sync__project__project_id FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID), CONSTRAINT fk_remote_sync__bugtracker__bugtracker_id FOREIGN KEY (SERVER_ID) REFERENCES BUGTRACKER(BUGTRACKER_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-jira-sync-01', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 7, '8:b70c85f02dd90cf9d8ce3b2a6e9cf76d', 'createTable tableName=REMOTE_SYNCHRONISATION', 'Add a remote synchronisation table in squash tm.', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-jira-sync-02::jthebault
--  Add a remote folder synchronisation table in squash tm.
CREATE TABLE REQUIREMENT_FOLDER_SYNC_EXTENDER (RF_SYNC_EXTENDER_ID BIGINT AUTO_INCREMENT NOT NULL, REMOTE_SYNCHRONISATION_ID BIGINT NOT NULL COMMENT 'Only one master folder should be targeted by a given synchronisation', REMOTE_FOLDER_ID VARCHAR(255) NULL, REMOTE_FOLDER_STATUS VARCHAR(50) NULL, REQUIREMENT_FOLDER_ID BIGINT NOT NULL COMMENT 'Only one extender for any folder in Squash TM', TYPE VARCHAR(30) NOT NULL, CONSTRAINT PK_REQUIREMENT_FOLDER_SYNC_EXTENDER PRIMARY KEY (RF_SYNC_EXTENDER_ID), CONSTRAINT fk_req_folder_sync_extender__req_folder__rln_id FOREIGN KEY (REQUIREMENT_FOLDER_ID) REFERENCES REQUIREMENT_FOLDER(RLN_ID), CONSTRAINT fk_req_folder_sync_extender__remote_sync_remote_sync_id FOREIGN KEY (REMOTE_SYNCHRONISATION_ID) REFERENCES REMOTE_SYNCHRONISATION(REMOTE_SYNCHRONISATION_ID), UNIQUE (REQUIREMENT_FOLDER_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-jira-sync-02', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 8, '8:77686424e0ff386fcc4e120065c7c6fc', 'createTable tableName=REQUIREMENT_FOLDER_SYNC_EXTENDER', 'Add a remote folder synchronisation table in squash tm.', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-jira-sync-03::jthebault
ALTER TABLE REQUIREMENT_SYNC_EXTENDER MODIFY REMOTE_FILTER_NAME VARCHAR(150) NULL;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD REMOTE_SYNCHRONISATION_ID BIGINT NULL, ADD REMOTE_LAST_UPDATED datetime NULL, ADD REMOTE_PARENT_ID VARCHAR(30) NULL;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD CONSTRAINT fk_req_sync_extender__remote_sync_remote_sync_id FOREIGN KEY (REMOTE_SYNCHRONISATION_ID) REFERENCES REMOTE_SYNCHRONISATION (REMOTE_SYNCHRONISATION_ID);

CREATE INDEX req_sync_extender_remote_parent_id_idx ON REQUIREMENT_SYNC_EXTENDER(REMOTE_PARENT_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-jira-sync-03', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 9, '8:98f597ab35b289fca921d3062ea9795e', 'dropNotNullConstraint columnName=REMOTE_FILTER_NAME, tableName=REQUIREMENT_SYNC_EXTENDER; addColumn tableName=REQUIREMENT_SYNC_EXTENDER; createIndex indexName=req_sync_extender_remote_parent_id_idx, tableName=REQUIREMENT_SYNC_EXTENDER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-Issue-6967::jthebault
CREATE INDEX tcln_name_idx ON TEST_CASE_LIBRARY_NODE(NAME);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-Issue-6967', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 10, '8:3cdbf1b9fd528540de692dda7c1b941e', 'createIndex indexName=tcln_name_idx, tableName=TEST_CASE_LIBRARY_NODE', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340185048');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

