--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.3.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0.01::gfouquet
--  Adds a TM database version number
UPDATE CORE_CONFIG SET STR_KEY = 'squashtest.tm.database.version', VALUE = '1.3.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0.01', 'gfouquet', '../tm/tm.changelog-1.3.0.xml', NOW(), 1, '8:d67bb6124a9935b8167b1b4662927757', 'update tableName=CORE_CONFIG', 'Adds a TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0.2::gfouquet
--  Add a default group to users who do not have one (should be users from alpha versions)
create temporary table GROUPLESS_USERS (USER_ID INTEGER);

insert
			into GROUPLESS_USERS (USER_ID)
			select cu.ID from CORE_USER cu
			where
			cu.ID not in (select cgm.USER_ID from CORE_GROUP_MEMBER cgm);

insert
			into CORE_GROUP_MEMBER (USER_ID, GROUP_ID)
			select cu.ID, cg.ID
			from
			CORE_USER cu, CORE_GROUP cg
			where cg.QUALIFIED_NAME =
			'squashtest.tm.group.User'
			and cu.ID in (select USER_ID from
			GROUPLESS_USERS);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0.2', 'gfouquet', '../tm/tm.changelog-1.3.0.xml', NOW(), 2, '8:0ec33fb5aa2c59df7bfc6cdc8cddfff0', 'sql', 'Add a default group to users who do not have one (should be users from alpha versions)', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.0::bsiri
--  The following serie of changeset labelled tm-1.3-feat-1112.x implements the closure table
--  			modelization for tree-like data	at
--  			http://www.mysqlperformanceblog.com/2011/02/14/moving-subtrees-in-closure-table/,
--  			with a focus on the mysql-specifics shortcomings regarding modifying a table already
--  			under modification.
--  
--  			Big kudos to you Bill Karwin !
INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.0', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 3, '8:d41d8cd98f00b204e9800998ecf8427e', 'empty', 'The following serie of changeset labelled tm-1.3-feat-1112.x implements the closure table
			modelization for tree-like data	at
			http://www.mysqlperformanceblog.com/2011/02/14/moving-subtrees-in-closure-table/,
			with a focus on the mysql-speci...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.01::bsiri
--  closure table for test case library nodes. Its content is set and modified by four triggers, see
--  			changeset 'tm-1.3-feat-1112.05-mysql' or 'tm-1.3-feat-1112.05-h2'.
CREATE TABLE TCLN_RELATIONSHIP_CLOSURE (ANCESTOR_ID BIGINT NOT NULL COMMENT 'cle etrangere vers le noeud parent. La relation est parfois d''un noeud vers lui meme.', DESCENDANT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers l''element fils. La relation est parfois d''un noeud vers lui meme.', DEPTH SMALLINT NOT NULL COMMENT 'stores how deep is the descendant element nested in the subtree of the ancestor element', CONSTRAINT fk_tcln_relationship_clos_desc FOREIGN KEY (DESCENDANT_ID) REFERENCES TEST_CASE_LIBRARY_NODE(TCLN_ID), CONSTRAINT fk_tcln_relationship_clos_anc FOREIGN KEY (ANCESTOR_ID) REFERENCES TEST_CASE_LIBRARY_NODE(TCLN_ID));

CREATE INDEX idx_tcln_relationship_clos_desc ON TCLN_RELATIONSHIP_CLOSURE(DESCENDANT_ID);

CREATE INDEX idx_tcln_relationship_clos_anc ON TCLN_RELATIONSHIP_CLOSURE(ANCESTOR_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.01', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 4, '8:b6e7e58a746810a5b5f47ff5b7eba060', 'createTable tableName=TCLN_RELATIONSHIP_CLOSURE; createIndex indexName=idx_tcln_relationship_clos_desc, tableName=TCLN_RELATIONSHIP_CLOSURE; createIndex indexName=idx_tcln_relationship_clos_anc, tableName=TCLN_RELATIONSHIP_CLOSURE', 'closure table for test case library nodes. Its content is set and modified by four triggers, see
			changeset ''tm-1.3-feat-1112.05-mysql'' or ''tm-1.3-feat-1112.05-h2''.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.02::bsiri
--  closure table for requirement library nodes. Its content is set and modified by four triggers, see
--  			changeset 'tm-1.3-feat-1112.06-mysql' or 'tm-1.3-feat-1112.06-h2'.
CREATE TABLE RLN_RELATIONSHIP_CLOSURE (ANCESTOR_ID BIGINT NOT NULL COMMENT 'cle etrangere vers le noeud parent. La relation est parfois d''un noeud vers lui meme.', DESCENDANT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers l''element fils. La relation est parfois d''un noeud vers lui meme.', DEPTH SMALLINT NOT NULL COMMENT 'stores how deep is the descendant element nested in the subtree of the ancestor element', CONSTRAINT fk_rln_relationship_clos_desc FOREIGN KEY (DESCENDANT_ID) REFERENCES REQUIREMENT_LIBRARY_NODE(RLN_ID), CONSTRAINT fk_rln_relationship_clos_anc FOREIGN KEY (ANCESTOR_ID) REFERENCES REQUIREMENT_LIBRARY_NODE(RLN_ID));

CREATE INDEX idx_rln_relationship_clos_desc ON RLN_RELATIONSHIP_CLOSURE(DESCENDANT_ID);

CREATE INDEX idx_rln_relationship_clos_anc ON RLN_RELATIONSHIP_CLOSURE(ANCESTOR_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.02', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 5, '8:5f2965c6052880bcc7b620a324442bef', 'createTable tableName=RLN_RELATIONSHIP_CLOSURE; createIndex indexName=idx_rln_relationship_clos_desc, tableName=RLN_RELATIONSHIP_CLOSURE; createIndex indexName=idx_rln_relationship_clos_anc, tableName=RLN_RELATIONSHIP_CLOSURE', 'closure table for requirement library nodes. Its content is set and modified by four triggers, see
			changeset ''tm-1.3-feat-1112.06-mysql'' or ''tm-1.3-feat-1112.06-h2''.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.03::bsiri
--  closure table for campaign library nodes. Its content is set and modified by four triggers, see
--  			changeset 'tm-1.3-feat-1112.07-mysql' or 'tm-1.3-feat-1112.07-h2'.
CREATE TABLE CLN_RELATIONSHIP_CLOSURE (ANCESTOR_ID BIGINT NOT NULL COMMENT 'cle etrangere vers le noeud parent. La relation est parfois d''un noeud vers lui meme.', DESCENDANT_ID BIGINT NOT NULL COMMENT 'cle etrangere vers l''element fils. La relation est parfois d''un noeud vers lui meme.', DEPTH SMALLINT NOT NULL COMMENT 'stores how deep is the descendant element nested in the subtree of the ancestor element', CONSTRAINT fk_cln_relationship_clos_desc FOREIGN KEY (DESCENDANT_ID) REFERENCES CAMPAIGN_LIBRARY_NODE(CLN_ID), CONSTRAINT fk_cln_relationship_clos_anc FOREIGN KEY (ANCESTOR_ID) REFERENCES CAMPAIGN_LIBRARY_NODE(CLN_ID));

CREATE INDEX idx_cln_relationship_clos_desc ON CLN_RELATIONSHIP_CLOSURE(DESCENDANT_ID);

CREATE INDEX idx_cln_relationship_clos_anc ON CLN_RELATIONSHIP_CLOSURE(ANCESTOR_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.03', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 6, '8:c0f7ef97f02b9034218ee874a8e37664', 'createTable tableName=CLN_RELATIONSHIP_CLOSURE; createIndex indexName=idx_cln_relationship_clos_desc, tableName=CLN_RELATIONSHIP_CLOSURE; createIndex indexName=idx_cln_relationship_clos_anc, tableName=CLN_RELATIONSHIP_CLOSURE', 'closure table for campaign library nodes. Its content is set and modified by four triggers, see
			changeset ''tm-1.3-feat-1112.07-mysql'' or ''tm-1.3-feat-1112.07-h2''.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.04::bsiri
--  first step of the migration : creation of temporary tables in which we will dump
--  			the X_RELATIONSHIP tables, then truncate the later. We will reinsert the data once
--  			the triggers are all set.
CREATE TABLE TCLN_RELATIONSHIP_TMP (ANCESTOR_ID BIGINT NULL, DESCENDANT_ID BIGINT NULL);

CREATE TABLE RLN_RELATIONSHIP_TMP (ANCESTOR_ID BIGINT NULL, DESCENDANT_ID BIGINT NULL);

CREATE TABLE CLN_RELATIONSHIP_TMP (ANCESTOR_ID BIGINT NULL, DESCENDANT_ID BIGINT NULL);

insert into TCLN_RELATIONSHIP_TMP
			select * from TCLN_RELATIONSHIP;

insert into RLN_RELATIONSHIP_TMP
			select * from RLN_RELATIONSHIP;

insert into CLN_RELATIONSHIP_TMP
			select * from CLN_RELATIONSHIP;

delete from TCLN_RELATIONSHIP;

delete from RLN_RELATIONSHIP;

delete from CLN_RELATIONSHIP;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.04', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 7, '8:82390dab2ef8d88d92b5633ceaa105e1', 'createTable tableName=TCLN_RELATIONSHIP_TMP; createTable tableName=RLN_RELATIONSHIP_TMP; createTable tableName=CLN_RELATIONSHIP_TMP; sql; sql; sql; sql; sql; sql', 'first step of the migration : creation of temporary tables in which we will dump
			the X_RELATIONSHIP tables, then truncate the later. We will reinsert the data once
			the triggers are all set.', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.05-mysql::bsiri
--  mysql-triggers for TCLN_RELATIONSHIP_CLOSURE table
create trigger ins_tcln_after after insert on
			TEST_CASE_LIBRARY_NODE
			for each row insert into
			TCLN_RELATIONSHIP_CLOSURE values (new.tcln_id, new.tcln_id, 0);

create trigger del_tcln_before before delete on
			TEST_CASE_LIBRARY_NODE
			for each row delete from
			TCLN_RELATIONSHIP_CLOSURE where ancestor_id=old.tcln_id and
			descendant_id=old.tcln_id;

create trigger attach_tcln_after after insert on
			TCLN_RELATIONSHIP
			for each row insert into TCLN_RELATIONSHIP_CLOSURE
			select c1.ancestor_id, c2.descendant_id, c1.depth+c2.depth+1
			from
			TCLN_RELATIONSHIP_CLOSURE c1
			cross join TCLN_RELATIONSHIP_CLOSURE c2
			where c1.descendant_id = new.ancestor_id
			and c2.ancestor_id =
			new.descendant_id;

create trigger detach_tcln_before before delete on
			TCLN_RELATIONSHIP
			for each row delete clos1 from
			TCLN_RELATIONSHIP_CLOSURE clos1
			join TCLN_RELATIONSHIP_CLOSURE clos2
			on clos1.descendant_id=clos2.descendant_id
			left join
			TCLN_RELATIONSHIP_CLOSURE clos3
			on clos3.ancestor_id =
			clos2.ancestor_id
			and clos3.descendant_id = clos1.ancestor_id
			where
			clos2.ancestor_id = old.descendant_id
			and clos3.ancestor_id is null;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.05-mysql', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 8, '8:17123de05225585b1b9cc62306b44334', 'sql; sql; sql; sql', 'mysql-triggers for TCLN_RELATIONSHIP_CLOSURE table', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.06-mysql::bsiri
--  mysql-triggers for RLN_RELATIONSHIP_CLOSURE table
create trigger ins_rln_after after insert on
			REQUIREMENT_LIBRARY_NODE
			for each row insert into
			RLN_RELATIONSHIP_CLOSURE values (new.rln_id, new.rln_id, 0);

create trigger del_rln_before before delete on
			REQUIREMENT_LIBRARY_NODE
			for each row delete from
			RLN_RELATIONSHIP_CLOSURE where ancestor_id=old.rln_id and
			descendant_id=old.rln_id;

create trigger attach_rln_after after insert on RLN_RELATIONSHIP
			for each row insert into RLN_RELATIONSHIP_CLOSURE
			select
			c1.ancestor_id, c2.descendant_id, c1.depth+c2.depth+1
			from
			RLN_RELATIONSHIP_CLOSURE c1
			cross join RLN_RELATIONSHIP_CLOSURE c2
			where c1.descendant_id = new.ancestor_id
			and c2.ancestor_id =
			new.descendant_id;

create trigger detach_rln_before before delete on
			RLN_RELATIONSHIP
			for each row delete clos1
            from RLN_RELATIONSHIP_CLOSURE clos1

            join RLN_RELATIONSHIP_CLOSURE clos2
			on clos1.descendant_id=clos2.descendant_id

            left join RLN_RELATIONSHIP_CLOSURE clos3
			on clos3.ancestor_id = clos2.ancestor_id
			and clos3.descendant_id = clos1.ancestor_id

            where clos2.ancestor_id = old.descendant_id
			and clos3.ancestor_id is null;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.06-mysql', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 9, '8:5ee5e18c073ca7ac1880dc5f9470ddb8', 'sql; sql; sql; sql', 'mysql-triggers for RLN_RELATIONSHIP_CLOSURE table', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.07-mysql::bsiri
--  mysql-triggers for CLN_RELATIONSHIP_CLOSURE table
create trigger ins_cln_after after insert on
			CAMPAIGN_LIBRARY_NODE
			for each row insert into
			CLN_RELATIONSHIP_CLOSURE values (new.cln_id, new.cln_id, 0);

create trigger del_cln_before before delete on
			CAMPAIGN_LIBRARY_NODE
			for each row delete from
			CLN_RELATIONSHIP_CLOSURE where ancestor_id=old.cln_id and
			descendant_id=old.cln_id;

create trigger attach_cln_after after insert on CLN_RELATIONSHIP
			for each row insert into CLN_RELATIONSHIP_CLOSURE
			select
			c1.ancestor_id, c2.descendant_id, c1.depth+c2.depth+1
			from
			CLN_RELATIONSHIP_CLOSURE c1
			cross join CLN_RELATIONSHIP_CLOSURE c2
			where c1.descendant_id = new.ancestor_id
			and c2.ancestor_id = new.descendant_id;

create trigger detach_cln_before before delete on
			CLN_RELATIONSHIP
			for each row delete clos1 from
			CLN_RELATIONSHIP_CLOSURE clos1
			join CLN_RELATIONSHIP_CLOSURE clos2
			on
			clos1.descendant_id=clos2.descendant_id
			left join
			CLN_RELATIONSHIP_CLOSURE clos3
			on clos3.ancestor_id = clos2.ancestor_id
			and clos3.descendant_id = clos1.ancestor_id
			where
			clos2.ancestor_id = old.descendant_id
			and clos3.ancestor_id is null;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.07-mysql', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 10, '8:53d0b3d696f4e77145aa14e4fe55ecc4', 'sql; sql; sql; sql', 'mysql-triggers for CLN_RELATIONSHIP_CLOSURE table', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.08::bsiri
--  this step is mandatory if we want the next one to work (triggers need the nodes to have self-reference in the closure tables)
insert into TCLN_RELATIONSHIP_CLOSURE
			select tcln_id, tcln_id, 0
			from TEST_CASE_LIBRARY_NODE
			where deleted_on is null;

insert into RLN_RELATIONSHIP_CLOSURE
			select rln_id, rln_id, 0
			from
			REQUIREMENT_LIBRARY_NODE
			where deleted_on is null;

insert into CLN_RELATIONSHIP_CLOSURE
			select cln_id, cln_id, 0
			from
			CAMPAIGN_LIBRARY_NODE
			where deleted_on is null;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.08', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 11, '8:5f54649ea2e1588ab1b315322a5f4a66', 'sql; sql; sql', 'this step is mandatory if we want the next one to work (triggers need the nodes to have self-reference in the closure tables)', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.09::bsiri
--  we can now reinsert our data from the tmp tables and let the triggers do the job
insert into TCLN_RELATIONSHIP
			select * from TCLN_RELATIONSHIP_TMP;

insert into RLN_RELATIONSHIP
			select * from RLN_RELATIONSHIP_TMP;

insert into CLN_RELATIONSHIP
			select * from CLN_RELATIONSHIP_TMP;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.09', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 12, '8:1094739e703332e8b458be2316f88e61', 'sql; sql; sql', 'we can now reinsert our data from the tmp tables and let the triggers do the job', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1112.10::bsiri
--  If success, we can now drop our temp tables and complete the migration
DROP TABLE TCLN_RELATIONSHIP_TMP;

DROP TABLE RLN_RELATIONSHIP_TMP;

DROP TABLE CLN_RELATIONSHIP_TMP;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1112.10', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 13, '8:ac6c51cee3c0dacc8f67971cb3ac85a2', 'dropTable tableName=TCLN_RELATIONSHIP_TMP; dropTable tableName=RLN_RELATIONSHIP_TMP; dropTable tableName=CLN_RELATIONSHIP_TMP', 'If success, we can now drop our temp tables and complete the migration', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1209.01::mpagnon
--  To connect Squash TM to a bugtracker, you must provide the name and the url of the bugtracker. The mantis plugin is shipped with the application
--  	 IFRAME_FRIENDLY :tells if the bugtracker page can be accessed through an iframe : if the response header of the bugtracker page has the property [X-Frame-Options = DENY] the answer is false
--  	 URL : must point to the base name of the end point. Eg : http://www.yourdomain.com/mantis . Tips : Prefer IPs over localhost and domain names over IPs. If you don't some minor issues may occur when reporting an issue.
CREATE TABLE BUGTRACKER (BUGTRACKER_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'primary key, should be auto-generated.', NAME VARCHAR(50) NOT NULL COMMENT 'identifies the instance configured.', KIND VARCHAR(50) DEFAULT 'mantis' NOT NULL COMMENT 'tells what kind of connector should be used', URL VARCHAR(255) NOT NULL COMMENT 'the bugtracker url', IFRAME_FRIENDLY BIT(1) DEFAULT 0 NOT NULL COMMENT 'tells if the bugtracker page can be accessed through an iframe', CONSTRAINT PK_BUGTRACKER PRIMARY KEY (BUGTRACKER_ID)) COMMENT='stores bugtrackers informations';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1209.01', 'mpagnon', '../tm/tm.changelog-1.3.0.xml', NOW(), 14, '8:51f3aec0712253ff164f236ab0673307', 'createTable tableName=BUGTRACKER', 'To connect Squash TM to a bugtracker, you must provide the name and the url of the bugtracker. The mantis plugin is shipped with the application
	 IFRAME_FRIENDLY :tells if the bugtracker page can be accessed through an iframe : if the response he...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1181.01::bsiri
--  creating table TEST_AUTOMATION_SERVER
CREATE TABLE TEST_AUTOMATION_SERVER (SERVER_ID BIGINT AUTO_INCREMENT NOT NULL, BASE_URL VARCHAR(255) NOT NULL COMMENT 'the url of the server', LOGIN VARCHAR(50) NOT NULL COMMENT 'the login TM will use', PASSWORD VARCHAR(255) NOT NULL COMMENT 'yes, this is a plain clear password in the database. Until we have what it takes to make it better.', KIND VARCHAR(30) DEFAULT 'jenkins' NOT NULL COMMENT 'the kind of automated test server TM will deal with.', CONSTRAINT PK_TEST_AUTOMATION_SERVER PRIMARY KEY (SERVER_ID));

CREATE INDEX idx_autotest_server ON TEST_AUTOMATION_SERVER(SERVER_ID);

ALTER TABLE TEST_AUTOMATION_SERVER ADD CONSTRAINT uni_autotest_server UNIQUE (BASE_URL, LOGIN);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1181.01', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 15, '8:59851e575739afe2883bde38b98a826c', 'createTable tableName=TEST_AUTOMATION_SERVER; createIndex indexName=idx_autotest_server, tableName=TEST_AUTOMATION_SERVER; addUniqueConstraint constraintName=uni_autotest_server, tableName=TEST_AUTOMATION_SERVER', 'creating table TEST_AUTOMATION_SERVER', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1181.02::bsiri
--  creating table TEST_AUTOMATION_PROJECT
CREATE TABLE TEST_AUTOMATION_PROJECT (PROJECT_ID BIGINT AUTO_INCREMENT NOT NULL, NAME VARCHAR(50) NOT NULL, SERVER_ID BIGINT NULL COMMENT 'foreign key to an automated test server', CONSTRAINT PK_TEST_AUTOMATION_PROJECT PRIMARY KEY (PROJECT_ID), CONSTRAINT fk_auto_test_project FOREIGN KEY (SERVER_ID) REFERENCES TEST_AUTOMATION_SERVER(SERVER_ID));

CREATE INDEX idx_auto_test_project ON TEST_AUTOMATION_PROJECT(PROJECT_ID);

ALTER TABLE TEST_AUTOMATION_PROJECT ADD CONSTRAINT uni_autotest_project UNIQUE (NAME, SERVER_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1181.02', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 16, '8:ee88a2e8cd8c855b038614fbf673969d', 'createTable tableName=TEST_AUTOMATION_PROJECT; createIndex indexName=idx_auto_test_project, tableName=TEST_AUTOMATION_PROJECT; addUniqueConstraint constraintName=uni_autotest_project, tableName=TEST_AUTOMATION_PROJECT', 'creating table TEST_AUTOMATION_PROJECT', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1181.03::bsiri
--  now a PROJECT may or may not have test automation enabled
ALTER TABLE PROJECT ADD TEST_AUTOMATION_ENABLED BIT(1) DEFAULT 0 NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1181.03', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 17, '8:964bf60732b6b169049b8c69aef3a44d', 'addColumn tableName=PROJECT', 'now a PROJECT may or may not have test automation enabled', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1181.04::bsiri
--  table where TM projects and TA projects are bound to each others
CREATE TABLE TM_TA_PROJECTS (TM_PROJECT_ID BIGINT NOT NULL, TA_PROJECT_ID BIGINT NOT NULL, CONSTRAINT fk_tm_ta_projects_ta FOREIGN KEY (TA_PROJECT_ID) REFERENCES TEST_AUTOMATION_PROJECT(PROJECT_ID), CONSTRAINT fk_tm_ta_projects_tm FOREIGN KEY (TM_PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

ALTER TABLE TM_TA_PROJECTS ADD PRIMARY KEY (TM_PROJECT_ID, TA_PROJECT_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1181.04', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 18, '8:f02d1949114f3ad883bebf32826222f1', 'createTable tableName=TM_TA_PROJECTS; addPrimaryKey constraintName=pk_tm_ta_projects, tableName=TM_TA_PROJECTS', 'table where TM projects and TA projects are bound to each others', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1194.01::mpagnon
--  Bugtracker project represent the project's name in a configured bugtracker
CREATE TABLE BUGTRACKER_BINDING (BUGTRACKER_BINDING_ID BIGINT AUTO_INCREMENT NOT NULL, BUGTRACKER_ID BIGINT NOT NULL, PROJECT_NAME VARCHAR(255) NULL COMMENT 'project-name in the bugtracker', PROJECT_ID BIGINT NOT NULL, CONSTRAINT PK_BUGTRACKER_BINDING PRIMARY KEY (BUGTRACKER_BINDING_ID), CONSTRAINT FK_BUGTRACKER_BINDING_PROJECT FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID), CONSTRAINT FK_BUGTRACKER_BINDING_BUGTRACKER FOREIGN KEY (BUGTRACKER_ID) REFERENCES BUGTRACKER(BUGTRACKER_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1194.01', 'mpagnon', '../tm/tm.changelog-1.3.0.xml', NOW(), 19, '8:17c48fe1bc427eb11dcef751a5d425b4', 'createTable tableName=BUGTRACKER_BINDING', 'Bugtracker project represent the project''s name in a configured bugtracker', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1194.04::mpagnon
--  Data migration: add all bugtrackers that had an issue
insert into BUGTRACKER (NAME, KIND, URL, IFRAME_FRIENDLY)
			select distinct issues.BT_NAME , 'mantis', 'TO BE DEFINED', true
			from ISSUE issues;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1194.04', 'mpagnon', '../tm/tm.changelog-1.3.0.xml', NOW(), 20, '8:86f6d7c670961034792a94bcd19d47fc', 'sql', 'Data migration: add all bugtrackers that had an issue', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1194.05::mpagnon
--  New foreign key in ISSUE table that points to a BUGTRACKER
ALTER TABLE ISSUE ADD BUGTRACKER_ID BIGINT NULL COMMENT 'Issue''s bugtracker';

ALTER TABLE ISSUE ADD CONSTRAINT fk_issue_bugtracker FOREIGN KEY (BUGTRACKER_ID) REFERENCES BUGTRACKER (BUGTRACKER_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1194.05', 'mpagnon', '../tm/tm.changelog-1.3.0.xml', NOW(), 21, '8:9988978cd539cad5825d4d38c13025af', 'addColumn tableName=ISSUE', 'New foreign key in ISSUE table that points to a BUGTRACKER', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1194.06::mpagnon
--  Data migration : update issue's bugtracker FK with migrated BTs
CREATE TABLE ISSUEBT
			(
			ISSUEID BIGINT,
			BTID BIGINT
			);

Insert into ISSUEBT (ISSUEID, BTID)
			select distinct iss.ISSUE_ID,
			bt.BUGTRACKER_ID
			from ISSUE as iss, BUGTRACKER as bt
			where iss.BT_NAME = bt.NAME;

update ISSUE
			set BUGTRACKER_ID = (
				select BTID from ISSUEBT
				where ISSUEBT.ISSUEID = ISSUE.ISSUE_ID
			);

DROP table ISSUEBT;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1194.06', 'mpagnon', '../tm/tm.changelog-1.3.0.xml', NOW(), 22, '8:e5e998d9314b8c63dd1b0cf4b277e596', 'sql', 'Data migration : update issue''s bugtracker FK with migrated BTs', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1194.07::mpagnon
--  Drop of column "BT_NAME" on table issue because it is not used anymore => use of FK to table BUGTRACKER instead
ALTER TABLE ISSUE DROP COLUMN BT_NAME;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1194.07', 'mpagnon', '../tm/tm.changelog-1.3.0.xml', NOW(), 23, '8:b78973176d167ccbd820a55e90aad2e3', 'dropColumn columnName=BT_NAME, tableName=ISSUE', 'Drop of column "BT_NAME" on table issue because it is not used anymore => use of FK to table BUGTRACKER instead', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1194.08::mpagnon
--  After Data migration : issue's bugtracker must not be null
ALTER TABLE ISSUE MODIFY BUGTRACKER_ID BIGINT NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1194.08', 'mpagnon', '../tm/tm.changelog-1.3.0.xml', NOW(), 24, '8:89f404e6ddfe747a5ab83b985af561a7', 'addNotNullConstraint columnName=BUGTRACKER_ID, tableName=ISSUE', 'After Data migration : issue''s bugtracker must not be null', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1210.01::bsiri
--  Creation of the table AUTOMATED_TEST
CREATE TABLE AUTOMATED_TEST (TEST_ID BIGINT AUTO_INCREMENT NOT NULL, NAME VARCHAR(255) NULL, PROJECT_ID BIGINT NULL, CONSTRAINT PK_AUTOMATED_TEST PRIMARY KEY (TEST_ID), CONSTRAINT fk_automated_test_project FOREIGN KEY (PROJECT_ID) REFERENCES TEST_AUTOMATION_PROJECT(PROJECT_ID));

ALTER TABLE AUTOMATED_TEST ADD CONSTRAINT uni_auto_test UNIQUE (NAME, PROJECT_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1210.01', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 25, '8:2c1f6c7ed17779b0c35a44d1d6d5e8b3', 'createTable tableName=AUTOMATED_TEST; addUniqueConstraint constraintName=uni_auto_test, tableName=AUTOMATED_TEST', 'Creation of the table AUTOMATED_TEST', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1210.02::bsiri
--  a TEST_CASE can now refer to 0 or 1 AUTOMATED_TEST
ALTER TABLE TEST_CASE ADD TA_TEST BIGINT DEFAULT null NULL;

ALTER TABLE TEST_CASE ADD CONSTRAINT fk_test_case_ta_test FOREIGN KEY (TA_TEST) REFERENCES AUTOMATED_TEST (TEST_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1210.02', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 26, '8:57c3dcb67b055fe67cb7314528cbe1aa', 'addColumn tableName=TEST_CASE', 'a TEST_CASE can now refer to 0 or 1 AUTOMATED_TEST', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1210.03::gfouquet
--  Added a role / group for test automation clients
INSERT INTO CORE_GROUP (QUALIFIED_NAME) VALUES ('squashtest.authz.group.tm.TestAutomationServer');

INSERT INTO CORE_GROUP_AUTHORITY (GROUP_ID, AUTHORITY) VALUES ((select max(ID) from CORE_GROUP), 'ROLE_TA_API_CLIENT');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1210.03', 'gfouquet', '../tm/tm.changelog-1.3.0.xml', NOW(), 27, '8:b2a3d3a51d970eb38c67a0fb63421388', 'insert tableName=CORE_GROUP; insert tableName=CORE_GROUP_AUTHORITY', 'Added a role / group for test automation clients', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1211.01::bsiri
--  Creation of the automated suites table. Note that althought its ID is
--  			still the primary key, it won't be autogenerated : the system will supply it
--  			along the rest instead.
--  
--  			A automated suite groups together a bunch of test automation executions,
--  			which themselves refer to test automation tests.
CREATE TABLE AUTOMATED_SUITE (SUITE_ID VARCHAR(50) NOT NULL, CONSTRAINT PK_AUTOMATED_SUITE PRIMARY KEY (SUITE_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1211.01', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 28, '8:ecf1e42d21760d8ffc8bc23631fdeb54', 'createTable tableName=AUTOMATED_SUITE', 'Creation of the automated suites table. Note that althought its ID is
			still the primary key, it won''t be autogenerated : the system will supply it
			along the rest instead.

			A automated suite groups together a bunch of test automation execu...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Changeset ../tm/tm.changelog-1.3.0.xml::tm-1.3.0-feat-1211.02::bsiri
--  Table for the automated executions extender. An automated execution is
--  			an extension to Executions that handles things related to test automation.
--  
--  			The correct business model would have been that an automated execution is a specialization of
--  			execution, thus inherited from it. Sadly Hibernates got in the way so we came
--  			up with that solution instead.
CREATE TABLE AUTOMATED_EXECUTION_EXTENDER (EXTENDER_ID BIGINT AUTO_INCREMENT NOT NULL, MASTER_EXECUTION_ID BIGINT NOT NULL COMMENT 'foreign key to the Execution it attaches to.', TEST_ID BIGINT NOT NULL COMMENT 'we save that information as soon as the auto execution is created,             because it may change in the future (even if the test case that this execution             is linked to stays otherwhise the same)', RESULT_URL VARCHAR(300) NULL COMMENT 'urls longer than 300 chars should go to hell', SUITE_ID VARCHAR(50) NULL COMMENT 'foreignkey of the suite this execution belongs to', RESULT_SUMMARY LONGTEXT DEFAULT null NULL COMMENT 'a short debriefing of a test once it has been       executed, for instance an error message', CONSTRAINT PK_AUTOMATED_EXECUTION_EXTENDER PRIMARY KEY (EXTENDER_ID), CONSTRAINT fk_auto_exec_suite FOREIGN KEY (SUITE_ID) REFERENCES AUTOMATED_SUITE(SUITE_ID), CONSTRAINT fk_auto_exec_exec FOREIGN KEY (MASTER_EXECUTION_ID) REFERENCES EXECUTION(EXECUTION_ID), CONSTRAINT fk_auto_exec_auto_test FOREIGN KEY (TEST_ID) REFERENCES AUTOMATED_TEST(TEST_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.3.0-feat-1211.02', 'bsiri', '../tm/tm.changelog-1.3.0.xml', NOW(), 29, '8:8d5db31f6c48476056b0b087e474d41e', 'createTable tableName=AUTOMATED_EXECUTION_EXTENDER', 'Table for the automated executions extender. An automated execution is
			an extension to Executions that handles things related to test automation.

			The correct business model would have been that an automated execution is a specialization of
...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184016');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

