--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.4.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.00::gfouquet
--  Adds a TM database version number
UPDATE CORE_CONFIG SET STR_KEY = 'squashtest.tm.database.version', VALUE = '1.4.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.00', 'gfouquet', '../tm/tm.changelog-1.4.0.xml', NOW(), 1, '8:47d4503dc22d75c6e4340159a517bdc8', 'update tableName=CORE_CONFIG', 'Adds a TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0-feat-1109.01::gfouquet
--  Creates a table for Custom Fields
CREATE TABLE CUSTOM_FIELD (CF_ID BIGINT AUTO_INCREMENT NOT NULL, FIELD_TYPE CHAR(3) NOT NULL COMMENT 'CF : simple, SSF : multiple-choice', NAME VARCHAR(255) NOT NULL, LABEL VARCHAR(255) DEFAULT '' NOT NULL, OPTIONAL BIT(1) DEFAULT 1 NOT NULL, DEFAULT_VALUE VARCHAR(255) NULL, INPUT_TYPE CHAR(30) NOT NULL, CONSTRAINT pk_custom_field PRIMARY KEY (CF_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0-feat-1109.01', 'gfouquet', '../tm/tm.changelog-1.4.0.xml', NOW(), 2, '8:5f0d873c1d91b85e3774ab6c07edc713', 'createTable tableName=CUSTOM_FIELD', 'Creates a table for Custom Fields', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0-feat-1109.02::gfouquet
--  Creates a table for Custom Fields Options
CREATE TABLE CUSTOM_FIELD_OPTION (CF_ID BIGINT NOT NULL, LABEL VARCHAR(255) NOT NULL, POSITION INT NOT NULL, CONSTRAINT fk_cf_option_cf FOREIGN KEY (CF_ID) REFERENCES CUSTOM_FIELD(CF_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0-feat-1109.02', 'gfouquet', '../tm/tm.changelog-1.4.0.xml', NOW(), 3, '8:b26d04016cf7e30c5677b5e270bae690', 'createTable tableName=CUSTOM_FIELD_OPTION', 'Creates a table for Custom Fields Options', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0-feat-1390.01::gfouquet
--  Creates a table for Custom Fields Binding
CREATE TABLE CUSTOM_FIELD_BINDING (CFB_ID BIGINT AUTO_INCREMENT NOT NULL, CF_ID BIGINT NOT NULL, BOUND_ENTITY VARCHAR(30) NOT NULL, BOUND_PROJECT_ID BIGINT NOT NULL, POSITION INT NULL, CONSTRAINT pk_cfb_option PRIMARY KEY (CFB_ID), CONSTRAINT fk_cfb_cf FOREIGN KEY (CF_ID) REFERENCES CUSTOM_FIELD(CF_ID), CONSTRAINT fk_cfb_bound_project FOREIGN KEY (BOUND_PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

ALTER TABLE CUSTOM_FIELD_BINDING ADD CONSTRAINT uc_cf_entity_proj_bnd UNIQUE (BOUND_PROJECT_ID, BOUND_ENTITY, CF_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0-feat-1390.01', 'gfouquet', '../tm/tm.changelog-1.4.0.xml', NOW(), 4, '8:1f63580988cd0ac375147c25b71db8ac', 'createTable tableName=CUSTOM_FIELD_BINDING; addUniqueConstraint constraintName=uc_cf_entity_proj_bnd, tableName=CUSTOM_FIELD_BINDING', 'Creates a table for Custom Fields Binding', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0-feat-1390.02::gfouquet
--  Creates a table for rendering locations of a bound custom field
CREATE TABLE CUSTOM_FIELD_RENDERING_LOCATION (CFB_ID BIGINT NOT NULL, RENDERING_LOCATION VARCHAR(30) NOT NULL, CONSTRAINT fk_cfb_render_loc_cfb FOREIGN KEY (CFB_ID) REFERENCES CUSTOM_FIELD_BINDING(CFB_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0-feat-1390.02', 'gfouquet', '../tm/tm.changelog-1.4.0.xml', NOW(), 5, '8:3dfbb528ef03de65f14eb152014c2bdc', 'createTable tableName=CUSTOM_FIELD_RENDERING_LOCATION', 'Creates a table for rendering locations of a bound custom field', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.01::mpagnon
--  Add property attachment list in library nodes, projects and libraries
ALTER TABLE TEST_CASE_LIBRARY_NODE ADD ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes.';

ALTER TABLE TEST_CASE_LIBRARY_NODE ADD CONSTRAINT fk_tcNode_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST (ATTACHMENT_LIST_ID);

ALTER TABLE CAMPAIGN_LIBRARY_NODE ADD ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes.';

ALTER TABLE CAMPAIGN_LIBRARY_NODE ADD CONSTRAINT fk_campNode_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST (ATTACHMENT_LIST_ID);

ALTER TABLE `RESOURCE` ADD ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes.';

ALTER TABLE `RESOURCE` ADD CONSTRAINT fk_resource_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST (ATTACHMENT_LIST_ID);

ALTER TABLE PROJECT ADD ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes.';

ALTER TABLE PROJECT ADD CONSTRAINT fk_project_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST (ATTACHMENT_LIST_ID);

ALTER TABLE REQUIREMENT_LIBRARY ADD ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes.';

ALTER TABLE REQUIREMENT_LIBRARY ADD CONSTRAINT fk_reqLib_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST (ATTACHMENT_LIST_ID);

ALTER TABLE TEST_CASE_LIBRARY ADD ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes.';

ALTER TABLE TEST_CASE_LIBRARY ADD CONSTRAINT fk_tcLib_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST (ATTACHMENT_LIST_ID);

ALTER TABLE CAMPAIGN_LIBRARY ADD ATTACHMENT_LIST_ID BIGINT NULL COMMENT 'clé étrangère vers un ATTACHMENT_LIST, l''entité qui gère les pièces jointes.';

ALTER TABLE CAMPAIGN_LIBRARY ADD CONSTRAINT fk_campLib_attachment_list FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST (ATTACHMENT_LIST_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.01', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 6, '8:1e5fe54adc3e7b02dbaba826944fd900', 'addColumn tableName=TEST_CASE_LIBRARY_NODE; addColumn tableName=CAMPAIGN_LIBRARY_NODE; addColumn tableName=RESOURCE; addColumn tableName=PROJECT; addColumn tableName=REQUIREMENT_LIBRARY; addColumn tableName=TEST_CASE_LIBRARY; addColumn tableName=C...', 'Add property attachment list in library nodes, projects and libraries', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.02::mpagnon
--  Migrate existing attachment lists
update TEST_CASE_LIBRARY_NODE
			set ATTACHMENT_LIST_ID = (select TEST_CASE.ATTACHMENT_LIST_ID from TEST_CASE where TEST_CASE.TCLN_ID = TEST_CASE_LIBRARY_NODE.TCLN_ID);

update CAMPAIGN_LIBRARY_NODE
			set ATTACHMENT_LIST_ID = (select CAMPAIGN.ATTACHMENT_LIST_ID from CAMPAIGN where CAMPAIGN.CLN_ID = CAMPAIGN_LIBRARY_NODE.CLN_ID);

update RESOURCE
			set ATTACHMENT_LIST_ID = (select REQUIREMENT_VERSION.ATTACHMENT_LIST_ID from REQUIREMENT_VERSION where REQUIREMENT_VERSION.RES_ID = RESOURCE.RES_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.02', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 7, '8:a544746773f1033e47515a544c9b18e3', 'sql; sql; sql', 'Migrate existing attachment lists', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.03::mpagnon
--  Add attachment lists to test_case_folders
ALTER TABLE ATTACHMENT_LIST ADD TCLN_ID BIGINT NULL COMMENT 'colonne provisoire pour se rapeller de à qui était destinée la nouvelle attachment_list';

ALTER TABLE ATTACHMENT_LIST ADD CONSTRAINT fk_tcln FOREIGN KEY (TCLN_ID) REFERENCES TEST_CASE_LIBRARY_NODE (TCLN_ID);

insert into ATTACHMENT_LIST (TCLN_ID)
			select TEST_CASE_FOLDER.TCLN_ID from TEST_CASE_FOLDER;

update TEST_CASE_LIBRARY_NODE
			set ATTACHMENT_LIST_ID = (select ATTACHMENT_LIST.ATTACHMENT_LIST_ID from ATTACHMENT_LIST where ATTACHMENT_LIST.TCLN_ID = TEST_CASE_LIBRARY_NODE.TCLN_ID)
			where ATTACHMENT_LIST_ID is null;

ALTER TABLE ATTACHMENT_LIST DROP FOREIGN KEY fk_tcln;

ALTER TABLE ATTACHMENT_LIST DROP COLUMN TCLN_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.03', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 8, '8:a921fd0f39ba6cce8100d1874fe5f202', 'addColumn tableName=ATTACHMENT_LIST; sql; sql; dropForeignKeyConstraint baseTableName=ATTACHMENT_LIST, constraintName=fk_tcln; dropColumn columnName=TCLN_ID, tableName=ATTACHMENT_LIST', 'Add attachment lists to test_case_folders', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.04::mpagnon
--  Add attachment lists to campaign_folders
ALTER TABLE ATTACHMENT_LIST ADD CLN_ID BIGINT NULL COMMENT 'table provisoire pour se rapeller de à qui était destinée la nouvelle attachment_list';

ALTER TABLE ATTACHMENT_LIST ADD CONSTRAINT fk_cln FOREIGN KEY (CLN_ID) REFERENCES CAMPAIGN_LIBRARY_NODE (CLN_ID);

insert into ATTACHMENT_LIST (CLN_ID)
			select CAMPAIGN_FOLDER.CLN_ID from CAMPAIGN_FOLDER;

update CAMPAIGN_LIBRARY_NODE
			set ATTACHMENT_LIST_ID = (select ATTACHMENT_LIST.ATTACHMENT_LIST_ID from ATTACHMENT_LIST where ATTACHMENT_LIST.CLN_ID = CAMPAIGN_LIBRARY_NODE.CLN_ID)
			where ATTACHMENT_LIST_ID is null;

ALTER TABLE ATTACHMENT_LIST DROP FOREIGN KEY fk_cln;

ALTER TABLE ATTACHMENT_LIST DROP COLUMN CLN_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.04', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 9, '8:76838efd394db1c0516055a81a6e4035', 'addColumn tableName=ATTACHMENT_LIST; sql; sql; dropForeignKeyConstraint baseTableName=ATTACHMENT_LIST, constraintName=fk_cln; dropColumn columnName=CLN_ID, tableName=ATTACHMENT_LIST', 'Add attachment lists to campaign_folders', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.05::mpagnon
--  Add attachment lists to requirement folders
ALTER TABLE ATTACHMENT_LIST ADD RES_ID BIGINT NULL COMMENT 'table provisoire pour se rapeller de à qui était destinée la nouvelle attachment_list';

ALTER TABLE ATTACHMENT_LIST ADD CONSTRAINT fk_sr FOREIGN KEY (RES_ID) REFERENCES `RESOURCE` (RES_ID);

insert into ATTACHMENT_LIST (RES_ID)
			select SIMPLE_RESOURCE.RES_ID from SIMPLE_RESOURCE;

update RESOURCE
			set ATTACHMENT_LIST_ID = (select ATTACHMENT_LIST.ATTACHMENT_LIST_ID from ATTACHMENT_LIST where ATTACHMENT_LIST.RES_ID = RESOURCE.RES_ID)
			where ATTACHMENT_LIST_ID is null;

ALTER TABLE ATTACHMENT_LIST DROP FOREIGN KEY fk_sr;

ALTER TABLE ATTACHMENT_LIST DROP COLUMN RES_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.05', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 10, '8:1d57bcfb9f9178e1fe76e1232dda8418', 'addColumn tableName=ATTACHMENT_LIST; sql; sql; dropForeignKeyConstraint baseTableName=ATTACHMENT_LIST, constraintName=fk_sr; dropColumn columnName=RES_ID, tableName=ATTACHMENT_LIST', 'Add attachment lists to requirement folders', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.06::mpagnon
--  Add attachment lists to projects
ALTER TABLE ATTACHMENT_LIST ADD PROJECT_ID BIGINT NULL COMMENT 'table provisoire pour se rapeller de à qui était destinée la nouvelle attachment_list';

ALTER TABLE ATTACHMENT_LIST ADD CONSTRAINT fk_project FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT (PROJECT_ID);

insert into ATTACHMENT_LIST (PROJECT_ID)
			select PROJECT.PROJECT_ID from PROJECT;

update PROJECT
			set ATTACHMENT_LIST_ID = (select ATTACHMENT_LIST.ATTACHMENT_LIST_ID from ATTACHMENT_LIST where ATTACHMENT_LIST.PROJECT_ID = PROJECT.PROJECT_ID)
			where ATTACHMENT_LIST_ID is null;

ALTER TABLE ATTACHMENT_LIST DROP FOREIGN KEY fk_project;

ALTER TABLE ATTACHMENT_LIST DROP COLUMN PROJECT_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.06', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 11, '8:17f4c1960e10e28b5e1d8452233cbe10', 'addColumn tableName=ATTACHMENT_LIST; sql; sql; dropForeignKeyConstraint baseTableName=ATTACHMENT_LIST, constraintName=fk_project; dropColumn columnName=PROJECT_ID, tableName=ATTACHMENT_LIST', 'Add attachment lists to projects', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.07::mpagnon
--  Add attachment lists to reqLib
ALTER TABLE ATTACHMENT_LIST ADD RL_ID BIGINT NULL COMMENT 'table provisoire pour se rapeller de à qui était destinée la nouvelle attachment_list';

ALTER TABLE ATTACHMENT_LIST ADD CONSTRAINT fk_rLib FOREIGN KEY (RL_ID) REFERENCES REQUIREMENT_LIBRARY (RL_ID);

insert into ATTACHMENT_LIST (RL_ID)
			select REQUIREMENT_LIBRARY.RL_ID from REQUIREMENT_LIBRARY;

update REQUIREMENT_LIBRARY
			set ATTACHMENT_LIST_ID = (select ATTACHMENT_LIST.ATTACHMENT_LIST_ID from ATTACHMENT_LIST where ATTACHMENT_LIST.RL_ID = REQUIREMENT_LIBRARY.RL_ID)
			where ATTACHMENT_LIST_ID is null;

ALTER TABLE ATTACHMENT_LIST DROP FOREIGN KEY fk_rLib;

ALTER TABLE ATTACHMENT_LIST DROP COLUMN RL_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.07', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 12, '8:741b34777bada69e897109fac527cd34', 'addColumn tableName=ATTACHMENT_LIST; sql; sql; dropForeignKeyConstraint baseTableName=ATTACHMENT_LIST, constraintName=fk_rLib; dropColumn columnName=RL_ID, tableName=ATTACHMENT_LIST', 'Add attachment lists to reqLib', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.08::mpagnon
--  Add attachment lists to test_case_library
ALTER TABLE ATTACHMENT_LIST ADD TCL_ID BIGINT NULL COMMENT 'table provisoire pour se rapeller de à qui était destinée la nouvelle attachment_list';

ALTER TABLE ATTACHMENT_LIST ADD CONSTRAINT fk_tcLib FOREIGN KEY (TCL_ID) REFERENCES TEST_CASE_LIBRARY (TCL_ID);

insert into ATTACHMENT_LIST (TCL_ID)
			select TEST_CASE_LIBRARY.TCL_ID from TEST_CASE_LIBRARY;

update TEST_CASE_LIBRARY
			set ATTACHMENT_LIST_ID = (select ATTACHMENT_LIST.ATTACHMENT_LIST_ID from ATTACHMENT_LIST where ATTACHMENT_LIST.TCL_ID = TEST_CASE_LIBRARY.TCL_ID)
			where ATTACHMENT_LIST_ID is null;

ALTER TABLE ATTACHMENT_LIST DROP FOREIGN KEY fk_tcLib;

ALTER TABLE ATTACHMENT_LIST DROP COLUMN TCL_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.08', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 13, '8:83934b979af1c904fa5c961f67e16d26', 'addColumn tableName=ATTACHMENT_LIST; sql; sql; dropForeignKeyConstraint baseTableName=ATTACHMENT_LIST, constraintName=fk_tcLib; dropColumn columnName=TCL_ID, tableName=ATTACHMENT_LIST', 'Add attachment lists to test_case_library', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.09::mpagnon
--  Add attachment lists to campaign libraries
ALTER TABLE ATTACHMENT_LIST ADD CL_ID BIGINT NULL COMMENT 'table provisoire pour se rapeller de à qui était destinée la nouvelle attachment_list';

ALTER TABLE ATTACHMENT_LIST ADD CONSTRAINT fk_cLib FOREIGN KEY (CL_ID) REFERENCES CAMPAIGN_LIBRARY (CL_ID);

insert into ATTACHMENT_LIST (CL_ID)
			select CAMPAIGN_LIBRARY.CL_ID from CAMPAIGN_LIBRARY;

update CAMPAIGN_LIBRARY
			set ATTACHMENT_LIST_ID = (select ATTACHMENT_LIST.ATTACHMENT_LIST_ID from ATTACHMENT_LIST where ATTACHMENT_LIST.CL_ID = CAMPAIGN_LIBRARY.CL_ID)
			where ATTACHMENT_LIST_ID is null;

ALTER TABLE ATTACHMENT_LIST DROP FOREIGN KEY fk_cLib;

ALTER TABLE ATTACHMENT_LIST DROP COLUMN CL_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.09', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 14, '8:80471c4ed7a864008f3780723581604c', 'addColumn tableName=ATTACHMENT_LIST; sql; sql; dropForeignKeyConstraint baseTableName=ATTACHMENT_LIST, constraintName=fk_cLib; dropColumn columnName=CL_ID, tableName=ATTACHMENT_LIST', 'Add attachment lists to campaign libraries', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.010::mpagnon
--  Make attachment_list_ids new fks not nullable
ALTER TABLE TEST_CASE_LIBRARY_NODE MODIFY ATTACHMENT_LIST_ID BIGINT NOT NULL;

ALTER TABLE CAMPAIGN_LIBRARY_NODE MODIFY ATTACHMENT_LIST_ID BIGINT NOT NULL;

ALTER TABLE `RESOURCE` MODIFY ATTACHMENT_LIST_ID BIGINT NOT NULL;

ALTER TABLE PROJECT MODIFY ATTACHMENT_LIST_ID BIGINT NOT NULL;

ALTER TABLE REQUIREMENT_LIBRARY MODIFY ATTACHMENT_LIST_ID BIGINT NOT NULL;

ALTER TABLE CAMPAIGN_LIBRARY MODIFY ATTACHMENT_LIST_ID BIGINT NOT NULL;

ALTER TABLE TEST_CASE_LIBRARY MODIFY ATTACHMENT_LIST_ID BIGINT NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.010', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 15, '8:910e041f846e1c2f0e9797e7c3e0db09', 'addNotNullConstraint columnName=ATTACHMENT_LIST_ID, tableName=TEST_CASE_LIBRARY_NODE; addNotNullConstraint columnName=ATTACHMENT_LIST_ID, tableName=CAMPAIGN_LIBRARY_NODE; addNotNullConstraint columnName=ATTACHMENT_LIST_ID, tableName=RESOURCE; addN...', 'Make attachment_list_ids new fks not nullable', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1513.11::mpagnon
--  Drop previous attachment list ids
ALTER TABLE TEST_CASE DROP FOREIGN KEY fk_test_case_attachment_list;

ALTER TABLE CAMPAIGN DROP FOREIGN KEY fk_campaign_attachment_list;

ALTER TABLE REQUIREMENT_VERSION DROP FOREIGN KEY fk_requirement_version_attachment_list;

ALTER TABLE TEST_CASE DROP COLUMN ATTACHMENT_LIST_ID;

ALTER TABLE CAMPAIGN DROP COLUMN ATTACHMENT_LIST_ID;

ALTER TABLE REQUIREMENT_VERSION DROP COLUMN ATTACHMENT_LIST_ID;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1513.11', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 16, '8:3cb3532cce4a9ba7a85d2bd935735d13', 'dropForeignKeyConstraint baseTableName=TEST_CASE, constraintName=fk_test_case_attachment_list; dropForeignKeyConstraint baseTableName=CAMPAIGN, constraintName=fk_campaign_attachment_list; dropForeignKeyConstraint baseTableName=REQUIREMENT_VERSION,...', 'Drop previous attachment list ids', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1392.01::bsiri
--  The table CUSTOM_FIELD_VALUE holds instances of a CUSTOM_FIELD that are bound to instances of :
--  			test cases, requirement version, campagnes, iterations and test suites. A custom field value is created
--  			when a custom field binding is created or an entity subject to an existing custom field binding is created.
--  			A custom field value is destroyed when the bound entity instance is destroyed or the custom field binding
--  			is destroyed.
--  
--  			Note that in this table the coupling between the custom field value and the bound entity is week : it consists of a pair
--  			of Type/ID (BINDABLE_ENTITY_TYPE and BINDABLE_ENTITY_ID) rather than a foreign key to the said entity, nor is true
--  			the opposite ( ie no FK from a test case to a custom field value).
CREATE TABLE CUSTOM_FIELD_VALUE (CFV_ID BIGINT AUTO_INCREMENT NOT NULL COMMENT 'technical id', BOUND_ENTITY_ID BIGINT NOT NULL COMMENT 'the id of the bound entity', BOUND_ENTITY_TYPE VARCHAR(30) NOT NULL COMMENT 'the kind of entity. Note that this information is also contained by the                  custom field binding.', CFB_ID BIGINT NOT NULL COMMENT 'the custom field binding that holds all the data', VALUE VARCHAR(255) NULL COMMENT 'the value of that particular custom field value', CONSTRAINT pk_custom_field_value PRIMARY KEY (CFV_ID), CONSTRAINT fk_cfv_cf_binding FOREIGN KEY (CFB_ID) REFERENCES CUSTOM_FIELD_BINDING(CFB_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1392.01', 'bsiri', '../tm/tm.changelog-1.4.0.xml', NOW(), 17, '8:e419045701cd1d660c290d9cebc96d71', 'createTable tableName=CUSTOM_FIELD_VALUE', 'The table CUSTOM_FIELD_VALUE holds instances of a CUSTOM_FIELD that are bound to instances of :
			test cases, requirement version, campagnes, iterations and test suites. A custom field value is created
			when a custom field binding is created or...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1553.00::flaurens
--  Adds a nature field to test cases
ALTER TABLE TEST_CASE ADD TC_NATURE VARCHAR(30) DEFAULT 'UNDEFINED' NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1553.00', 'flaurens', '../tm/tm.changelog-1.4.0.xml', NOW(), 18, '8:687080f9bf005ab2a5ee3064e3a9235b', 'addColumn tableName=TEST_CASE', 'Adds a nature field to test cases', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1554.00::flaurens
--  Adds a type field to test cases
ALTER TABLE TEST_CASE ADD TC_TYPE VARCHAR(30) DEFAULT 'UNDEFINED' NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1554.00', 'flaurens', '../tm/tm.changelog-1.4.0.xml', NOW(), 19, '8:1c43b37cb04adca934b62633b595ed08', 'addColumn tableName=TEST_CASE', 'Adds a type field to test cases', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1609.00::flaurens
--  Adds a status field to test cases
ALTER TABLE TEST_CASE ADD TC_STATUS VARCHAR(30) DEFAULT 'WORK_IN_PROGRESS' NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1609.00', 'flaurens', '../tm/tm.changelog-1.4.0.xml', NOW(), 20, '8:7d3c71ee41d2af7a983ca1855ff775f3', 'addColumn tableName=TEST_CASE', 'Adds a status field to test cases', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1596.00::flaurens
--  Adds test case related fields to executions for denormalization
ALTER TABLE EXECUTION ADD TC_NATURE VARCHAR(30) DEFAULT 'UNDEFINED' NOT NULL, ADD TC_TYPE VARCHAR(30) DEFAULT 'UNDEFINED' NOT NULL, ADD TC_STATUS VARCHAR(30) DEFAULT 'WORK_IN_PROGRESS' NOT NULL, ADD IMPORTANCE VARCHAR(20) DEFAULT 'LOW' NOT NULL, ADD `REFERENCE` VARCHAR(20) DEFAULT null NULL, ADD TC_DESCRIPTION LONGTEXT DEFAULT null NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1596.00', 'flaurens', '../tm/tm.changelog-1.4.0.xml', NOW(), 21, '8:98717315ac63d2f0ec87d045f9a0e7fd', 'addColumn tableName=EXECUTION', 'Adds test case related fields to executions for denormalization', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1596.01::flaurens
--  adds test case information to executions created prior to the changeset tm-1.4.0.feat-1596.00
create table EXECUTION_TEST_CASE_DATA (TCLN_ID BIGINT, TC_DESCRIPTION TEXT, REFERENCE VARCHAR(20), IMPORTANCE VARCHAR(20), TC_NATURE VARCHAR(30), TC_TYPE VARCHAR(30), TC_STATUS VARCHAR(30));

insert into EXECUTION_TEST_CASE_DATA (TCLN_ID, TC_DESCRIPTION, REFERENCE, IMPORTANCE, TC_NATURE, TC_TYPE, TC_STATUS)
				select
					tc.tcln_id AS TCLN_ID,
					tcln.description AS DESCRIPTION,
					tc.reference AS REFERENCE,
					tc.importance AS IMPORTANCE,
					tc.tc_nature AS TCNATURE,
					tc.tc_type AS TCTYPE,
					tc.tc_status AS TCSTATUS
				from TEST_CASE tc
				join TEST_CASE_LIBRARY_NODE tcln on tcln.tcln_id = tc.tcln_id;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1596.01', 'flaurens', '../tm/tm.changelog-1.4.0.xml', NOW(), 22, '8:0746b8b92b662185b04724e135518a48', 'sql', 'adds test case information to executions created prior to the changeset tm-1.4.0.feat-1596.00', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1596.01-a::mpagnon
--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1596.01-b::mpagnon
--  this grammar is not supported by h2 and is more efficient
UPDATE EXECUTION exe
			JOIN EXECUTION_TEST_CASE_DATA etcd ON etcd.TCLN_ID = exe.TCLN_ID
			SET
			exe.TC_DESCRIPTION=etcd.tc_description,
			exe.REFERENCE=etcd.reference,
			exe.IMPORTANCE=etcd.importance,
			exe.TC_NATURE=etcd.tc_nature,
			exe.TC_TYPE=etcd.tc_type,
			exe.TC_STATUS=etcd.tc_status;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1596.01-b', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 23, '8:f9eb3cff4afa408a01c77ed552491ea7', 'sql', 'this grammar is not supported by h2 and is more efficient', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1110.01::gfouquet
--  Adds a type discriminator column on PROJECT
ALTER TABLE PROJECT ADD PROJECT_TYPE CHAR(1) DEFAULT 'P' NOT NULL COMMENT 'P: project, T: project template';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1110.01', 'gfouquet', '../tm/tm.changelog-1.4.0.xml', NOW(), 24, '8:a6f68a8239f86c9e6fdbee0610d4a558', 'addColumn tableName=PROJECT', 'Adds a type discriminator column on PROJECT', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1393.01::mpagnon
--  Adds a className for the ProjectTemplate, this is needed so that a project template can hold user's permissions
INSERT INTO ACL_CLASS (CLASSNAME) VALUES ('org.squashtest.csp.tm.domain.project.ProjectTemplate');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1393.01', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 25, '8:d379b785e3df9b3bfe8ddd40e32cc75b', 'insert tableName=ACL_CLASS', 'Adds a className for the ProjectTemplate, this is needed so that a project template can hold user''s permissions', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1628.01::flaurens
ALTER TABLE REQUIREMENT_VERSION ALTER `REFERENCE` SET DEFAULT '';

ALTER TABLE TEST_CASE ALTER `REFERENCE` SET DEFAULT '';

ALTER TABLE EXECUTION ALTER `REFERENCE` SET DEFAULT '';

ALTER TABLE REQUIREMENT_VERSION MODIFY `REFERENCE` VARCHAR(50);

ALTER TABLE TEST_CASE MODIFY `REFERENCE` VARCHAR(50);

ALTER TABLE EXECUTION MODIFY `REFERENCE` VARCHAR(50);

ALTER TABLE REQUIREMENT_VERSION ALTER `REFERENCE` SET DEFAULT '';

ALTER TABLE TEST_CASE ALTER `REFERENCE` SET DEFAULT '';

ALTER TABLE EXECUTION ALTER `REFERENCE` SET DEFAULT '';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1628.01', 'flaurens', '../tm/tm.changelog-1.4.0.xml', NOW(), 26, '8:cc41991917196a77889b24836899a3f0', 'addDefaultValue columnName=REFERENCE, tableName=REQUIREMENT_VERSION; addDefaultValue columnName=REFERENCE, tableName=TEST_CASE; addDefaultValue columnName=REFERENCE, tableName=EXECUTION; modifyDataType columnName=REFERENCE, tableName=REQUIREMENT_V...', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1638.01::mpagnon
ALTER TABLE CUSTOM_FIELD ADD CODE VARCHAR(30) DEFAULT '' NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1638.01', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 27, '8:ec3f5d309c82e25742b70c9cb60b2530', 'addColumn tableName=CUSTOM_FIELD', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../tm/tm.changelog-1.4.0.xml::tm-1.4.0.feat-1638.02::mpagnon
ALTER TABLE CUSTOM_FIELD_OPTION ADD CODE VARCHAR(30) DEFAULT '' NOT NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.0.feat-1638.02', 'mpagnon', '../tm/tm.changelog-1.4.0.xml', NOW(), 28, '8:32a32aad58ccb2a3d1e4f8353ac51c6f', 'addColumn tableName=CUSTOM_FIELD_OPTION', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Changeset ../core/core.changelog-1.4.0.xml::core-feat-327::mpagnon
--  Because admin was not active , need to make sure that all user active in auth_user are active in core_user
update CORE_USER
					set ACTIVE = true
					where CORE_USER.LOGIN in (select AUTH_USER.LOGIN from AUTH_USER where AUTH_USER.ACTIVE = true);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('core-feat-327', 'mpagnon', '../core/core.changelog-1.4.0.xml', NOW(), 29, '8:323c895a060d7f87a79287ea2c7d1489', 'sql', 'Because admin was not active , need to make sure that all user active in auth_user are active in core_user', 'EXECUTED', NULL, NULL, '4.17.2', '9340184083');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

