--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.4.1.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.4.1.xml::tm-1.4.1.00::mpagnon
--  Adds a TM database version number
UPDATE CORE_CONFIG SET STR_KEY = 'squashtest.tm.database.version', VALUE = '1.4.1' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.1.00', 'mpagnon', '../tm/tm.changelog-1.4.1.xml', NOW(), 1, '8:e64714660838abe288858a785b925c7a', 'update tableName=CORE_CONFIG', 'Adds a TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184142');

--  Changeset ../tm/tm.changelog-1.4.1.xml::tm-1.4.1.issue-1864-01::mpagnon
--  fixed database integrity for execution importance
update EXECUTION exe
			set importance = 'LOW'
			where exe.importance <>
			'LOW'
			and exe.importance <> 'HIGH'
			and exe.importance <>
			'MEDIUM'
			and exe.importance <> 'VERY_HIGH';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.1.issue-1864-01', 'mpagnon', '../tm/tm.changelog-1.4.1.xml', NOW(), 2, '8:24a3af879eb0b03292ab5e34fc4e1547', 'sql', 'fixed database integrity for execution importance', 'EXECUTED', NULL, NULL, '4.17.2', '9340184142');

--  Changeset ../tm/tm.changelog-1.4.1.xml::tm-1.4.1.issue-1864-02::mpagnon
--  fixed database integrity for execution tc_nature
update EXECUTION exe
			set tc_nature = 'UNDEFINED'
			where exe.tc_nature <>
			'ATDD'
			and exe.tc_nature <> 'BUSINESS_TESTING'
			and exe.tc_nature <> 'FUNCTIONAL_TESTING'
			and exe.tc_nature <> 'NON_FUNCTIONAL_TESTING'
			and exe.tc_nature <> 'PERFORMANCE_TESTING'
			and exe.tc_nature <> 'SECURITY_TESTING'
			and exe.tc_nature <> 'UNDEFINED'
			and exe.tc_nature <> 'USER_TESTING';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.1.issue-1864-02', 'mpagnon', '../tm/tm.changelog-1.4.1.xml', NOW(), 3, '8:0d0369cdf5535f7c8549757e3df6d8c1', 'sql', 'fixed database integrity for execution tc_nature', 'EXECUTED', NULL, NULL, '4.17.2', '9340184142');

--  Changeset ../tm/tm.changelog-1.4.1.xml::tm-1.4.1.issue-1864-03::mpagnon
--  fixed database integrity for execution tc_type
update EXECUTION exe
			set tc_type = 'UNDEFINED'
			where exe.tc_type <>
			'COMPLIANCE_TESTING'
			and exe.tc_type <> 'CORRECTION_TESTING'
			and exe.tc_type <> 'END_TO_END_TESTING'
			and exe.tc_type <> 'EVOLUTION_TESTING'
			and exe.tc_type <> 'PARTNER_TESTING'
			and exe.tc_type <> 'REGRESSION_TESTING'
			and exe.tc_type <> 'UNDEFINED';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.1.issue-1864-03', 'mpagnon', '../tm/tm.changelog-1.4.1.xml', NOW(), 4, '8:b56f8d7e673cc2c1967de32a86ae3929', 'sql', 'fixed database integrity for execution tc_type', 'EXECUTED', NULL, NULL, '4.17.2', '9340184142');

--  Changeset ../tm/tm.changelog-1.4.1.xml::tm-1.4.1.issue-1864-04::mpagnon
--  fixed database integrity for execution tc_status
update EXECUTION exe
			set tc_status = 'WORK_IN_PROGRESS'
			where exe.tc_status
			<> 'APPROVED'
			and exe.tc_status <> 'OBSOLETE'
			and exe.tc_status <> 'TO_BE_UPDATED'
			and exe.tc_status <> 'UNDER_REVIEW'
			and exe.tc_status <> 'WORK_IN_PROGRESS';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.4.1.issue-1864-04', 'mpagnon', '../tm/tm.changelog-1.4.1.xml', NOW(), 5, '8:d9c21801b86b940f5e8370048c6e2ae6', 'sql', 'fixed database integrity for execution tc_status', 'EXECUTED', NULL, NULL, '4.17.2', '9340184142');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

