--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.7.1.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1::mpagnon
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.7.1' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 1, '8:9fb57c775efdc1df8328e60e9451dbfe', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-01::mpagnon
--  Delete ghost executions
--  create table to store the id of entities to delete
CREATE TABLE ENTITIES_TO_DELETE (ENTITY_NAME VARCHAR(30) NULL, ENTITY_ID BIGINT NULL);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-01', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 2, '8:7272f8f2270ba64bde072ffb28e34500', 'createTable tableName=ENTITIES_TO_DELETE', 'Delete ghost executions
create table to store the id of entities to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-02::mpagnon
--  Store the ids of the ghost executions
insert into ENTITIES_TO_DELETE (ENTITY_NAME, ENTITY_ID)
			select distinct 'EXECUTION', E.EXECUTION_ID
			from EXECUTION E left outer join ITEM_TEST_PLAN_EXECUTION ITPE
			on E.EXECUTION_ID = ITPE.EXECUTION_ID
			where ITPE.EXECUTION_ID is null;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-02', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 3, '8:c15f92dd81b0c9c31614090a8c56978c', 'sql', 'Store the ids of the ghost executions', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-03::mpagnon
--  Store the ids of the execution steps
insert into ENTITIES_TO_DELETE (ENTITY_NAME, ENTITY_ID)
			select
			'EXECUTION_STEP', ES.EXECUTION_STEP_ID
			from EXECUTION_STEP ES, EXECUTION_EXECUTION_STEPS EES, ENTITIES_TO_DELETE ETD
			where ES.EXECUTION_STEP_ID = EES.EXECUTION_STEP_ID
			and EES.EXECUTION_ID =	ETD.ENTITY_ID
			and ETD.ENTITY_NAME = 'EXECUTION';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-03', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 4, '8:5ef52276cc018068dc1991cfd87d619a', 'sql', 'Store the ids of the execution steps', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-04::mpagnon
--  Store the ids of the issue lists to delete
insert into ENTITIES_TO_DELETE (ENTITY_NAME, ENTITY_ID)
			select 'ISSUE_LIST', E.ISSUE_LIST_ID
			from EXECUTION E,  ENTITIES_TO_DELETE ETD
			where E.EXECUTION_ID = ETD.ENTITY_ID
			and ETD.ENTITY_NAME = 'EXECUTION';

insert into ENTITIES_TO_DELETE (ENTITY_NAME, ENTITY_ID)
			select 'ISSUE_LIST', ES.ISSUE_LIST_ID
			from   EXECUTION_STEP ES,  ENTITIES_TO_DELETE ETD2
			where ES.EXECUTION_STEP_ID = ETD2.ENTITY_ID
			and	ETD2.ENTITY_NAME = 'EXECUTION_STEP';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-04', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 5, '8:71001eefb8d42caf4254974e320560f9', 'sql; sql', 'Store the ids of the issue lists to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-05::mpagnon
--  Store the ids of the issue lists to delete
insert into ENTITIES_TO_DELETE (ENTITY_NAME, ENTITY_ID)
			select 'ATTACHMENT_LIST', E.ATTACHMENT_LIST_ID
			from EXECUTION E,  ENTITIES_TO_DELETE ETD
			where  E.EXECUTION_ID = ETD.ENTITY_ID
			and ETD.ENTITY_NAME = 'EXECUTION';

insert into ENTITIES_TO_DELETE (ENTITY_NAME, ENTITY_ID)
			select 'ATTACHMENT_LIST', ES.ATTACHMENT_LIST_ID
			from  EXECUTION_STEP ES,  ENTITIES_TO_DELETE ETD2
			where  ES.EXECUTION_STEP_ID = ETD2.ENTITY_ID
			and	ETD2.ENTITY_NAME = 'EXECUTION_STEP';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-05', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 6, '8:d863755915078c39df6ba89e904decb3', 'sql; sql', 'Store the ids of the issue lists to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-06::mpagnon
--  DELETE Issues of execution and execution steps to delete
DELETE FROM ISSUE WHERE exists (
				select 1
				from ENTITIES_TO_DELETE
				where ENTITY_NAME = 'ISSUE_LIST'
				and ENTITY_ID = ISSUE_LIST_ID
				);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-06', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 7, '8:2a83700005cdc28dea66c8c684614489', 'delete tableName=ISSUE', 'DELETE Issues of execution and execution steps to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-07::mpagnon
--  DELETE Automated execution extender of executions to delete
DELETE FROM AUTOMATED_EXECUTION_EXTENDER WHERE exists (
				select	1 
				from ENTITIES_TO_DELETE
				where ENTITY_NAME = 'EXECUTION'
				and ENTITY_ID = MASTER_EXECUTION_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-07', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 8, '8:ff7b8bc5a12da202bc90530ec6cb4fdd', 'delete tableName=AUTOMATED_EXECUTION_EXTENDER', 'DELETE Automated execution extender of executions to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-08::mpagnon
--  DELETE automated suites that are not linked to any automated execution extender
DELETE FROM AUTOMATED_SUITE WHERE not exists (
				select 1
				from AUTOMATED_EXECUTION_EXTENDER
				where AUTOMATED_SUITE.SUITE_ID = AUTOMATED_EXECUTION_EXTENDER.SUITE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-08', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 9, '8:f4bdb1e5374512923e80ab8d71eb4373', 'delete tableName=AUTOMATED_SUITE', 'DELETE automated suites that are not linked to any automated execution extender', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-09::mpagnon
--  Delete execution steps of ghost executions
DELETE FROM EXECUTION_EXECUTION_STEPS WHERE exists (
				select 1 
				from ENTITIES_TO_DELETE
				where ENTITY_NAME = 'EXECUTION_STEP'
				and ENTITY_ID = EXECUTION_STEP_ID);

DELETE FROM EXECUTION_STEP WHERE exists (
				select 1 
				from ENTITIES_TO_DELETE
				where ENTITY_NAME = 'EXECUTION_STEP'
				and EXECUTION_STEP_ID = ENTITY_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-09', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 10, '8:c5721418be2eb4249876cbce4e4c88eb', 'delete tableName=EXECUTION_EXECUTION_STEPS; delete tableName=EXECUTION_STEP', 'Delete execution steps of ghost executions', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-10::mpagnon
--  Delete ghost executions
DELETE FROM EXECUTION WHERE exists (
				select 1 
				from ENTITIES_TO_DELETE
				where ENTITY_NAME = 'EXECUTION'
				and EXECUTION_ID = ENTITY_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-10', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 11, '8:1156cb430ad5b69595e8d19502495cde', 'delete tableName=EXECUTION', 'Delete ghost executions', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-11::mpagnon
--  DELETE Attachments of execution and execution steps to delete
DELETE FROM ATTACHMENT WHERE exists (
				select 1
				from ENTITIES_TO_DELETE
				where ENTITY_NAME = 'ATTACHMENT_LIST'
				and ENTITY_ID = ATTACHMENT_LIST_ID
				);

DELETE FROM ATTACHMENT_CONTENT WHERE not exists (
				select 1
				from ATTACHMENT
				where CONTENT_ID = ATTACHMENT_CONTENT_ID
				);

DELETE FROM ATTACHMENT_LIST WHERE exists (
				select 1
				from ENTITIES_TO_DELETE
				where ENTITY_NAME = 'ATTACHMENT_LIST'
				and ATTACHMENT_LIST_ID = ENTITY_ID
				);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-11', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 12, '8:c0efea33fdf229f3f19da5016117e61f', 'delete tableName=ATTACHMENT; delete tableName=ATTACHMENT_CONTENT; delete tableName=ATTACHMENT_LIST', 'DELETE Attachments of execution and execution steps to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-12::mpagnon
--  DELETE issue lists of executions and execution-steps to delete
DELETE FROM ISSUE_LIST WHERE exists (
				select 1 
				from ENTITIES_TO_DELETE
				where ENTITY_NAME ='ISSUE_LIST'
				and ENTITY_ID = ISSUE_LIST_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-12', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 13, '8:469b75e66f5a61c58781b5d1580b8b49', 'delete tableName=ISSUE_LIST', 'DELETE issue lists of executions and execution-steps to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Changeset ../tm/tm.changelog-1.7.1.xml::tm-1.7.1.issue-2873-13::mpagnon
--  Drop table used to store the ids of the entities to delete
DROP TABLE ENTITIES_TO_DELETE;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.7.1.issue-2873-13', 'mpagnon', '../tm/tm.changelog-1.7.1.xml', NOW(), 14, '8:dc231f69059c5088b3d1a2c631639652', 'dropTable tableName=ENTITIES_TO_DELETE', 'Drop table used to store the ids of the entities to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184354');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

