--  *********************************************************************
--  Update Database Script
--  *********************************************************************
--  Change Log: upgrade.changelog-up-to-1.8.0.xml
--  Ran at: 25/06/2024 20:29
--  Against: root@jdbc:mariadb://mariadb/squashtest
--  Liquibase version: 4.17.2
--  *********************************************************************

--  Lock Database
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 1, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND `LOCKED` = 0;

--  Changeset ../tm/tm.changelog-1.8.0.xml::tm-1.8.0::mpagnon
--  Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.8.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0', 'mpagnon', '../tm/tm.changelog-1.8.0.xml', NOW(), 1, '8:8b6b499d7389ff8110221970eb80c9a7', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::tm-1.8.0.feat-2688::mpagnon
--  add permission READ_UNASSIGNED on Campaign library for all users but TestRunners
insert into ACL_GROUP_PERMISSION (ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID)
      select ACL_GROUP.ID, 4096, ACL_CLASS.ID
      from ACL_GROUP , ACL_CLASS
      where ACL_GROUP.QUALIFIED_NAME != 'squashtest.acl.group.tm.TestRunner'
      and ACL_CLASS.CLASSNAME = 'org.squashtest.tm.domain.campaign.CampaignLibrary';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.feat-2688', 'mpagnon', '../tm/tm.changelog-1.8.0.xml', NOW(), 2, '8:56601fe862e0e0ba8c8a4815ab83b5f7', 'sql', 'add permission READ_UNASSIGNED on Campaign library for all users but TestRunners', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::tm-1.8.0.issue-1846-02::mpagnon
--  Remove the DELETED_ON columns
ALTER TABLE CAMPAIGN_LIBRARY_NODE DROP COLUMN DELETED_ON;

ALTER TABLE TEST_CASE_LIBRARY_NODE DROP COLUMN DELETED_ON;

ALTER TABLE REQUIREMENT_LIBRARY_NODE DROP COLUMN DELETED_ON;

ALTER TABLE ITERATION DROP COLUMN DELETED_ON;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-1846-02', 'mpagnon', '../tm/tm.changelog-1.8.0.xml', NOW(), 3, '8:6673cb98a415026d6fef23212ce1eeb2', 'dropColumn columnName=DELETED_ON, tableName=CAMPAIGN_LIBRARY_NODE; dropColumn columnName=DELETED_ON, tableName=TEST_CASE_LIBRARY_NODE; dropColumn columnName=DELETED_ON, tableName=REQUIREMENT_LIBRARY_NODE; dropColumn columnName=DELETED_ON, tableNam...', 'Remove the DELETED_ON columns', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::tm-1.8.0.issue-3009-01::bsiri
--  As of 1.8.0 anyone that executes a test becomes de facto its assignee. This changeset will update the iteration
--  			test plan items and assign it to the last executor (if any) if it hasn't an assignee already
update ITERATION_TEST_PLAN_ITEM itpi
      set USER_ID = (select cu.PARTY_ID from CORE_USER cu where cu.LOGIN = itpi.LAST_EXECUTED_BY)
      where itpi.USER_ID IS NULL;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-3009-01', 'bsiri', '../tm/tm.changelog-1.8.0.xml', NOW(), 4, '8:a0cfe094f7eb99ad49cd260803846c5e', 'sql', 'As of 1.8.0 anyone that executes a test becomes de facto its assignee. This changeset will update the iteration
			test plan items and assign it to the last executor (if any) if it hasn''t an assignee already', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::core-1.8.0-feat-2699-00::bsiri
--  actually remove user accounts that were deactivated
delete from CORE_TEAM_MEMBER
      where USER_ID in (
      select PARTY_ID from CORE_USER
      where ACTIVE= false
      );

delete from CORE_GROUP_MEMBER
      where PARTY_ID in (
      select PARTY_ID from CORE_USER
      where ACTIVE= false
      );

update ITERATION_TEST_PLAN_ITEM SET USER_ID = NULL WHERE USER_ID IN (SELECT PARTY_ID FROM CORE_USER WHERE active = false );

update CAMPAIGN_TEST_PLAN_ITEM SET USER_ID = NULL WHERE USER_ID IN (SELECT PARTY_ID FROM CORE_USER WHERE active =
      false );

delete from CORE_USER where active = false;

delete from CORE_PARTY where PARTY_ID not in
      (select PARTY_ID from CORE_USER)
      and PARTY_ID not in
      (select PARTY_ID from CORE_TEAM);

delete from AUTH_USER where active= false;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('core-1.8.0-feat-2699-00', 'bsiri', '../tm/tm.changelog-1.8.0.xml', NOW(), 5, '8:bf8b1e3ef0b1c9b26541538750aeb153', 'sql', 'actually remove user accounts that were deactivated', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::core-1.8.0-feat-2699-01::bsiri
--  the CORE_GROUP squashtest.tm.group.User is now renamed to the normalized squashtest.authz.group.tm.User
UPDATE CORE_GROUP SET QUALIFIED_NAME = 'squashtest.authz.group.tm.User' WHERE ID = 2;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('core-1.8.0-feat-2699-01', 'bsiri', '../tm/tm.changelog-1.8.0.xml', NOW(), 6, '8:164df9ae9d3f977b88d2ab101b6ccb1f', 'update tableName=CORE_GROUP', 'the CORE_GROUP squashtest.tm.group.User is now renamed to the normalized squashtest.authz.group.tm.User', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::core-1.8.0-feat-2699-02::bsiri
--  the CORE_GROUP squashtest.authz.tm.group.ProjectManager is deleted and the users belonging to that group are now
--  		demoted to squashtest.authz.group.tm.User
UPDATE CORE_GROUP_MEMBER SET GROUP_ID = '2' WHERE GROUP_ID = 3;

DELETE FROM CORE_GROUP_AUTHORITY WHERE GROUP_ID = 3;

DELETE FROM CORE_GROUP WHERE ID = 3;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('core-1.8.0-feat-2699-02', 'bsiri', '../tm/tm.changelog-1.8.0.xml', NOW(), 7, '8:bca2911749887a9a1b375d20a595dc83', 'update tableName=CORE_GROUP_MEMBER; delete tableName=CORE_GROUP_AUTHORITY; delete tableName=CORE_GROUP', 'the CORE_GROUP squashtest.authz.tm.group.ProjectManager is deleted and the users belonging to that group are now
		demoted to squashtest.authz.group.tm.User', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::core-1.8.0-feat-2699-03::bsiri
--  The table CORE_PARY_AUTHORITY stores personal authorities. As for TM 1.8.0 the users and teams now have blanket permissions
--  			(aka authorities) for themselves, not only via core_group membership. However, a user will still belong to one of the CORE_GROUPs and
--  			the personal authorities will stack with the authorities of the group they belong to.
CREATE TABLE CORE_PARTY_AUTHORITY (PARTY_ID BIGINT NOT NULL COMMENT 'The CORE_PARTY ', AUTHORITY VARCHAR(50) NOT NULL COMMENT 'The authority', CONSTRAINT FK_PARTY_AUTHORITY_PARTY FOREIGN KEY (PARTY_ID) REFERENCES CORE_PARTY(PARTY_ID));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('core-1.8.0-feat-2699-03', 'bsiri', '../tm/tm.changelog-1.8.0.xml', NOW(), 8, '8:be47ff6ce0b7158c0ca139853ce283fd', 'createTable tableName=CORE_PARTY_AUTHORITY', 'The table CORE_PARY_AUTHORITY stores personal authorities. As for TM 1.8.0 the users and teams now have blanket permissions
			(aka authorities) for themselves, not only via core_group membership. However, a user will still belong to one of the CO...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::core-1.8.0-feat-2699-04::bsiri
--  we have now to set the role ROLE_TM_PROJECT_MANAGER to the corresponding users
insert into CORE_PARTY_AUTHORITY(PARTY_ID, AUTHORITY)
      select distinct cu.PARTY_ID, 'ROLE_TM_PROJECT_MANAGER' from CORE_USER cu
      where cu.PARTY_ID in (
      select cu1.PARTY_ID from CORE_USER cu1
      inner join ACL_RESPONSIBILITY_SCOPE_ENTRY arse1 on arse1.PARTY_ID = cu1.PARTY_ID
      where arse1.ACL_GROUP_ID = 5
      )
      or cu.PARTY_ID in (
      select cu2.PARTY_ID from CORE_USER cu2
      inner join CORE_TEAM_MEMBER ctm on ctm.USER_ID = cu2.PARTY_ID
      inner join ACL_RESPONSIBILITY_SCOPE_ENTRY arse2 on arse2.PARTY_ID = ctm.TEAM_ID
      where arse2.ACL_GROUP_ID = 5
      );

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('core-1.8.0-feat-2699-04', 'bsiri', '../tm/tm.changelog-1.8.0.xml', NOW(), 9, '8:02d8d2b9728de4c3bbc5b692bff3ef6d', 'sql', 'we have now to set the role ROLE_TM_PROJECT_MANAGER to the corresponding users', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::tm-1.8.0.issue-2899-1::bsiri
--  Clean up the database from dead entities that slipped through the deletion routines (mysql, postgresql)
SET foreign_key_checks = 0;

delete RESOURCE.* , SIMPLE_RESOURCE.*
      from RESOURCE inner join SIMPLE_RESOURCE on RESOURCE.RES_ID = SIMPLE_RESOURCE.RES_ID
      where SIMPLE_RESOURCE.RES_ID NOT IN (
      select RES_ID from REQUIREMENT_FOLDER
      );

delete ATTACHMENT_LIST.*, ATTACHMENT.*, ATTACHMENT_CONTENT.*
      from ATTACHMENT_LIST
      left join ATTACHMENT on ATTACHMENT_LIST.ATTACHMENT_LIST_ID = ATTACHMENT.ATTACHMENT_LIST_ID
      left join ATTACHMENT_CONTENT on ATTACHMENT_CONTENT.ATTACHMENT_CONTENT_ID = ATTACHMENT.CONTENT_ID
      where ATTACHMENT_LIST.ATTACHMENT_LIST_ID NOT IN(
      select ATTACHMENT_LIST_ID from ACTION_TEST_STEP UNION
      select ATTACHMENT_LIST_ID from CAMPAIGN_LIBRARY UNION
      select ATTACHMENT_LIST_ID from CAMPAIGN_LIBRARY_NODE UNION
      select ATTACHMENT_LIST_ID from EXECUTION UNION
      select ATTACHMENT_LIST_ID from EXECUTION_STEP UNION
      select ATTACHMENT_LIST_ID from ITERATION UNION
      select ATTACHMENT_LIST_ID from PROJECT UNION
      select ATTACHMENT_LIST_ID from REQUIREMENT_LIBRARY UNION
      select ATTACHMENT_LIST_ID from RESOURCE UNION
      select ATTACHMENT_LIST_ID from TEST_CASE_LIBRARY UNION
      select ATTACHMENT_LIST_ID from TEST_CASE_LIBRARY_NODE UNION
      select ATTACHMENT_LIST_ID from TEST_SUITE
      );

SET foreign_key_checks = 1;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2899-1', 'bsiri', '../tm/tm.changelog-1.8.0.xml', NOW(), 10, '8:a545daa4cad19216cee6121b1e4f5db8', 'sql', 'Clean up the database from dead entities that slipped through the deletion routines (mysql, postgresql)', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0.xml::tm-1.8.0.issue-2899-2::bsiri
--  Clean up the database from dead entities that slipped through the deletion routines (h2). Note :
--  			There is no way to perform multi table delete so we must delete the tables one by one.
--  
--  			Since h2 doesn't support multi table delete we must delete the entries one table after the other
--  			and this will cost quite a bit.
--  Changeset ../tm/tm.changelog-1.8.0.xml::tm-1.8.0.issue-2899-2-postgresql::mpagnon
--  Clean up the database from dead entities that slipped through the deletion routines (postgresql).
--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-1-init.xml::tm-1.8.0.issue-2933-init-01::mpagnon
--  create table to store ids of orphan entities to delete
--  create table to store if table has orphan to delete
CREATE TABLE ENTITIES_TO_DELETE (NAME VARCHAR(30) NULL, ID BIGINT NULL);

CREATE TABLE IS_TO_DELETE (NAME VARCHAR(30) NOT NULL, TOTAL INT NULL, CONSTRAINT PK_IS_TO_DELETE PRIMARY KEY (NAME));

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-init-01', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-1-init.xml', NOW(), 11, '8:6a740e41cc1e3986dd83c53e449e6607', 'createTable tableName=ENTITIES_TO_DELETE; createTable tableName=IS_TO_DELETE', 'create table to store ids of orphan entities to delete
create table to store if table has orphan to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-2-requirements.xml::tm-1.8.0.issue-2933-req-01::mpagnon
--  save ids of requirements nodes to delete
--  store info if exist requirement nodes to delete
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'RLN', rln.RLN_ID
			from REQUIREMENT_LIBRARY_NODE rln
			where not exists (
			select 1 from RLN_RELATIONSHIP  where RLN_RELATIONSHIP.DESCENDANT_ID = rln.RLN_ID UNION
			select 1 from REQUIREMENT_LIBRARY_CONTENT where REQUIREMENT_LIBRARY_CONTENT.CONTENT_ID = rln.RLN_ID 
			);

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'RLN', count(1)
			from
			ENTITIES_TO_DELETE where NAME = 'RLN';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-req-01', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-2-requirements.xml', NOW(), 12, '8:3db9a91d4af44f365f13ee3401e29acc', 'sql; sql', 'save ids of requirements nodes to delete
store info if exist requirement nodes to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-2-requirements.xml::tm-1.8.0.issue-2933-req-02::mpagnon
--  add ids of children
--  save ids of resources
--  save requirement_version_coverages ids
--  save if requirement_version_coverage to delete
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select distinct 'RLN',
			rlnrc.DESCENDANT_ID
			from RLN_RELATIONSHIP_CLOSURE rlnrc,
			ENTITIES_TO_DELETE etd
			where etd.NAME = 'RLN'
			and etd.ID =
			rlnrc.ANCESTOR_ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'RESOURCE',
			rv.RES_ID
			from REQUIREMENT_VERSION rv , ENTITIES_TO_DELETE etd
			where
			etd.ID = rv.REQUIREMENT_ID
			and etd.NAME = 'RLN';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'RESOURCE', rf.RES_ID
			from REQUIREMENT_FOLDER rf, ENTITIES_TO_DELETE etd
			where etd.ID = rf.RLN_ID
			and etd.NAME = 'RLN';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select
			'REQUIREMENT_VERSION_COVERAGE', rvc.REQUIREMENT_VERSION_COVERAGE_ID
			from REQUIREMENT_VERSION_COVERAGE rvc, ENTITIES_TO_DELETE etd
			where
			rvc.VERIFIED_REQ_VERSION_ID = etd.ID
			and etd.NAME = 'RESOURCE';

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select
			'REQUIREMENT_VERSION_COVERAGE', count(1)
			from ENTITIES_TO_DELETE where
			NAME = 'REQUIREMENT_VERSION_COVERAGE';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-req-02', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-2-requirements.xml', NOW(), 13, '8:a6101bd2cea942c55edb033bdfbaf1d1', 'sql; sql; sql; sql', 'add ids of children
save ids of resources
save requirement_version_coverages ids
save if requirement_version_coverage to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-2-requirements.xml::tm-1.8.0.issue-2933-req-03::mpagnon
--  delete verifying_steps
--  delete requirement_version_coverages
delete from VERIFYING_STEPS
			where REQUIREMENT_VERSION_COVERAGE_ID
			in
			(
			select ID from ENTITIES_TO_DELETE
			where NAME =
			'REQUIREMENT_VERSION_COVERAGE'
			);

delete from REQUIREMENT_VERSION_COVERAGE
			where
			REQUIREMENT_VERSION_COVERAGE_ID in
			(
			select ID from ENTITIES_TO_DELETE
			where NAME =
			'REQUIREMENT_VERSION_COVERAGE'
			);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-req-03', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-2-requirements.xml', NOW(), 14, '8:d999142439a3e7ef8c913fb9709b5f9b', 'sql; sql', 'delete verifying_steps
delete requirement_version_coverages', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-2-requirements.xml::tm-1.8.0.issue-2933-req-04::mpagnon
--  save ids of requirement_version cufs values to delete
--  save ids of attachment_lists
--  save ids of requirement_audit_event
--  delete requirement_large_property_change
--  delete requirement_creation
--  delete requirement_property_change
--  delete requirement_audit_event
--  set current_version to null
--  delete requirement_version
--  delete rln_relationship
--  delete rln_relationship_closure
--  delete requirement_folder
--  delete requirement
--  delete requirement_library_node
--  delete simple_resource
--  delete resources
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select
			'CUSTOM_FIELD_VALUE' , cfv.CFV_ID
			from CUSTOM_FIELD_VALUE cfv,
			ENTITIES_TO_DELETE etd
			where etd.ID = cfv.BOUND_ENTITY_ID
			and etd.NAME = 'RESOURCE'
			and cfv.BOUND_ENTITY_TYPE = 'REQUIREMENT_VERSION';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ATTACHMENT_LIST',
			r.ATTACHMENT_LIST_ID
			from RESOURCE r , ENTITIES_TO_DELETE etd
			where
			etd.ID = r.RES_ID
			and etd.NAME = 'RESOURCE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select
			'REQUIREMENT_AUDIT_EVENT', rae.EVENT_ID
			from REQUIREMENT_AUDIT_EVENT
			rae, ENTITIES_TO_DELETE etd
			where etd.NAME = 'RESOURCE'
			and etd.ID =
			rae.REQ_VERSION_ID;

delete from REQUIREMENT_LARGE_PROPERTY_CHANGE
			where EVENT_ID in
			(select ID from ENTITIES_TO_DELETE where NAME =
			'REQUIREMENT_AUDIT_EVENT');

delete from REQUIREMENT_CREATION
			where exists (select 1 from	ENTITIES_TO_DELETE 
			where NAME = 'REQUIREMENT_AUDIT_EVENT'
			and ENTITIES_TO_DELETE.ID  = REQUIREMENT_CREATION.EVENT_ID
			);

delete from REQUIREMENT_PROPERTY_CHANGE
			where exists (select 1 
			from ENTITIES_TO_DELETE where NAME = 'REQUIREMENT_AUDIT_EVENT' and REQUIREMENT_PROPERTY_CHANGE.EVENT_ID = ENTITIES_TO_DELETE.ID );

delete from REQUIREMENT_AUDIT_EVENT
			where exists (select 1
			from ENTITIES_TO_DELETE where NAME = 'REQUIREMENT_AUDIT_EVENT' and ID = REQUIREMENT_AUDIT_EVENT.EVENT_ID);

update REQUIREMENT 
			set CURRENT_VERSION_ID = null
			where exists  (select 1
			from ENTITIES_TO_DELETE where NAME = 'RLN' and ID = REQUIREMENT.RLN_ID);

delete from REQUIREMENT_VERSION
			where exists (select 1 from
			ENTITIES_TO_DELETE where NAME = 'RESOURCE' and ID = REQUIREMENT_VERSION.RES_ID);

delete from RLN_RELATIONSHIP
			where exists (select 1
			from
			ENTITIES_TO_DELETE where NAME = 'RLN' and ID = RLN_RELATIONSHIP.DESCENDANT_ID);

delete from RLN_RELATIONSHIP_CLOSURE
			where  exists
			(select 1 from
			ENTITIES_TO_DELETE where NAME = 'RLN' and RLN_RELATIONSHIP_CLOSURE.DESCENDANT_ID = ID);

delete from REQUIREMENT_FOLDER
			where  exists (select 1 from
			ENTITIES_TO_DELETE where NAME = 'RLN' and ID = REQUIREMENT_FOLDER.RLN_ID);

delete from REQUIREMENT
			where  exists (select 1 from
			ENTITIES_TO_DELETE where NAME = 'RLN' and ID = REQUIREMENT.RLN_ID);

delete from REQUIREMENT_LIBRARY_NODE
			where exists (select 1
			from
			ENTITIES_TO_DELETE where NAME = 'RLN' and ID = REQUIREMENT_LIBRARY_NODE.RLN_ID);

delete from SIMPLE_RESOURCE
			where exists (select 1 from
			ENTITIES_TO_DELETE where NAME = 'RESOURCE' and ID = SIMPLE_RESOURCE.RES_ID);

delete from RESOURCE
			where exists (select ID from
			ENTITIES_TO_DELETE where NAME =
			'RESOURCE' and RESOURCE.RES_ID = ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-req-04', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-2-requirements.xml', NOW(), 15, '8:ec70676afb6ff48e05beceb27fe08b6c', 'sql; sql; sql; sql; sql; sql; sql; sql; sql; sql; sql; sql; sql; sql; sql; sql', 'save ids of requirement_version cufs values to delete
save ids of attachment_lists
save ids of requirement_audit_event
delete requirement_large_property_change
delete requirement_creation
delete requirement_property_change
delete requirement_audit...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-01::mpagnon
--  save ids of test case folders to delete
--  store info if exist test case folders to delete
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'TEST_CASE_FOLDER', folder.TCLN_ID
			from TEST_CASE_FOLDER folder
			where not exists (
				select 1  from TCLN_RELATIONSHIP where DESCENDANT_ID = folder.TCLN_ID UNION
				select 1  from TEST_CASE_LIBRARY_CONTENT where CONTENT_ID = folder.TCLN_ID
			);

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'TEST_CASE_FOLDER', count(1)
			from ENTITIES_TO_DELETE
			where NAME = 'TEST_CASE_FOLDER';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-01', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 16, '8:56aeb5471ef88edb7f84c3ebbdb2e34f', 'sql; sql', 'save ids of test case folders to delete
store info if exist test case folders to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-02::mpagnon
--  save ids of children test_case_folders
--  save ids of orphan and children test_case
--  save property if exist test case to delete
--  save ids of attachment_lists
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select distinct 'TEST_CASE_FOLDER', folder.TCLN_ID
			from TEST_CASE_FOLDER folder, TCLN_RELATIONSHIP_CLOSURE tclnrc, ENTITIES_TO_DELETE etd
			where etd.NAME = 'TEST_CASE_FOLDER'
			and etd.ID = tclnrc.ANCESTOR_ID
			and	tclnrc.DESCENDANT_ID = folder.TCLN_ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select distinct 'TEST_CASE', testcase.TCLN_ID
			from TEST_CASE testcase
			where not exists (
				select 1  from TCLN_RELATIONSHIP where DESCENDANT_ID = testcase.TCLN_ID UNION
				select 1  from TEST_CASE_LIBRARY_CONTENT where CONTENT_ID = testcase.TCLN_ID
			);

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select distinct 'TEST_CASE', testcase.TCLN_ID
			from TEST_CASE testcase, TCLN_RELATIONSHIP_CLOSURE tclnrc, ENTITIES_TO_DELETE etd
			where etd.NAME = 'TEST_CASE_FOLDER'
			and etd.ID = tclnrc.ANCESTOR_ID
			and tclnrc.DESCENDANT_ID = testcase.TCLN_ID;

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'TEST_CASE', count(1)
			from ENTITIES_TO_DELETE etd
			where etd.NAME = 'TEST_CASE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ATTACHMENT_LIST', tcln.ATTACHMENT_LIST_ID
			from TEST_CASE_LIBRARY_NODE tcln , ENTITIES_TO_DELETE etd
			where tcln.TCLN_ID = etd.ID
			and etd.NAME in ('TEST_CASE_FOLDER', 'TEST_CASE');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-02', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 17, '8:507be83e208c3cb0a2462e727276df63', 'sql; sql; sql; sql', 'save ids of children test_case_folders
save ids of orphan and children test_case
save property if exist test case to delete
save ids of attachment_lists', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-03::mpagnon
--  empty ids of requirement_version_coverage to delete from requirements deletion
--  save ids of requirement_version_coverage
--  save ids of test_case cufs values to delete
--  save ids of campaign concerned by campaign_test_plan_item deletion
--  save all parameter ids
--  save all dataset ids
--  save automated_test_ids
--  save test_step ids
--  save ids of test_step calling deleted test cases
--  set tcln_id to null on execution table
--  set tcln_id to null on iteration_test_plan_item
delete from ENTITIES_TO_DELETE
			where NAME = 'REQUIREMENT_VERSION_COVERAGE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'REQUIREMENT_VERSION_COVERAGE', rvc.REQUIREMENT_VERSION_COVERAGE_ID
			from REQUIREMENT_VERSION_COVERAGE rvc, ENTITIES_TO_DELETE etd
			where rvc.VERIFYING_TEST_CASE_ID = etd.ID
			and etd.NAME = 'TEST_CASE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CUSTOM_FIELD_VALUE', cfv.CFV_ID
			from CUSTOM_FIELD_VALUE cfv, ENTITIES_TO_DELETE etd
			where etd.ID = cfv.BOUND_ENTITY_ID
			and cfv.BOUND_ENTITY_TYPE = 'TEST_CASE'
			and etd.NAME = 'TEST_CASE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CTPI_CAMPAIGN' , ctpi.CAMPAIGN_ID
			from CAMPAIGN_TEST_PLAN_ITEM ctpi, ENTITIES_TO_DELETE etd
			where etd.ID = ctpi.TEST_CASE_ID
			and etd.NAME = 'TEST_CASE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'PARAMETER', param.PARAM_ID
			from PARAMETER param, ENTITIES_TO_DELETE etd
			where etd.ID = param.TEST_CASE_ID
			and etd.NAME = 'TEST_CASE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'DATASET', ds.DATASET_ID
			from DATASET ds, ENTITIES_TO_DELETE etd
			where etd.ID = ds.TEST_CASE_ID
			and etd.NAME = 'TEST_CASE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'AUTOMATED_TEST', tc.TA_TEST
			from TEST_CASE tc, ENTITIES_TO_DELETE etd
			where etd.ID = tc.TCLN_ID
			and etd.NAME = 'TEST_CASE'
			and tc.TA_TEST is not null;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'TEST_STEP', tcs.STEP_ID
			from TEST_CASE_STEPS tcs, ENTITIES_TO_DELETE etd
			where etd.ID = tcs.TEST_CASE_ID
			and etd.NAME = 'TEST_CASE';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CALLING_STEP', cts.TEST_STEP_ID
			from CALL_TEST_STEP cts, ENTITIES_TO_DELETE etd
			where etd.ID = cts.CALLED_TEST_CASE_ID
			and etd.NAME = 'TEST_CASE';

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'CALLING_STEP', count(1)
			from ENTITIES_TO_DELETE etd
			where etd.NAME = 'CALLING_STEP';

update EXECUTION
			set TCLN_ID = null
			where exists (select 1
			from ENTITIES_TO_DELETE where NAME = 'TEST_CASE' and ID = EXECUTION.TCLN_ID );

update ITERATION_TEST_PLAN_ITEM
			set TCLN_ID = null
			where exists (select ID from ENTITIES_TO_DELETE where NAME = 'TEST_CASE' and ID = ITERATION_TEST_PLAN_ITEM.TCLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-03', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 18, '8:bb5cb232bb4f001a27fc87d13c3098eb', 'sql; sql; sql; sql; sql; sql; sql; sql; sql; sql; sql; sql', 'empty ids of requirement_version_coverage to delete from requirements deletion
save ids of requirement_version_coverage
save ids of test_case cufs values to delete
save ids of campaign concerned by campaign_test_plan_item deletion
save all paramet...', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-04::mpagnon
--  delete verifying_steps
delete from VERIFYING_STEPS
			where  exists (
				select 1 from ENTITIES_TO_DELETE where NAME = 'REQUIREMENT_VERSION_COVERAGE'
				and REQUIREMENT_VERSION_COVERAGE_ID = ID
			);

delete from REQUIREMENT_VERSION_COVERAGE
			where  exists (
				select 1 from ENTITIES_TO_DELETE where NAME = 'REQUIREMENT_VERSION_COVERAGE'
				and REQUIREMENT_VERSION_COVERAGE.REQUIREMENT_VERSION_COVERAGE_ID = ID
			);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-04', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 19, '8:e8d94066d5fcdeacf7e61036c0daa490', 'sql; sql', 'delete verifying_steps', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-05-mysql::mpagnon
--  delete campaign_test_plan_item
--  reorder test plan of campaign where deletion of campaign_test_plan_item occurred
delete from CAMPAIGN_TEST_PLAN_ITEM
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE' and CAMPAIGN_TEST_PLAN_ITEM.TEST_CASE_ID = ID);

create table CAMPAIGN_TEST_PLAN_ITEM_TEMP(
			CAMPAIGN_ID BIGINT NOT NULL,
			CTPI_ID BIGINT NOT NULL,
			TEST_PLAN_ORDER INT NOT NULL
			);

set @rownum:=0;

insert into CAMPAIGN_TEST_PLAN_ITEM_TEMP
			(CAMPAIGN_ID, CTPI_ID, TEST_PLAN_ORDER)
			select CAMPAIGN_ID, CTPI_ID, @rownum:=@rownum+1 as globindex
			from CAMPAIGN_TEST_PLAN_ITEM
			where  exists (
				select ID from ENTITIES_TO_DELETE where NAME = 'CTPI_CAMPAIGN'and ID = CAMPAIGN_TEST_PLAN_ITEM.CAMPAIGN_ID
			)
			group by CAMPAIGN_ID, CTPI_ID, globindex
			order by TEST_PLAN_ORDER;

create table CAMPAIGN_TEST_PLAN_ITEM_TEMP2
			(
			CAMPAIGN_ID
			BIGINT NOT NULL,
			CTPI_ID BIGINT NOT NULL,
			TEST_PLAN_ORDER INT NOT NULL
			);

insert into CAMPAIGN_TEST_PLAN_ITEM_TEMP2
			select *
			from CAMPAIGN_TEST_PLAN_ITEM_TEMP;

update CAMPAIGN_TEST_PLAN_ITEM ctpi
			set TEST_PLAN_ORDER = (
				select count( ctpit2.CTPI_ID )
				from CAMPAIGN_TEST_PLAN_ITEM_TEMP ctpit1,CAMPAIGN_TEST_PLAN_ITEM_TEMP2 ctpit2
				where ctpit1.CTPI_ID = ctpi.CTPI_ID
				and ctpit2.CAMPAIGN_ID = ctpit1.CAMPAIGN_ID
				and ctpit1.TEST_PLAN_ORDER > ctpit2.TEST_PLAN_ORDER
			)
			where ctpi.CTPI_ID in (select DISTINCT ctpi3.CTPI_ID from CAMPAIGN_TEST_PLAN_ITEM_TEMP ctpi3);

drop table CAMPAIGN_TEST_PLAN_ITEM_TEMP;

drop table CAMPAIGN_TEST_PLAN_ITEM_TEMP2;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-05-mysql', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 20, '8:536948f52d282f0ee5a1db33a8329008', 'sql; sql', 'delete campaign_test_plan_item
reorder test plan of campaign where deletion of campaign_test_plan_item occurred', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-05-h2::mpagnon
--  delete campaign_test_plan_item
--  reorder test plan of campaign where deletion of campaign_test_plan_item occurred
--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-05-postgre::mpagnon
--  delete campaign_test_plan_item
--  reorder test plan of campaign where deletion of campaign_test_plan_item occurred
--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-06::mpagnon
--  set dataset to null in referenced entity
--  delete dataset_param_value where dataset id
--  delete dataset
update ITERATION_TEST_PLAN_ITEM
			set DATASET_ID = null
			where exists (select 1 from ENTITIES_TO_DELETE where NAME ='DATASET' and ID = ITERATION_TEST_PLAN_ITEM.DATASET_ID);

delete from DATASET_PARAM_VALUE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'DATASET' and DATASET_PARAM_VALUE.DATASET_ID = ID);

delete from DATASET
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'DATASET' and ID = DATASET.DATASET_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-06', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 21, '8:f6430b2ab1714b77868744c542b5be86', 'sql; sql; sql', 'set dataset to null in referenced entity
delete dataset_param_value where dataset id
delete dataset', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-07::mpagnon
--  delete dataset_param_value where param_id
--  delete parameters
delete from DATASET_PARAM_VALUE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'PARAMETER' and ID = DATASET_PARAM_VALUE.PARAM_ID);

delete from PARAMETER
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'PARAMETER' and PARAMETER.PARAM_ID = ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-07', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 22, '8:22c28509839b3d68cf4513f4051a91de', 'sql; sql', 'delete dataset_param_value where param_id
delete parameters', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-08::mpagnon
--  delete automated_execution_extender
--  delete automated_suite where not exist automated_execution_extender linked to it
delete from AUTOMATED_EXECUTION_EXTENDER
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'AUTOMATED_TEST' and AUTOMATED_EXECUTION_EXTENDER.TEST_ID = ID);

delete from AUTOMATED_SUITE
			where not exists (select 1 from AUTOMATED_EXECUTION_EXTENDER where AUTOMATED_EXECUTION_EXTENDER.SUITE_ID = AUTOMATED_SUITE.SUITE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-08', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 23, '8:e2a55d4483531ec852b64278200f985b', 'sql; sql', 'delete automated_execution_extender
delete automated_suite where not exist automated_execution_extender linked to it', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-09::mpagnon
--  save ids of step cufs values to delete
--  set test_step_id to null on execution_step table
--  save ids of steps attachment_list
--  delete test_case_steps
--  delete call_step
--  delete action_step
--  delete test step
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CUSTOM_FIELD_VALUE', cfv.CFV_ID
			from CUSTOM_FIELD_VALUE cfv, ENTITIES_TO_DELETE etd
			where etd.ID = cfv.BOUND_ENTITY_ID
			and cfv.BOUND_ENTITY_TYPE = 'TEST_STEP'
			and etd.NAME = 'TEST_STEP';

update EXECUTION_STEP
			set TEST_STEP_ID = null
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_STEP' and ID = EXECUTION_STEP.TEST_STEP_ID);

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ATTACHMENT_LIST', ats.ATTACHMENT_LIST_ID
			from ACTION_TEST_STEP ats, ENTITIES_TO_DELETE etd
			where ats.TEST_STEP_ID = etd.ID
			and etd.NAME = 'TEST_STEP';

delete from TEST_CASE_STEPS
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE' and TEST_CASE_STEPS.TEST_CASE_ID = ID);

delete from CALL_TEST_STEP
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_STEP' and CALL_TEST_STEP.TEST_STEP_ID = ID);

delete from ACTION_TEST_STEP
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_STEP' and ACTION_TEST_STEP.TEST_STEP_ID = ID);

delete from TEST_STEP
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_STEP' and TEST_STEP.TEST_STEP_ID = ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-09', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 24, '8:7ba0fef7fc30e6a854a16aa21f8c7d60', 'sql; sql; sql; sql; sql; sql; sql', 'save ids of step cufs values to delete
set test_step_id to null on execution_step table
save ids of steps attachment_list
delete test_case_steps
delete call_step
delete action_step
delete test step', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-10::mpagnon
--  save ids of calling test case
--  set null to test_step_id on execution_step
--  delete test_step and call_test_step
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CALLING_TEST_CASE' , tcs.TEST_CASE_ID
			from TEST_CASE_STEPS tcs ,	ENTITIES_TO_DELETE etd
			where tcs.STEP_ID = etd.ID
			and etd.NAME =	'CALLING_STEP';

update EXECUTION_STEP
			set TEST_STEP_ID = null
			where TEST_STEP_ID in
			(select ID from ENTITIES_TO_DELETE where NAME = 'CALLING_STEP');

delete from CALL_TEST_STEP
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CALLING_STEP' and ID = CALL_TEST_STEP.TEST_STEP_ID);

delete from TEST_CASE_STEPS
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CALLING_STEP' and ID = TEST_CASE_STEPS.STEP_ID);

delete from TEST_STEP
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CALLING_STEP' and ID = TEST_STEP.TEST_STEP_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-10', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 25, '8:52dfe84f3d62c0a9c0c7d0bdfdea51be', 'sql; sql; sql', 'save ids of calling test case
set null to test_step_id on execution_step
delete test_step and call_test_step', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-11-mysql::mpagnon
--  reorder steps of calling test case
create table TEST_CASE_STEPS_TEMP(
			TEST_CASE_ID
			BIGINT
			NOT NULL,
			STEP_ID BIGINT NOT NULL,
			STEP_ORDER INT NOT NULL
			);

set @rownum:=0;

insert into TEST_CASE_STEPS_TEMP
			(TEST_CASE_ID, STEP_ID, STEP_ORDER)
			select TEST_CASE_ID, STEP_ID, @rownum:=@rownum+1 as globindex
			from TEST_CASE_STEPS
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'tcs_CAMPAIGN' and ID = TEST_CASE_STEPS.TEST_CASE_ID)
			group by TEST_CASE_ID, STEP_ID, globindex
			order by STEP_ORDER;

create table TEST_CASE_STEPS_TEMP2 (
			TEST_CASE_ID BIGINT NOT NULL,
			STEP_ID BIGINT NOT NULL,
			STEP_ORDER INT NOT NULL
			);

insert into TEST_CASE_STEPS_TEMP2
			select * from TEST_CASE_STEPS_TEMP;

update TEST_CASE_STEPS tcs
			set STEP_ORDER = (
				select count( tcst2.STEP_ID )
				from TEST_CASE_STEPS_TEMP tcst1,TEST_CASE_STEPS_TEMP2 tcst2
				where tcst1.STEP_ID = tcs.STEP_ID
				and tcst2.TEST_CASE_ID = tcst1.TEST_CASE_ID
				and tcst1.STEP_ORDER > tcst2.STEP_ORDER
			)
			where tcs.STEP_ID in (select DISTINCT tcst3.STEP_ID from TEST_CASE_STEPS_TEMP tcst3);

drop table TEST_CASE_STEPS_TEMP;

drop table TEST_CASE_STEPS_TEMP2;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-11-mysql', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 26, '8:82aa7dca19daeebbe6eda0be2bf10d4d', 'sql', 'reorder steps of calling test case', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-11-h2::mpagnon
--  reorder steps of calling test case
--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-11-postgresql::mpagnon
--  reorder steps of calling test case
--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-12::mpagnon
--  delete tcln_relationship_closure for test case
--  delete tcln_relationship for test case
--  delete test_cases
--  delete test_case_library_node
delete from TCLN_RELATIONSHIP_CLOSURE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE' and ID = TCLN_RELATIONSHIP_CLOSURE.DESCENDANT_ID);

delete from TCLN_RELATIONSHIP
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE' and ID = TCLN_RELATIONSHIP.DESCENDANT_ID);

delete from TEST_CASE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE' and ID = TEST_CASE.TCLN_ID);

delete from TEST_CASE_LIBRARY_NODE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE' and ID = TEST_CASE_LIBRARY_NODE.TCLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-12', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 27, '8:1a75566cee5ae726f7730e5c9b6c8424', 'sql; sql; sql; sql', 'delete tcln_relationship_closure for test case
delete tcln_relationship for test case
delete test_cases
delete test_case_library_node', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml::tm-1.8.0.issue-2933-tc-13::mpagnon
--  delete tcln_relationship_closure for test case folder
--  delete tcln_relationship for test case folder
--  delete test_case_folder
--  delete test_case_library_node
delete from TCLN_RELATIONSHIP_CLOSURE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE_FOLDER' and ID = TCLN_RELATIONSHIP_CLOSURE.DESCENDANT_ID);

delete from TCLN_RELATIONSHIP
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE_FOLDER' and ID = TCLN_RELATIONSHIP.DESCENDANT_ID);

delete from TEST_CASE_FOLDER
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE_FOLDER' and ID = TEST_CASE_FOLDER.TCLN_ID);

delete from TEST_CASE_LIBRARY_NODE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_CASE_FOLDER' and ID = TEST_CASE_LIBRARY_NODE.TCLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-tc-13', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-3-testcases.xml', NOW(), 28, '8:d5a7767ad233f6eab6508394d3e28010', 'sql; sql; sql; sql', 'delete tcln_relationship_closure for test case folder
delete tcln_relationship for test case folder
delete test_case_folder
delete test_case_library_node', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-01::mpagnon
--  save ids of campaign folders to delete
--  store info if exist campaign folders to delete
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CAMPAIGN_FOLDER',
			folder.CLN_ID
			from CAMPAIGN_FOLDER folder
			where not exists (
			select 1  from CLN_RELATIONSHIP where DESCENDANT_ID = folder.CLN_ID  UNION
			select 1  from CAMPAIGN_LIBRARY_CONTENT where CONTENT_ID = folder.CLN_ID 
			);

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'CAMPAIGN_FOLDER',
			count(1)
			from ENTITIES_TO_DELETE
			where NAME = 'CAMPAIGN_FOLDER';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-01', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 29, '8:f834705f9feb9966792ea6f32efb2961', 'sql; sql', 'save ids of campaign folders to delete
store info if exist campaign folders to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-02::mpagnon
--  save is of children campaign_folders
--  save ids of attachment_lists
--  save if campaign to delete exists
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CAMPAIGN_FOLDER', cf.CLN_ID
			from CAMPAIGN_FOLDER cf, CLN_RELATIONSHIP_CLOSURE crc, ENTITIES_TO_DELETE etd
			where cf.CLN_ID = crc.DESCENDANT_ID
			and crc.ANCESTOR_ID = etd.ID
			and etd.NAME = 'CAMPAIGN_FOLDER';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CAMPAIGN', c.CLN_ID
			from CAMPAIGN c, CLN_RELATIONSHIP_CLOSURE crc, ENTITIES_TO_DELETE etd
			where c.CLN_ID = crc.DESCENDANT_ID
			and crc.ANCESTOR_ID = etd.ID
			and etd.NAME = 'CAMPAIGN_FOLDER';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ATTACHMENT_LIST', cln.ATTACHMENT_LIST_ID
			from CAMPAIGN_LIBRARY_NODE cln, ENTITIES_TO_DELETE etd
			where cln.CLN_ID = etd.ID
			and etd.NAME in ('CAMPAIGN_FOLDER', 'CAMPAIGN');

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'CAMPAIGN', count(1)
			from ENTITIES_TO_DELETE etd
			where etd.NAME = 'CAMPAIGN';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-02', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 30, '8:f592f6b000d21c5d6aa4df23ecdd2b09', 'sql; sql; sql', 'save is of children campaign_folders
save ids of attachment_lists
save if campaign to delete exists', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-03::mpagnon
--  save ids of campaign cuf_values
--  delete campaign_test_plan_item
--  save ids of iterations
--  save iteration to delete property
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CUSTOM_FIELD_VALUE', cfv.CFV_ID
			from CUSTOM_FIELD_VALUE cfv, ENTITIES_TO_DELETE etd
			where cfv.BOUND_ENTITY_TYPE = 'CAMPAIGN'
			and cfv.BOUND_ENTITY_ID = etd.ID
			and etd.NAME = 'CAMPAIGN';

delete from CAMPAIGN_TEST_PLAN_ITEM
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN' and ID = CAMPAIGN_TEST_PLAN_ITEM.CAMPAIGN_ID);

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ITERATION', ci.ITERATION_ID
			from CAMPAIGN_ITERATION ci, ENTITIES_TO_DELETE etd
			where etd.NAME = 'CAMPAIGN'
			and ci.CAMPAIGN_ID = etd.ID;

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'ITERATION', count(1)
			from ENTITIES_TO_DELETE etd
			where etd.NAME = 'ITERATION';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-03', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 31, '8:598954c2985cf7723d4cc66ccb2703f0', 'sql; sql; sql; sql', 'save ids of campaign cuf_values
delete campaign_test_plan_item
save ids of iterations
save iteration to delete property', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-04::mpagnon
--  save ids of attachment_list
--  save ids of custom_field_values
--  save ids of iteration_test_plan_item
--  save ids of test_suite
--  save if itpi to delete property
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ATTACHMENT_LIST', it.ATTACHMENT_LIST_ID
			from ITERATION it, ENTITIES_TO_DELETE etd
			where etd.NAME = 'ITERATION'
			and etd.ID = it.ITERATION_ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CUSTOM_FIELD_VALUE', cfv.CFV_ID
			from CUSTOM_FIELD_VALUE cfv, ENTITIES_TO_DELETE etd
			where etd.NAME = 'ITERATION'
			and etd.ID = cfv.BOUND_ENTITY_ID
			and cfv.BOUND_ENTITY_TYPE = 'ITERATION';

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ITPI', itpl.ITEM_TEST_PLAN_ID
			from ITEM_TEST_PLAN_LIST itpl, ENTITIES_TO_DELETE etd
			where etd.NAME = 'ITERATION'
			and etd.ID = itpl.ITERATION_ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'TEST_SUITE', its.TEST_SUITE_ID
			from ITERATION_TEST_SUITE its, ENTITIES_TO_DELETE etd
			where etd.NAME = 'ITERATION'
			and etd.ID = its.ITERATION_ID;

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'TEST_SUITE', count(1)
			from ENTITIES_TO_DELETE etd
			where etd.NAME = 'TEST_SUITE';

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'ITPI', count(1)
			from ENTITIES_TO_DELETE etd
			where etd.NAME = 'ITPI';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-04', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 32, '8:7411415fe6192aa0cbde46f6ecf2659a', 'sql; sql; sql; sql; sql; sql', 'save ids of attachment_list
save ids of custom_field_values
save ids of iteration_test_plan_item
save ids of test_suite
save if itpi to delete property', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-05::mpagnon
--  save ids of execution
--  save execution to delete property
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'EXECUTION' , itpe.EXECUTION_ID
			from ITEM_TEST_PLAN_EXECUTION itpe, ENTITIES_TO_DELETE etd
			where etd.ID = itpe.ITEM_TEST_PLAN_ID
			and etd.NAME = 'ITPI';

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'EXECUTION', count(1)
			from ENTITIES_TO_DELETE etd
			where etd.NAME = 'EXECUTION';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-05', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 33, '8:2aa01475c5e0e34116bbfa4298d8ebc5', 'sql; sql', 'save ids of execution
save execution to delete property', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-06::mpagnon
--  save ids of attachment_list
--  save ids of issue_list
--  save ids of automated_execution_extender
--  save ids of execution_step
--  save if execution step to delete
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ATTACHMENT_LIST', e.ATTACHMENT_LIST_ID
			from EXECUTION e , ENTITIES_TO_DELETE etd
			where etd.NAME = 'EXECUTION'
			and e.EXECUTION_ID = etd.ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ISSUE_LIST', e.ISSUE_LIST_ID
			from EXECUTION e , ENTITIES_TO_DELETE etd
			where etd.NAME = 'EXECUTION'
			and e.EXECUTION_ID = etd.ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'AUTOMATED_EXECUTION_EXTENDER', aee.EXTENDER_ID
			from AUTOMATED_EXECUTION_EXTENDER aee, ENTITIES_TO_DELETE etd
			where etd.NAME = 'EXECUTION'
			and etd.ID = aee.MASTER_EXECUTION_ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'EXECUTION_STEP', ees.EXECUTION_STEP_ID
			from EXECUTION_EXECUTION_STEPS ees, ENTITIES_TO_DELETE etd
			where etd.NAME = 'EXECUTION'
			and etd.ID = ees.EXECUTION_ID;

insert into IS_TO_DELETE
			(NAME, TOTAL)
			select 'EXECUTION_STEP', count(1)
			from ENTITIES_TO_DELETE etd
			where etd.NAME = 'EXECUTION_STEP';

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-06', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 34, '8:ea38529ecaad5e78059963b59039bac2', 'sql; sql; sql; sql; sql', 'save ids of attachment_list
save ids of issue_list
save ids of automated_execution_extender
save ids of execution_step
save if execution step to delete', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-07::mpagnon
--  delete automated_execution_extender
--  delete automated_suite where not exist automated_execution_extender linked to it
delete from AUTOMATED_EXECUTION_EXTENDER
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'AUTOMATED_EXECUTION_EXTENDER' and ID = AUTOMATED_EXECUTION_EXTENDER.EXTENDER_ID);

delete from AUTOMATED_SUITE
			where not exists (select 1 from AUTOMATED_EXECUTION_EXTENDER where AUTOMATED_EXECUTION_EXTENDER.SUITE_ID = AUTOMATED_SUITE.SUITE_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-07', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 35, '8:e84d0b01262773724d9c5d6f8409e4bf', 'sql; sql', 'delete automated_execution_extender
delete automated_suite where not exist automated_execution_extender linked to it', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-08::mpagnon
--  save ids of issue_list
--  save ids of attachment_list
--  delete execution steps
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ISSUE_LIST', es.ISSUE_LIST_ID
			from EXECUTION_STEP es, ENTITIES_TO_DELETE etd
			where etd.NAME = 'EXECUTION_STEP'
			and etd.ID = es.EXECUTION_STEP_ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ATTACHMENT_LIST', es.ATTACHMENT_LIST_ID
			from EXECUTION_STEP es, ENTITIES_TO_DELETE etd
			where etd.NAME = 'EXECUTION_STEP'
			and etd.ID = es.EXECUTION_STEP_ID;

delete from EXECUTION_EXECUTION_STEPS
			where  exists  (select 1 from ENTITIES_TO_DELETE where NAME = 'EXECUTION' and ID = EXECUTION_EXECUTION_STEPS.EXECUTION_ID);

delete from EXECUTION_STEP
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'EXECUTION_STEP' and ID = EXECUTION_STEP.EXECUTION_STEP_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-08', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 36, '8:4adf7b99fa603bc26bc4e0db3d1eef6d', 'sql; sql; sql', 'save ids of issue_list
save ids of attachment_list
delete execution steps', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-09::mpagnon
--  delete executions
--  delete issues
--  delete issue_lists
delete from ITEM_TEST_PLAN_EXECUTION
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'ITPI' and ID = ITEM_TEST_PLAN_EXECUTION.ITEM_TEST_PLAN_ID);

delete from EXECUTION 
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'EXECUTION' and ID = EXECUTION.EXECUTION_ID);

delete from ISSUE
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'ISSUE_LIST' and ID = ISSUE.ISSUE_LIST_ID);

delete from ISSUE_LIST
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'ISSUE_LIST' and ID = ISSUE_LIST.ISSUE_LIST_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-09', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 37, '8:a05f70572a9a1aee3ed05177ec985cf0', 'sql; sql; sql', 'delete executions
delete issues
delete issue_lists', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-10::mpagnon
--  delete item_test_plan_list
--  delete test_suite_test_plan_item
--  delete iteration_test_plan_item
delete from ITEM_TEST_PLAN_LIST
			where exists (select 1 from ENTITIES_TO_DELETE where NAME ='ITERATION' and ID = ITEM_TEST_PLAN_LIST.ITERATION_ID);

delete from TEST_SUITE_TEST_PLAN_ITEM
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_SUITE' and ID = TEST_SUITE_TEST_PLAN_ITEM.SUITE_ID);

delete from ITERATION_TEST_PLAN_ITEM
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'ITPI' and ID = ITERATION_TEST_PLAN_ITEM.ITEM_TEST_PLAN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-10', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 38, '8:8bc29ed60868d52130cfcbf820e7c462', 'sql; sql; sql', 'delete item_test_plan_list
delete test_suite_test_plan_item
delete iteration_test_plan_item', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-11::mpagnon
--  save ids of attachment_list
--  save ids of custom_field_values
--  delete iteartion_test_suite
--  delete test_suites
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'ATTACHMENT_LIST', ts.ATTACHMENT_LIST_ID
			from TEST_SUITE ts, ENTITIES_TO_DELETE etd
			where etd.NAME = 'TEST_SUITE'
			and etd.ID = ts.ID;

insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select 'CUSTOM_FIELD_VALUE', cfv.CFV_ID
			from CUSTOM_FIELD_VALUE cfv, ENTITIES_TO_DELETE etd
			where etd.NAME = 'TEST_SUITE'
			and etd.ID = cfv.BOUND_ENTITY_ID
			and cfv.BOUND_ENTITY_TYPE = 'TEST_SUITE';

delete from ITERATION_TEST_SUITE
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'ITERATION' and ID = ITERATION_TEST_SUITE.ITERATION_ID);

delete from TEST_SUITE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'TEST_SUITE' and ENTITIES_TO_DELETE.ID = TEST_SUITE.ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-11', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 39, '8:819a2e97a1805df34c49d1c0ad12efba', 'sql; sql; sql; sql', 'save ids of attachment_list
save ids of custom_field_values
delete iteartion_test_suite
delete test_suites', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-12::mpagnon
--  delete campaign_iteration
--  delete iterations
delete from CAMPAIGN_ITERATION
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN' and ID = CAMPAIGN_ITERATION.CAMPAIGN_ID);

delete from ITERATION
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'ITERATION' and ID = ITERATION.ITERATION_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-12', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 40, '8:baebe7332c943763631560e56e2090a9', 'sql; sql', 'delete campaign_iteration
delete iterations', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-13::mpagnon
--  delete cln_relationship
--  delete cln_relationship_closure
--  delete campaign
--  delete campaign_library_nodes
delete from CLN_RELATIONSHIP
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN' and ID = CLN_RELATIONSHIP.DESCENDANT_ID);

delete from CLN_RELATIONSHIP_CLOSURE
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN' and ID = CLN_RELATIONSHIP_CLOSURE.DESCENDANT_ID);

delete from CAMPAIGN
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN' and ID = CAMPAIGN.CLN_ID);

delete from CAMPAIGN_LIBRARY_NODE
			where exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN' and ID = CAMPAIGN_LIBRARY_NODE.CLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-13', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 41, '8:52d77ae5b6d2ced88fcb9484572a2c97', 'sql; sql; sql; sql', 'delete cln_relationship
delete cln_relationship_closure
delete campaign
delete campaign_library_nodes', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml::tm-1.8.0.issue-2933-camp-14::mpagnon
--  delete cln_relationship_closure
--  delete campaign folder
--  delete campaign_library_nodes
delete from CLN_RELATIONSHIP
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN_FOLDER' and ID = CLN_RELATIONSHIP.DESCENDANT_ID);

delete from CLN_RELATIONSHIP_CLOSURE
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN_FOLDER' and ID = CLN_RELATIONSHIP_CLOSURE.DESCENDANT_ID);

delete from CAMPAIGN_FOLDER
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN_FOLDER' and ID = CAMPAIGN_FOLDER.CLN_ID);

delete from CAMPAIGN_LIBRARY_NODE
			where  exists (select 1 from ENTITIES_TO_DELETE where NAME = 'CAMPAIGN_FOLDER' and ID = CLN_ID);

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-camp-14', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-4-campaigns.xml', NOW(), 42, '8:e7d215dd76646d07973cd8881f8f0feb', 'sql; sql; sql; sql', 'delete cln_relationship_closure
delete campaign folder
delete campaign_library_nodes', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-5-end.xml::tm-1.8.0.issue-2933-101::mpagnon
--  save attachment_content ids
--  delete attachment
--  delete attachment_content
--  delete attachment_list
insert into ENTITIES_TO_DELETE
			(NAME, ID)
			select
			'ATTACHMENT_CONTENT', attach.CONTENT_ID
			from ATTACHMENT attach,
			ENTITIES_TO_DELETE etd
			where etd.NAME = 'ATTACHMENT_LIST'
			and etd.ID =
			attach.ATTACHMENT_LIST_ID;

delete from ATTACHMENT
			where ATTACHMENT_LIST_ID in (select ID from
			ENTITIES_TO_DELETE where NAME = 'ATTACHMENT_LIST');

delete from ATTACHMENT_CONTENT
			where ATTACHMENT_CONTENT_ID in
			(select ID from ENTITIES_TO_DELETE where NAME = 'ATTACHMENT_CONTENT');

delete from ATTACHMENT_LIST
			where ATTACHMENT_LIST_ID in (select ID
			from ENTITIES_TO_DELETE where NAME = 'ATTACHMENT_LIST');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-101', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-5-end.xml', NOW(), 43, '8:444beaabf27c74f8f63f5eb02e73ba44', 'sql; sql; sql; sql', 'save attachment_content ids
delete attachment
delete attachment_content
delete attachment_list', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-5-end.xml::tm-1.8.0.issue-2933-end-01::mpagnon
--  delete cuf values
delete from CUSTOM_FIELD_VALUE
			where CFV_ID in (select ID from
			ENTITIES_TO_DELETE where NAME =
			'CUSTOM_FIELD_VALUE');

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-end-01', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-5-end.xml', NOW(), 44, '8:e198ffa36a22d6cb5ca087373be50d33', 'sql', 'delete cuf values', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Changeset ../tm/tm.changelog-1.8.0-issue-2933-5-end.xml::tm-1.8.0.issue-2933-end-02::mpagnon
--  delete storage tables
DROP TABLE ENTITIES_TO_DELETE;

DROP TABLE IS_TO_DELETE;

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, `DESCRIPTION`, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.8.0.issue-2933-end-02', 'mpagnon', '../tm/tm.changelog-1.8.0-issue-2933-5-end.xml', NOW(), 45, '8:c460ceccb9afc2464b2e1bc2ce2e63ac', 'dropTable tableName=ENTITIES_TO_DELETE; dropTable tableName=IS_TO_DELETE', 'delete storage tables', 'EXECUTED', NULL, NULL, '4.17.2', '9340184419');

--  Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET `LOCKED` = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

