-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.14.1.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.14.1.xml::tm-1.14.1::bsiri
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.14.1' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.14.1', 'bsiri', '../tm/tm.changelog-1.14.1.xml', NOW(), 1, '8:a4951c9aab722dc6da389d1fbbea4de6', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187637');

-- Changeset ../tm/tm.changelog-1.14.1.xml::tm-1.14.1-issue-6340-1::bsiri
-- For the purpose of the cleanup to come, we must activate on delete cascade
--             between DENORMALIZED_FIELD_OPTION and DENORMALIZED_FIELD_VALUE
ALTER TABLE DENORMALIZED_FIELD_OPTION DROP CONSTRAINT fk_df_option_dfv;

ALTER TABLE DENORMALIZED_FIELD_OPTION ADD CONSTRAINT fk_df_option_dfv FOREIGN KEY (DFV_ID) REFERENCES DENORMALIZED_FIELD_VALUE (DFV_ID) ON DELETE CASCADE;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.14.1-issue-6340-1', 'bsiri', '../tm/tm.changelog-1.14.1.xml', NOW(), 2, '8:2a456f87ed5132be98b83b0d7e8e28c7', 'dropForeignKeyConstraint baseTableName=DENORMALIZED_FIELD_OPTION, constraintName=fk_df_option_dfv; addForeignKeyConstraint baseTableName=DENORMALIZED_FIELD_OPTION, constraintName=fk_df_option_dfv, referencedTableName=DENORMALIZED_FIELD_VALUE', 'For the purpose of the cleanup to come, we must activate on delete cascade
            between DENORMALIZED_FIELD_OPTION and DENORMALIZED_FIELD_VALUE', 'EXECUTED', NULL, NULL, '4.17.2', '9340187637');

-- Changeset ../tm/tm.changelog-1.14.1.xml::tm-1.14.1-issue-6340-2a::bsiri
-- Fixing the extraneous custom field values (for test cases) and denormalized field values (for executions)
--           for Postgresql.
--           Note about the ordering (in the partition instruction) : I've empirically found that it must be ascending
--           for table DENORMALIZED_FIELD_VALUE and descending for CUSTOm_FIELD_VALUE because of
delete from DENORMALIZED_FIELD_VALUE
        where DFV_ID in (
            select DFV_ID from (
                select DFV_ID, ROW_NUMBER() over (partition by DENORMALIZED_FIELD_HOLDER_ID, DENORMALIZED_FIELD_HOLDER_TYPE, CODE order by DFV_ID)
                as RNUM
                from DENORMALIZED_FIELD_VALUE
            ) TODELETE
            where TODELETE.RNUM > 1
        );

delete from CUSTOM_FIELD_VALUE
        where CFV_ID in (
            select CFV_ID from (
                select CFV_ID, ROW_NUMBER() over (partition by BOUND_ENTITY_ID, BOUND_ENTITY_TYPE, CFB_ID order by CFV_ID desc)
                as RNUM
                from CUSTOM_FIELD_VALUE
            ) TODELETE
            where TODELETE.RNUM > 1
        );

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.14.1-issue-6340-2a', 'bsiri', '../tm/tm.changelog-1.14.1.xml', NOW(), 3, '8:ef8a581e1a1d1b2b2ea5c1e2f753b7fc', 'sql', 'Fixing the extraneous custom field values (for test cases) and denormalized field values (for executions)
          for Postgresql.
          Note about the ordering (in the partition instruction) : I''ve empirically found that it must be ascending...', 'EXECUTED', NULL, NULL, '4.17.2', '9340187637');

-- Changeset ../tm/tm.changelog-1.14.1.xml::tm-1.14.1-issue-6340-3::bsiri
-- enforcing uniticy on the custom field values and denormalized field values -
--           if later on there are more double insert let it fail fast
ALTER TABLE DENORMALIZED_FIELD_VALUE ADD CONSTRAINT u_dfv_id_type_code UNIQUE (DENORMALIZED_FIELD_HOLDER_ID, DENORMALIZED_FIELD_HOLDER_TYPE, CODE);

ALTER TABLE CUSTOM_FIELD_VALUE ADD CONSTRAINT u_cfv_id_type_binding UNIQUE (BOUND_ENTITY_ID, BOUND_ENTITY_TYPE, CFB_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.14.1-issue-6340-3', 'bsiri', '../tm/tm.changelog-1.14.1.xml', NOW(), 4, '8:33fe9e5bafdda2bd39ccdacb36ed1e1c', 'addUniqueConstraint constraintName=u_dfv_id_type_code, tableName=DENORMALIZED_FIELD_VALUE; addUniqueConstraint constraintName=u_cfv_id_type_binding, tableName=CUSTOM_FIELD_VALUE', 'enforcing uniticy on the custom field values and denormalized field values -
          if later on there are more double insert let it fail fast', 'EXECUTED', NULL, NULL, '4.17.2', '9340187637');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

