-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.17.0.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-SQUASH-5232-add-databasechangelog-new-columns::jprioux
-- Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table
ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-SQUASH-5232-add-databasechangelog-new-columns', 'jprioux', '../tm/tm.changelog-1.17.0.xml', NOW(), 1, '8:aeea36396a9ec2a5a73082a8a593b123', 'sql', 'Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0::jthebault
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.17.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 2, '8:635106608f9ea0995f9c28da565b8652', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-feature-6921::zyang
-- Adds a status field to campaign and iteration
ALTER TABLE CAMPAIGN ADD CAMPAIGN_STATUS VARCHAR(30) DEFAULT 'UNDEFINED' NOT NULL;

ALTER TABLE ITERATION ADD ITERATION_STATUS VARCHAR(30) DEFAULT 'UNDEFINED' NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-feature-6921', 'zyang', '../tm/tm.changelog-1.17.0.xml', NOW(), 3, '8:7c2bee7c946ec37dcf1c94a8edeb197f', 'addColumn tableName=CAMPAIGN; addColumn tableName=ITERATION', 'Adds a status field to campaign and iteration', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0::zyang
CREATE TABLE REPORT_DEFINITION (REPORT_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, NAME VARCHAR(255), DESCRIPTION TEXT, PLUGIN_NAMESPACE VARCHAR(255), PARAMETERS TEXT, USER_ID BIGINT NOT NULL, PROJECT_ID BIGINT NOT NULL, CREATED_BY VARCHAR(50) NOT NULL, CREATED_ON TIMESTAMP WITHOUT TIME ZONE NOT NULL, LAST_MODIFIED_BY VARCHAR(50) DEFAULT null, LAST_MODIFIED_ON TIMESTAMP WITHOUT TIME ZONE DEFAULT null, CONSTRAINT "REPORT_DEFINITION_pkey" PRIMARY KEY (REPORT_ID), CONSTRAINT fk_project_report_definition_project_id FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID), CONSTRAINT fk_report_owner FOREIGN KEY (USER_ID) REFERENCES CORE_USER(PARTY_ID));

COMMENT ON COLUMN REPORT_DEFINITION.REPORT_ID IS 'autogenerated ID';

COMMENT ON COLUMN REPORT_DEFINITION.NAME IS 'The name of this chart';

COMMENT ON COLUMN REPORT_DEFINITION.DESCRIPTION IS 'additional informations about this report';

COMMENT ON COLUMN REPORT_DEFINITION.PLUGIN_NAMESPACE IS 'The namespace of the report plugin';

COMMENT ON COLUMN REPORT_DEFINITION.PARAMETERS IS 'parameters to generate the report';

COMMENT ON COLUMN REPORT_DEFINITION.USER_ID IS 'foreign key to the owner of this report definition';

COMMENT ON COLUMN REPORT_DEFINITION.PROJECT_ID IS 'foreign key to the projet';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0', 'zyang', '../tm/tm.changelog-1.17.0.xml', NOW(), 4, '8:a51a3bbf6dfc42620313e2eef68df1cb', 'createTable tableName=REPORT_DEFINITION', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-feature-6921::cholc
-- Adds a execution status field to the test suites
ALTER TABLE TEST_SUITE ADD EXECUTION_STATUS VARCHAR(255) DEFAULT 'READY';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-feature-6921', 'cholc', '../tm/tm.changelog-1.17.0.xml', NOW(), 5, '8:7ecf63ab62a5066758ac61daadb4b949', 'addColumn tableName=TEST_SUITE', 'Adds a execution status field to the test suites', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-feature-sqtm-167::bsiri
-- Adding the ability to use application-level credentials that allows Squash interact with a bugtracker on its own
--       (ie instead of requiring the current user to authenticate).
CREATE TABLE STORED_CREDENTIALS (CREDENTIAL_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, ENC_VERSION SMALLINT, ENC_CREDENTIALS TEXT, AUTHENTICATED_SERVER BIGINT, CONSTRAINT "STORED_CREDENTIALS_pkey" PRIMARY KEY (CREDENTIAL_ID), CONSTRAINT fk_stored_credentials_authenticated_server FOREIGN KEY (AUTHENTICATED_SERVER) REFERENCES BUGTRACKER(BUGTRACKER_ID) ON DELETE CASCADE);

COMMENT ON COLUMN STORED_CREDENTIALS.CREDENTIAL_ID IS 'primary key';

COMMENT ON COLUMN STORED_CREDENTIALS.ENC_VERSION IS 'the version of encryption service used. Possibly the value will remain to 1 forever.';

COMMENT ON COLUMN STORED_CREDENTIALS.ENC_CREDENTIALS IS 'the credentials as an encrypted string';

COMMENT ON COLUMN STORED_CREDENTIALS.AUTHENTICATED_SERVER IS 'foreign key to the server to authenticate';

ALTER TABLE BUGTRACKER ADD AUTH_POLICY VARCHAR(30) DEFAULT 'USER';

COMMENT ON COLUMN BUGTRACKER.AUTH_POLICY IS 'the policy that decides who needs to authenticate';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-feature-sqtm-167', 'bsiri', '../tm/tm.changelog-1.17.0.xml', NOW(), 6, '8:dae8f23fb21f93b77c6246708ce0d72d', 'createTable tableName=STORED_CREDENTIALS; addColumn tableName=BUGTRACKER', 'Adding the ability to use application-level credentials that allows Squash interact with a bugtracker on its own
      (ie instead of requiring the current user to authenticate).', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-jira-sync-01::jthebault
-- Add a remote synchronisation table in squash tm.
CREATE TABLE REMOTE_SYNCHRONISATION (REMOTE_SYNCHRONISATION_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, PROJECT_ID BIGINT NOT NULL, SERVER_ID BIGINT NOT NULL, REMOTE_SYNCHRONISATION_NAME VARCHAR(255) NOT NULL, KIND VARCHAR(50) NOT NULL, REMOTE_SELECT_TYPE VARCHAR(50), REMOTE_SELECT_VALUE VARCHAR(1000), LAST_SUCCESSFUL_SYNC_DATE TIMESTAMP WITHOUT TIME ZONE, LAST_SYNC_DATE TIMESTAMP WITHOUT TIME ZONE, LAST_SYNC_STATUS VARCHAR(20), SYNC_STATUS VARCHAR(20), REMOTE_SYNCHRONISATION_OPTIONS TEXT, CONSTRAINT "REMOTE_SYNCHRONISATION_pkey" PRIMARY KEY (REMOTE_SYNCHRONISATION_ID), CONSTRAINT fk_remote_sync__bugtracker__bugtracker_id FOREIGN KEY (SERVER_ID) REFERENCES BUGTRACKER(BUGTRACKER_ID), CONSTRAINT fk_remote_sync__project__project_id FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-jira-sync-01', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 7, '8:b70c85f02dd90cf9d8ce3b2a6e9cf76d', 'createTable tableName=REMOTE_SYNCHRONISATION', 'Add a remote synchronisation table in squash tm.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-jira-sync-02::jthebault
-- Add a remote folder synchronisation table in squash tm.
CREATE TABLE REQUIREMENT_FOLDER_SYNC_EXTENDER (RF_SYNC_EXTENDER_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, REMOTE_SYNCHRONISATION_ID BIGINT NOT NULL, REMOTE_FOLDER_ID VARCHAR(255), REMOTE_FOLDER_STATUS VARCHAR(50), REQUIREMENT_FOLDER_ID BIGINT NOT NULL, TYPE VARCHAR(30) NOT NULL, CONSTRAINT "REQUIREMENT_FOLDER_SYNC_EXTENDER_pkey" PRIMARY KEY (RF_SYNC_EXTENDER_ID), CONSTRAINT fk_req_folder_sync_extender__remote_sync_remote_sync_id FOREIGN KEY (REMOTE_SYNCHRONISATION_ID) REFERENCES REMOTE_SYNCHRONISATION(REMOTE_SYNCHRONISATION_ID), CONSTRAINT fk_req_folder_sync_extender__req_folder__rln_id FOREIGN KEY (REQUIREMENT_FOLDER_ID) REFERENCES REQUIREMENT_FOLDER(RLN_ID), UNIQUE (REQUIREMENT_FOLDER_ID));

COMMENT ON COLUMN REQUIREMENT_FOLDER_SYNC_EXTENDER.REMOTE_SYNCHRONISATION_ID IS 'Only one master folder should be targeted by a given synchronisation';

COMMENT ON COLUMN REQUIREMENT_FOLDER_SYNC_EXTENDER.REQUIREMENT_FOLDER_ID IS 'Only one extender for any folder in Squash TM';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-jira-sync-02', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 8, '8:77686424e0ff386fcc4e120065c7c6fc', 'createTable tableName=REQUIREMENT_FOLDER_SYNC_EXTENDER', 'Add a remote folder synchronisation table in squash tm.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-jira-sync-03::jthebault
ALTER TABLE REQUIREMENT_SYNC_EXTENDER ALTER COLUMN  REMOTE_FILTER_NAME DROP NOT NULL;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD REMOTE_SYNCHRONISATION_ID BIGINT;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD CONSTRAINT fk_req_sync_extender__remote_sync_remote_sync_id FOREIGN KEY (REMOTE_SYNCHRONISATION_ID) REFERENCES REMOTE_SYNCHRONISATION (REMOTE_SYNCHRONISATION_ID);

ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD REMOTE_LAST_UPDATED TIMESTAMP WITHOUT TIME ZONE;

ALTER TABLE REQUIREMENT_SYNC_EXTENDER ADD REMOTE_PARENT_ID VARCHAR(30);

CREATE INDEX req_sync_extender_remote_parent_id_idx ON REQUIREMENT_SYNC_EXTENDER(REMOTE_PARENT_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-jira-sync-03', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 9, '8:98f597ab35b289fca921d3062ea9795e', 'dropNotNullConstraint columnName=REMOTE_FILTER_NAME, tableName=REQUIREMENT_SYNC_EXTENDER; addColumn tableName=REQUIREMENT_SYNC_EXTENDER; createIndex indexName=req_sync_extender_remote_parent_id_idx, tableName=REQUIREMENT_SYNC_EXTENDER', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Changeset ../tm/tm.changelog-1.17.0.xml::tm-1.17.0-Issue-6967::jthebault
CREATE INDEX tcln_name_idx ON TEST_CASE_LIBRARY_NODE(NAME);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.17.0-Issue-6967', 'jthebault', '../tm/tm.changelog-1.17.0.xml', NOW(), 10, '8:3cdbf1b9fd528540de692dda7c1b941e', 'createIndex indexName=tcln_name_idx, tableName=TEST_CASE_LIBRARY_NODE', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187722');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

