-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.19.0.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQUASH-5232-add-databasechangelog-new-columns::jprioux
-- Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table
ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQUASH-5232-add-databasechangelog-new-columns', 'jprioux', '../tm/tm.changelog-1.19.0.xml', NOW(), 1, '8:aeea36396a9ec2a5a73082a8a593b123', 'sql', 'Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0::cholc
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.19.0' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0', 'cholc', '../tm/tm.changelog-1.19.0.xml', NOW(), 2, '8:79d344adec29f8523acb83f31ca09402', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-400-info-list-item::cholc
-- Adds a colour field to info list items
ALTER TABLE INFO_LIST_ITEM ADD COLOUR VARCHAR(7);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-400-info-list-item', 'cholc', '../tm/tm.changelog-1.19.0.xml', NOW(), 3, '8:69536af651c134f813bc37a03070beea', 'addColumn tableName=INFO_LIST_ITEM', 'Adds a colour field to info list items', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-400-custom-field-option::cholc
-- Adds a colour field to custom field options
ALTER TABLE CUSTOM_FIELD_OPTION ADD COLOUR VARCHAR(7);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-400-custom-field-option', 'cholc', '../tm/tm.changelog-1.19.0.xml', NOW(), 4, '8:067e8b87f39929938617cd84c0930654', 'addColumn tableName=CUSTOM_FIELD_OPTION', 'Adds a colour field to custom field options', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-409-iteration-test-suite-remove-constraint::cholc
-- To drop an unique constraint, you need the constraint's name, which we don't have, so here we copy the
--       column and delete the original
ALTER TABLE ITERATION_TEST_SUITE ADD TEST_SUITE_ID_TEMP BIGINT;

ALTER TABLE ITERATION_TEST_SUITE DROP CONSTRAINT fk_iteration_test_suite_suite;

UPDATE ITERATION_TEST_SUITE SET TEST_SUITE_ID_TEMP = TEST_SUITE_ID;

ALTER TABLE ITERATION_TEST_SUITE DROP COLUMN TEST_SUITE_ID;

ALTER TABLE ITERATION_TEST_SUITE RENAME COLUMN TEST_SUITE_ID_TEMP TO TEST_SUITE_ID;

ALTER TABLE ITERATION_TEST_SUITE ALTER COLUMN  TEST_SUITE_ID SET NOT NULL;

ALTER TABLE ITERATION_TEST_SUITE ADD CONSTRAINT fk_iteration_test_suite_suite FOREIGN KEY (TEST_SUITE_ID) REFERENCES TEST_SUITE (ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-409-iteration-test-suite-remove-constraint', 'cholc', '../tm/tm.changelog-1.19.0.xml', NOW(), 5, '8:47251f14e90438d1cf29942477eac5ac', 'addColumn tableName=ITERATION_TEST_SUITE; dropForeignKeyConstraint baseTableName=ITERATION_TEST_SUITE, constraintName=fk_iteration_test_suite_suite; update tableName=ITERATION_TEST_SUITE; dropColumn columnName=TEST_SUITE_ID, tableName=ITERATION_TE...', 'To drop an unique constraint, you need the constraint''s name, which we don''t have, so here we copy the
      column and delete the original', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-409-iteration-test-suite-order::cholc
-- add an order to iterations' test suites
ALTER TABLE ITERATION_TEST_SUITE ADD ITERATION_TEST_SUITE_ORDER INTEGER;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-409-iteration-test-suite-order', 'cholc', '../tm/tm.changelog-1.19.0.xml', NOW(), 6, '8:c604993a6bcdbb239a2d95791e071a41', 'addColumn tableName=ITERATION_TEST_SUITE', 'add an order to iterations'' test suites', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-409-iteration-test-suite-order-generation::cholc
-- will compute the order of the test suites in the iterations, should work for all databases
UPDATE ITERATION_TEST_SUITE ITS
      SET
      ITERATION_TEST_SUITE_ORDER = (SELECT
      SUB_QUERY.ORDER_DEF
      FROM
      (SELECT
      ITS1.ITERATION_ID AS I_ID,
      ITS1.TEST_SUITE_ID AS TS_ID,
      (COUNT(*) - 1) AS ORDER_DEF
      FROM
      ITERATION_TEST_SUITE ITS1
      INNER JOIN ITERATION_TEST_SUITE ITS2 ON ITS1.ITERATION_ID = ITS2.ITERATION_ID
      AND ITS1.TEST_SUITE_ID >= ITS2.TEST_SUITE_ID
      GROUP BY ITS1.ITERATION_ID , ITS1.TEST_SUITE_ID) AS SUB_QUERY
      WHERE
      SUB_QUERY.I_ID = ITS.ITERATION_ID
      AND SUB_QUERY.TS_ID = ITS.TEST_SUITE_ID);

ALTER TABLE ITERATION_TEST_SUITE ADD CONSTRAINT uc_iteration_iteration_test_suite_order UNIQUE (ITERATION_ID, ITERATION_TEST_SUITE_ORDER);

ALTER TABLE ITERATION_TEST_SUITE ALTER COLUMN  ITERATION_TEST_SUITE_ORDER SET NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-409-iteration-test-suite-order-generation', 'cholc', '../tm/tm.changelog-1.19.0.xml', NOW(), 7, '8:d05b4845192d3b6f3f38ee79045e259b', 'sql; addUniqueConstraint constraintName=uc_iteration_iteration_test_suite_order, tableName=ITERATION_TEST_SUITE; addNotNullConstraint columnName=ITERATION_TEST_SUITE_ORDER, tableName=ITERATION_TEST_SUITE', 'will compute the order of the test suites in the iterations, should work for all databases', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-up-sb2-1::bsiri
-- Passwords are now much longer since we also store the salt.
ALTER TABLE AUTH_USER ALTER COLUMN PASSWORD TYPE VARCHAR(255) USING (PASSWORD::VARCHAR(255));

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-up-sb2-1', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 8, '8:4fec87dfb8b26d239bda1ae3f6573939', 'modifyDataType columnName=PASSWORD, tableName=AUTH_USER', 'Passwords are now much longer since we also store the salt.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-399-infolist-items-default-colours::cholc
-- Requirement categories colours
-- Test cases natures colours
-- Test cases types colours
UPDATE INFO_LIST_ITEM SET COLOUR = '#C3AB77' WHERE CODE = 'CAT_TEST_REQUIREMENT';

UPDATE INFO_LIST_ITEM SET COLOUR = '#CDCDCD' WHERE CODE = 'CAT_UNDEFINED';

UPDATE INFO_LIST_ITEM SET COLOUR = '#8F6057' WHERE CODE = 'CAT_ERGONOMIC';

UPDATE INFO_LIST_ITEM SET COLOUR = '#FCCA46' WHERE CODE = 'CAT_PERFORMANCE';

UPDATE INFO_LIST_ITEM SET COLOUR = '#233D4D' WHERE CODE = 'CAT_TECHNICAL';

UPDATE INFO_LIST_ITEM SET COLOUR = '#094C75' WHERE CODE = 'CAT_USER_STORY';

UPDATE INFO_LIST_ITEM SET COLOUR = '#FE7F2D' WHERE CODE = 'CAT_SECURITY';

UPDATE INFO_LIST_ITEM SET COLOUR = '#7594CD' WHERE CODE = 'CAT_FUNCTIONAL';

UPDATE INFO_LIST_ITEM SET COLOUR = '#BB5759' WHERE CODE = 'CAT_NON_FUNCTIONAL';

UPDATE INFO_LIST_ITEM SET COLOUR = '#A1C181' WHERE CODE = 'CAT_USE_CASE';

UPDATE INFO_LIST_ITEM SET COLOUR = '#619B8A' WHERE CODE = 'CAT_BUSINESS';

UPDATE INFO_LIST_ITEM SET COLOUR = '#A1C181' WHERE CODE = 'NAT_USER_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#FCCA46' WHERE CODE = 'NAT_PERFORMANCE_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#FE7F2D' WHERE CODE = 'NAT_SECURITY_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#233D4D' WHERE CODE = 'NAT_ATDD';

UPDATE INFO_LIST_ITEM SET COLOUR = '#CDCDCD' WHERE CODE = 'NAT_UNDEFINED';

UPDATE INFO_LIST_ITEM SET COLOUR = '#7594CD' WHERE CODE = 'NAT_FUNCTIONAL_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#BB5759' WHERE CODE = 'NAT_NON_FUNCTIONAL_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#619B8A' WHERE CODE = 'NAT_BUSINESS_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#CDCDCD' WHERE CODE = 'TYP_UNDEFINED';

UPDATE INFO_LIST_ITEM SET COLOUR = '#5B9367' WHERE CODE = 'TYP_COMPLIANCE_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#CD533B' WHERE CODE = 'TYP_CORRECTION_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#D8A86E' WHERE CODE = 'TYP_EVOLUTION_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#F2E77E' WHERE CODE = 'TYP_REGRESSION_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#2D5635' WHERE CODE = 'TYP_END_TO_END_TESTING';

UPDATE INFO_LIST_ITEM SET COLOUR = '#F2E2CE' WHERE CODE = 'TYP_PARTNER_TESTING';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-399-infolist-items-default-colours', 'cholc', '../tm/tm.changelog-1.19.0.xml', NOW(), 9, '8:024f29efbde813cf2093f9a88524ebde', 'update tableName=INFO_LIST_ITEM; update tableName=INFO_LIST_ITEM; update tableName=INFO_LIST_ITEM; update tableName=INFO_LIST_ITEM; update tableName=INFO_LIST_ITEM; update tableName=INFO_LIST_ITEM; update tableName=INFO_LIST_ITEM; update tableName...', 'Requirement categories colours
Test cases natures colours
Test cases types colours', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-453-execution-name-maxlength::jprioux
-- Increase max length for execution name
ALTER TABLE EXECUTION ALTER COLUMN NAME TYPE VARCHAR(308) USING (NAME::VARCHAR(308));

ALTER TABLE EXECUTION ALTER COLUMN  NAME SET NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-453-execution-name-maxlength', 'jprioux', '../tm/tm.changelog-1.19.0.xml', NOW(), 10, '8:3cb1611a1b730b40a0cb7703b48af530', 'modifyDataType columnName=NAME, tableName=EXECUTION; addNotNullConstraint columnName=NAME, tableName=EXECUTION', 'Increase max length for execution name', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-508-automation-request::aboittiaux
-- Create table AUTOMATION_REQUEST to Gherkin's test cases
CREATE TABLE AUTOMATION_REQUEST (AUTOMATION_REQUEST_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, REQUEST_STATUS VARCHAR(25) DEFAULT 'WORK_IN_PROGRESS' NOT NULL, TRANSMITTED_ON TIMESTAMP WITHOUT TIME ZONE, ASSIGNED_TO BIGINT, AUTOMATION_PRIORITY INTEGER, ASSIGNED_ON TIMESTAMP WITHOUT TIME ZONE, TEST_CASE_ID BIGINT, CREATED_BY BIGINT, TRANSMITTED_BY BIGINT, PROJECT_ID BIGINT NOT NULL, CONSTRAINT "AUTOMATION_REQUEST_pkey" PRIMARY KEY (AUTOMATION_REQUEST_ID), CONSTRAINT fk_automation_request_project FOREIGN KEY (PROJECT_ID) REFERENCES PROJECT(PROJECT_ID));

COMMENT ON COLUMN AUTOMATION_REQUEST.PROJECT_ID IS 'fk to the host project';

CREATE INDEX automation_request_assigned_to_idx ON AUTOMATION_REQUEST(ASSIGNED_TO);

CREATE INDEX automation_request_created_by_idx ON AUTOMATION_REQUEST(CREATED_BY);

CREATE INDEX automation_request_transmitted_by_idx ON AUTOMATION_REQUEST(TRANSMITTED_BY);

CREATE INDEX automation_request_test_case_id_idx ON AUTOMATION_REQUEST(TEST_CASE_ID);

ALTER TABLE AUTOMATION_REQUEST ADD CONSTRAINT fk_automation_request_automation_assigned_to FOREIGN KEY (ASSIGNED_TO) REFERENCES CORE_USER (PARTY_ID) ON DELETE SET NULL;

ALTER TABLE AUTOMATION_REQUEST ADD CONSTRAINT fk_automation_request_transmitted_by FOREIGN KEY (TRANSMITTED_BY) REFERENCES CORE_USER (PARTY_ID) ON DELETE SET NULL;

ALTER TABLE AUTOMATION_REQUEST ADD CONSTRAINT fk_automation_request_created_by FOREIGN KEY (CREATED_BY) REFERENCES CORE_USER (PARTY_ID) ON DELETE SET NULL;

ALTER TABLE AUTOMATION_REQUEST ADD CONSTRAINT fk_automation_request_test_case FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASE (TCLN_ID) ON DELETE SET NULL;

ALTER TABLE TEST_CASE ADD AUTOMATABLE CHAR DEFAULT 'M';

COMMENT ON COLUMN TEST_CASE.AUTOMATABLE IS 'Y: Yes, N: No, M: Maybe';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-508-automation-request', 'aboittiaux', '../tm/tm.changelog-1.19.0.xml', NOW(), 11, '8:5748276926c63e23884eab6c5bec0219', 'createTable tableName=AUTOMATION_REQUEST; createIndex indexName=automation_request_assigned_to_idx, tableName=AUTOMATION_REQUEST; createIndex indexName=automation_request_created_by_idx, tableName=AUTOMATION_REQUEST; createIndex indexName=automati...', 'Create table AUTOMATION_REQUEST to Gherkin''s test cases', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-519-automation-request-library-1::bsiri
-- Creating the AutomationRequestLibrary
CREATE TABLE AUTOMATION_REQUEST_LIBRARY (ARL_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, ATTACHMENT_LIST_ID BIGINT, CONSTRAINT PK_AUTOMATION_REQUEST_LIBRARY PRIMARY KEY (ARL_ID), CONSTRAINT "fk_autorequestLib_attachment_list" FOREIGN KEY (ATTACHMENT_LIST_ID) REFERENCES ATTACHMENT_LIST(ATTACHMENT_LIST_ID));

COMMENT ON COLUMN AUTOMATION_REQUEST_LIBRARY.ARL_ID IS 'autoincremented primary key';

COMMENT ON COLUMN AUTOMATION_REQUEST_LIBRARY.ATTACHMENT_LIST_ID IS 'fk to the attachment list';

CREATE INDEX idx_automation_request_library ON AUTOMATION_REQUEST_LIBRARY(ARL_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-519-automation-request-library-1', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 12, '8:d50286a3e29feee52710b1b901b61221', 'createTable tableName=AUTOMATION_REQUEST_LIBRARY; createIndex indexName=idx_automation_request_library, tableName=AUTOMATION_REQUEST_LIBRARY', 'Creating the AutomationRequestLibrary', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-519-automation-request-library-2::bsiri
-- New entries in the ACL infrastructure.
insert into ACL_CLASS(ID, CLASSNAME) values(7,
      'org.squashtest.tm.domain.tf.automationrequest.AutomationRequestLibrary');

insert into ACL_GROUP(ID, QUALIFIED_NAME) values(10, 'squashtest.acl.group.tm.AutomatedTestWriter');

insert into ACL_GROUP_PERMISSION(ACL_GROUP_ID, PERMISSION_MASK, CLASS_ID)
      select AGP2.ACL_GROUP_ID, AGP2.PERMISSION_MASK, 7
      from ACL_GROUP_PERMISSION AGP2
      where CLASS_ID = 3;

insert into ACL_GROUP_PERMISSION(ACL_GROUP_ID, CLASS_ID, PERMISSION_MASK) values
      (2, 7, 8192),
      (5, 7, 8192),
      (5, 7, 16384),
      (7, 7, 8192),
      (8, 7, 8192),
      (9, 7, 8192),
      (10, 2, 1),
      (10, 3, 1),
      (10, 4, 1),
      (10, 6, 1),
      (10, 7, 1),
      (10, 7, 2),
      (10, 7, 4),
      (10, 7, 8),
      (10, 7, 64),
      (10, 7, 256),
      (10, 7, 1024),
      (10, 7, 4096),
      (10, 7, 16384);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-519-automation-request-library-2', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 13, '8:180f840f2a84db732425975563ea575b', 'sql', 'New entries in the ACL infrastructure.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-519-automation-request-library-3::bsiri
-- The automation request library content table
CREATE TABLE AUTOMATION_REQUEST_LIBRARY_CONTENT (LIBRARY_ID BIGINT NOT NULL, CONTENT_ID BIGINT NOT NULL, CONSTRAINT fk_automation_rquest_lib_content_lib FOREIGN KEY (LIBRARY_ID) REFERENCES AUTOMATION_REQUEST_LIBRARY(ARL_ID), CONSTRAINT fk_automation_request_lib_content_content FOREIGN KEY (CONTENT_ID) REFERENCES AUTOMATION_REQUEST(AUTOMATION_REQUEST_ID), UNIQUE (CONTENT_ID));

COMMENT ON COLUMN AUTOMATION_REQUEST_LIBRARY_CONTENT.LIBRARY_ID IS 'Foreign key to the library';

COMMENT ON COLUMN AUTOMATION_REQUEST_LIBRARY_CONTENT.CONTENT_ID IS 'Foreign key to the content';

CREATE INDEX idx_automation_request_lib_content_content ON AUTOMATION_REQUEST_LIBRARY_CONTENT(CONTENT_ID);

CREATE INDEX idx_automation_request_lib_content_lib ON AUTOMATION_REQUEST_LIBRARY_CONTENT(LIBRARY_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-519-automation-request-library-3', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 14, '8:5cbe1b343b76e479c1690c7740b57a66', 'createTable tableName=AUTOMATION_REQUEST_LIBRARY_CONTENT; createIndex indexName=idx_automation_request_lib_content_content, tableName=AUTOMATION_REQUEST_LIBRARY_CONTENT; createIndex indexName=idx_automation_request_lib_content_lib, tableName=AUTOM...', 'The automation request library content table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-519-automation-request-library-4::bsiri
-- Add a Project fk to the AutomationRequestLibrary
ALTER TABLE PROJECT ADD ARL_ID BIGINT;

ALTER TABLE PROJECT ADD CONSTRAINT fk_project_arl FOREIGN KEY (ARL_ID) REFERENCES AUTOMATION_REQUEST_LIBRARY (ARL_ID);

COMMENT ON COLUMN PROJECT.ARL_ID IS 'fk to the automation request library';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-519-automation-request-library-4', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 15, '8:8ab0815e2d2f628387e03680cac07cb5', 'addColumn tableName=PROJECT', 'Add a Project fk to the AutomationRequestLibrary', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-519-automation-request-library-5::bsiri
-- Create one such library for each existing projects
-- create the libraries

      insert into AUTOMATION_REQUEST_LIBRARY (ARL_ID)
      select p.PROJECT_ID from PROJECT p;

-- attachments, step 1 :
      -- create a ranking table, akin to what would ROW_NUMBER() order by id desc would say

      create table ARL_RANK as
      select alib.arl_id, count(alib2.arl_id)  as ranking
      from AUTOMATION_REQUEST_LIBRARY alib,
      AUTOMATION_REQUEST_LIBRARY alib2
      where alib.arl_id <= alib2.arl_id
      group by alib.arl_id
      order by ranking asc;

-- attachments, step 2 :
      -- create a table that pairs library ids with predictable, consecutive attachment_list_ids using the rank
      -- calculated earlier

      create table ARL_ATTACHLIST_PAIRING as
      select arl.arl_id, (select max(al.attachment_list_id) from ATTACHMENT_LIST al) + arl.ranking as attachment_list_id
      from ARL_RANK arl;

-- attachments, step 3 :
      -- insert the attachment lists and update fk in the automation request library
      insert into ATTACHMENT_LIST(ATTACHMENT_LIST_ID)
      select pair.attachment_list_id from ARL_ATTACHLIST_PAIRING pair;

update AUTOMATION_REQUEST_LIBRARY arl
      set ATTACHMENT_LIST_ID = (select pair.attachment_list_id from ARL_ATTACHLIST_PAIRING pair where pair.arl_id = arl.arl_id);

-- attachments, step 4 and final :
      -- drop the temporary tables

      drop table ARL_ATTACHLIST_PAIRING;

drop table ARL_RANK;

-- wire the project to the ARL library

      update PROJECT P
      set ARL_ID = PROJECT_ID;

-- insert the acl object identities
      insert into ACL_OBJECT_IDENTITY(IDENTITY, CLASS_ID)
      select arl.arl_id, 7 from AUTOMATION_REQUEST_LIBRARY arl;

-- add the user/team permissions in ACL_RESPONSIBILITY_SCOPE_ENTRY
      -- each user will receive the same acl_group on each arl library than on the project it depends on
      -- (this last sentence is the idea behind the auto join on acl_object_identity in this query)
      insert into ACL_RESPONSIBILITY_SCOPE_ENTRY(party_id, acl_group_id, object_identity_id)
      select distinct arse.party_id, arse.acl_group_id, arl_oid.id
      from ACL_RESPONSIBILITY_SCOPE_ENTRY arse
      inner join ACL_OBJECT_IDENTITY oid on (arse.object_identity_id = oid.id and oid.class_id = 1)
      inner join ACL_OBJECT_IDENTITY arl_oid on (oid.identity = arl_oid.identity and arl_oid.class_id = 7);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-519-automation-request-library-5', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 16, '8:6ff106ef30e97bcc441802c7e131a5f9', 'sql', 'Create one such library for each existing projects', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-519-automation-request-library-6::bsiri
-- reset postgresql sequences
select setval('automation_request_library_arl_id_seq', (select MAX(ARL_ID) from AUTOMATION_REQUEST_LIBRARY));

select setval('attachment_list_attachment_list_id_seq', (select MAX(ATTACHMENT_LIST_ID) from ATTACHMENT_LIST));

select setval('acl_object_identity_id_seq', (SELECT MAX(ID) from ACL_OBJECT_IDENTITY));

select setval('acl_responsibility_scope_entry_id_seq', (select MAX(ID) from ACL_RESPONSIBILITY_SCOPE_ENTRY));

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-519-automation-request-library-6', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 17, '8:3e99f9ee9cc8deb92f4211693c5e455b', 'sql', 'reset postgresql sequences', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-510-add-roles-automation::aboittiaux
insert into CORE_PARTY_AUTHORITY(PARTY_ID, AUTHORITY)
      select distinct cu.PARTY_ID, 'ROLE_TF_FUNCTIONAL_TESTER' from CORE_USER cu
      left join CORE_PARTY_AUTHORITY cpa on cu.PARTY_ID = cpa.PARTY_ID
      left join CORE_GROUP_MEMBER ctm on ctm.PARTY_ID = cu.PARTY_ID
      where cpa.AUTHORITY is null and ctm.GROUP_ID = 2;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-510-add-roles-automation', 'aboittiaux', '../tm/tm.changelog-1.19.0.xml', NOW(), 18, '8:a3bdb0be7bc17d10b27d23bfc7066a98', 'sql', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-524-automation-workflow-by-project::jprioux
-- add a boolean in project table to activate or not the automation workflow
ALTER TABLE PROJECT ADD ALLOW_AUTOMATION_WORKFLOW BOOLEAN DEFAULT FALSE NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-524-automation-workflow-by-project', 'jprioux', '../tm/tm.changelog-1.19.0.xml', NOW(), 19, '8:11beffcb803f2a36c49f51746e8e80bd', 'addColumn tableName=PROJECT', 'add a boolean in project table to activate or not the automation workflow', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-create-auth-users::bsiri
-- add the missing entries in AUTH_USER for users that only exist in CORE_USER (eg a user created by LDAP)
insert into AUTH_USER (login, password, active)
      select cu.LOGIN, '', cu.active
      from CORE_USER cu
      left join AUTH_USER au on cu.login = au.login
      where au.login is null;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-create-auth-users', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 20, '8:de146a8d54324c093d99ec78aadced43', 'sql', 'add the missing entries in AUTH_USER for users that only exist in CORE_USER (eg a user created by LDAP)', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-Mantis-7833::jprioux
-- Increase remote project id limit to 100 for redmine bt project keys
ALTER TABLE REQUIREMENT_SYNC_EXTENDER ALTER COLUMN REMOTE_PROJECT_ID TYPE VARCHAR(100) USING (REMOTE_PROJECT_ID::VARCHAR(100));

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-Mantis-7833', 'jprioux', '../tm/tm.changelog-1.19.0.xml', NOW(), 21, '8:bf7e3cd98a3544c6515edcf56cc27f1a', 'modifyDataType columnName=REMOTE_PROJECT_ID, tableName=REQUIREMENT_SYNC_EXTENDER', 'Increase remote project id limit to 100 for redmine bt project keys', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-536-autoexec-gherkin-1::bsiri
-- Add a flag to the test automation project that tells whether it is able to run Gherkin tests.
ALTER TABLE TEST_AUTOMATION_PROJECT ADD CAN_RUN_GHERKIN BOOLEAN DEFAULT FALSE NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-536-autoexec-gherkin-1', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 22, '8:744d6d83f37e99e23cba94af126c24b5', 'addColumn tableName=TEST_AUTOMATION_PROJECT', 'Add a flag to the test automation project that tells whether it is able to run Gherkin tests.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-543-third-party-server-1::bsiri
-- Create the table THIRD_PARTY_SERVER
CREATE TABLE THIRD_PARTY_SERVER (SERVER_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, NAME VARCHAR(50) NOT NULL, URL VARCHAR(400) NOT NULL, AUTH_POLICY VARCHAR(30) DEFAULT 'USER', AUTH_PROTOCOL VARCHAR(30) DEFAULT 'BASIC_AUTH' NOT NULL, CONSTRAINT PK_THIRD_PARTY_SERVER PRIMARY KEY (SERVER_ID));

COMMENT ON TABLE THIRD_PARTY_SERVER IS 'base table for third party servers';

COMMENT ON COLUMN THIRD_PARTY_SERVER.SERVER_ID IS 'primary key, autogenerated';

COMMENT ON COLUMN THIRD_PARTY_SERVER.NAME IS 'name of the server';

COMMENT ON COLUMN THIRD_PARTY_SERVER.URL IS 'the base url';

COMMENT ON COLUMN THIRD_PARTY_SERVER.AUTH_POLICY IS 'the policy that decides who needs to authenticate';

COMMENT ON COLUMN THIRD_PARTY_SERVER.AUTH_PROTOCOL IS 'the protocol that should be used for that server';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-543-third-party-server-1', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 23, '8:ce4477c2e4c807d6dc8b136dc6bba2c9', 'createTable tableName=THIRD_PARTY_SERVER', 'Create the table THIRD_PARTY_SERVER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-543-third-party-server-2::bsiri
-- migrate data from table BUGTRACKER to table THIRD_PARTY_SERVER
insert into THIRD_PARTY_SERVER(SERVER_ID, NAME, URL, AUTH_POLICY, AUTH_PROTOCOL)
      select BUGTRACKER_ID, NAME, URL, AUTH_POLICY, AUTH_PROTOCOL
      from BUGTRACKER;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-543-third-party-server-2', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 24, '8:f06ca5fee15abe6e10e53e2847d0a3f3', 'sql', 'migrate data from table BUGTRACKER to table THIRD_PARTY_SERVER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-543-third-party-server-3::bsiri
-- Drop the now unused columns from BUGTRACKER and create the FK from BUGTRACKER to THIRD_PARTY_SERVER
ALTER TABLE BUGTRACKER DROP COLUMN NAME;

ALTER TABLE BUGTRACKER DROP COLUMN URL;

ALTER TABLE BUGTRACKER DROP COLUMN AUTH_POLICY;

ALTER TABLE BUGTRACKER DROP COLUMN AUTH_PROTOCOL;

ALTER TABLE BUGTRACKER ADD CONSTRAINT fk_bugtracker_third_party_server FOREIGN KEY (BUGTRACKER_ID) REFERENCES THIRD_PARTY_SERVER (SERVER_ID) ON DELETE CASCADE;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-543-third-party-server-3', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 25, '8:0528f96f8480293d795ddda1dd55c913', 'dropColumn columnName=NAME, tableName=BUGTRACKER; dropColumn columnName=URL, tableName=BUGTRACKER; dropColumn columnName=AUTH_POLICY, tableName=BUGTRACKER; dropColumn columnName=AUTH_PROTOCOL, tableName=BUGTRACKER; addForeignKeyConstraint baseTabl...', 'Drop the now unused columns from BUGTRACKER and create the FK from BUGTRACKER to THIRD_PARTY_SERVER', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-543-third-party-server-4::bsiri
-- change the foreign key stored_credentials -> bugtracker to stored_credentials -> third_party_server
ALTER TABLE STORED_CREDENTIALS DROP CONSTRAINT fk_stored_credentials_authenticated_server;

CREATE INDEX idx_fk_stored_credentials_authenticated_server ON STORED_CREDENTIALS(AUTHENTICATED_SERVER);

ALTER TABLE STORED_CREDENTIALS ADD CONSTRAINT fk_stored_credentials_authenticated_server FOREIGN KEY (AUTHENTICATED_SERVER) REFERENCES THIRD_PARTY_SERVER (SERVER_ID) ON DELETE CASCADE;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-543-third-party-server-4', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 26, '8:e97abf79dc8bc186c5d90e1ea4fe71fc', 'dropForeignKeyConstraint baseTableName=STORED_CREDENTIALS, constraintName=fk_stored_credentials_authenticated_server; createIndex indexName=idx_fk_stored_credentials_authenticated_server, tableName=STORED_CREDENTIALS; addForeignKeyConstraint baseT...', 'change the foreign key stored_credentials -> bugtracker to stored_credentials -> third_party_server', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-543-third-party-server-5-postgres::bsiri
-- For PostGre, remove the autoincrement on bugtracker_id and reset the sequence for third_party_server
alter table BUGTRACKER alter column BUGTRACKER_ID drop IDENTITY;

drop sequence if exists bugtracker_bugtracker_id_seq;

select setval('third_party_server_server_id_seq', (select max(SERVER_ID) from THIRD_PARTY_SERVER));

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-543-third-party-server-5-postgres', 'bsiri', '../tm/tm.changelog-1.19.0.xml', NOW(), 27, '8:3e4442b1366af5b17b66331343d1dd3a', 'sql', 'For PostGre, remove the autoincrement on bugtracker_id and reset the sequence for third_party_server', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-512-scm-server-management::jlor
-- Add new table for scm (source code management) server.
CREATE TABLE SCM_SERVER (SERVER_ID BIGINT NOT NULL, KIND VARCHAR(30) NOT NULL, CONSTRAINT "SCM_SERVER_pkey" PRIMARY KEY (SERVER_ID));

COMMENT ON COLUMN SCM_SERVER.SERVER_ID IS 'The id of the scm server.';

COMMENT ON COLUMN SCM_SERVER.KIND IS 'The kind of scm server.';

ALTER TABLE SCM_SERVER ADD CONSTRAINT fk_scm_server_third_party_server FOREIGN KEY (SERVER_ID) REFERENCES THIRD_PARTY_SERVER (SERVER_ID) ON DELETE CASCADE;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-512-scm-server-management', 'jlor', '../tm/tm.changelog-1.19.0.xml', NOW(), 28, '8:dc5c89d7514ccc3ed65c24da7b28c501', 'createTable tableName=SCM_SERVER; addForeignKeyConstraint baseTableName=SCM_SERVER, constraintName=fk_scm_server_third_party_server, referencedTableName=THIRD_PARTY_SERVER', 'Add new table for scm (source code management) server.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-512-scm-repository-management::jlor
-- Add new table for scm (source code management) repository.
CREATE TABLE SCM_REPOSITORY (SCM_REPOSITORY_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, SERVER_ID BIGINT NOT NULL, NAME VARCHAR(255) NOT NULL, REPOSITORY_PATH VARCHAR(255) NOT NULL, WORKING_FOLDER_PATH VARCHAR(255), WORKING_BRANCH VARCHAR(255) NOT NULL, CONSTRAINT "SCM_REPOSITORY_pkey" PRIMARY KEY (SCM_REPOSITORY_ID), CONSTRAINT fk_scm_repository_scm_server FOREIGN KEY (SERVER_ID) REFERENCES SCM_SERVER(SERVER_ID));

COMMENT ON COLUMN SCM_REPOSITORY.SCM_REPOSITORY_ID IS 'The auto-generated id of the scm repository.';

COMMENT ON COLUMN SCM_REPOSITORY.SERVER_ID IS 'The foreign key to the related SCM_SEVER';

COMMENT ON COLUMN SCM_REPOSITORY.NAME IS 'The name of the repository.';

COMMENT ON COLUMN SCM_REPOSITORY.REPOSITORY_PATH IS 'The absolute path to the local repository on the local server.';

COMMENT ON COLUMN SCM_REPOSITORY.WORKING_FOLDER_PATH IS 'The relative path of the working folder in which SquashTM will push.';

COMMENT ON COLUMN SCM_REPOSITORY.WORKING_BRANCH IS 'The name of the working branch on which SquashTM will push.';

ALTER TABLE SCM_REPOSITORY ADD UNIQUE (NAME, SERVER_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-512-scm-repository-management', 'jlor', '../tm/tm.changelog-1.19.0.xml', NOW(), 29, '8:1f223494883f21790714bfbcbe72a98f', 'createTable tableName=SCM_REPOSITORY; addUniqueConstraint tableName=SCM_REPOSITORY', 'Add new table for scm (source code management) repository.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-SQTM-512-project-scm-repository-binding::jlor
-- Add foreign key in project table to reference a scm (source code management) repository.
ALTER TABLE PROJECT ADD SCM_REPOSITORY_ID BIGINT;

ALTER TABLE PROJECT ADD CONSTRAINT fk_project_scm_repository FOREIGN KEY (SCM_REPOSITORY_ID) REFERENCES SCM_REPOSITORY (SCM_REPOSITORY_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-SQTM-512-project-scm-repository-binding', 'jlor', '../tm/tm.changelog-1.19.0.xml', NOW(), 30, '8:51a65c795e339379daf7294e51333ef5', 'addColumn tableName=PROJECT', 'Add foreign key in project table to reference a scm (source code management) repository.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-fixing-postgresql-index::jthebault
create index idx_fk_acl_grp_permission_acl_grp on acl_group_permission(acl_group_id);

create index idx_fk_acl_obj_id_acl_class on acl_object_identity(class_id);

create index idx_fk_action_test_step_attachment_list on action_test_step(attachment_list_id);

create index idx_fk_arse_party on acl_responsibility_scope_entry(party_id);

create index idx_fk_attachment_att_list on attachment(attachment_list_id);

create index idx_fk_attachment_content on attachment(content_id);

create index idx_fk_audit_event_requirement_version on requirement_audit_event(req_version_id);

create index idx_fk_auto_exec_auto_test on automated_execution_extender(test_id);

create index idx_fk_auto_exec_exec on automated_execution_extender(master_execution_id);

create index idx_fk_auto_exec_suite on automated_execution_extender(suite_id);

create index idx_fk_automated_test_project on automated_test(project_id);

create index idx_fk_automation_request_project on automation_request(project_id);

create index idx_fk_autorequestlib_attachment_list on automation_request_library(attachment_list_id);

create index idx_fk_axis_column_chart_column on chart_axis_column(chart_column_id);

create index idx_fk_bugtracker_binding_bugtracker on bugtracker_binding(bugtracker_id);

create index idx_fk_bugtracker_binding_project on bugtracker_binding(project_id);

create index idx_fk_bugtracker_project_bugtracker_binding on bugtracker_project(bugtracker_binding_id);

create index idx_fk_call_step_called_test_case on call_test_step(called_test_case_id);

create index idx_fk_call_step_dataset on call_test_step(called_dataset);

create index idx_fk_camp_iter_campaign on campaign_iteration(campaign_id);

create index idx_fk_camp_iter_iteration on campaign_iteration(iteration_id);

create index idx_fk_camp_test_plan_item_dataset on campaign_test_plan_item(dataset_id);

create index idx_fk_camp_tp_campaign on campaign_test_plan_item(campaign_id);

create index idx_fk_camp_tp_testcase on campaign_test_plan_item(test_case_id);

create index idx_fk_camp_tp_user on campaign_test_plan_item(user_id);

create index idx_fk_camplib_attachment_list on campaign_library(attachment_list_id);

create index idx_fk_campnode_attachment_list on campaign_library_node(attachment_list_id);

create index idx_fk_cf_option_cf on custom_field_option(cf_id);

create index idx_fk_cfb_bound_project on custom_field_binding(bound_project_id);

create index idx_fk_cfb_cf on custom_field_binding(cf_id);

create index idx_fk_cfb_render_loc_cfb on custom_field_rendering_location(cfb_id);

create index idx_fk_cfv_cf_binding on custom_field_value(cfb_id);

create index idx_fk_cfv_option_cfv on custom_field_value_option(cfv_id);

create index idx_fk_chart_axis_chart_query on chart_axis_column(query_id);

create index idx_fk_chart_bindind_chart_definition_chart_id on custom_report_chart_binding(chart_id);

create index idx_fk_chart_bindind_custom_report_dashboard_crd_id on custom_report_chart_binding(crd_id);

create index idx_fk_chart_bindind_report_definition_report_id on custom_report_report_binding(report_id);

create index idx_fk_chart_filter_chart_column on chart_filter(chart_column_id);

create index idx_fk_chart_filter_chart_query on chart_filter(query_id);

create index idx_fk_chart_filter_value_chart_column on chart_filter_values(filter_id);

create index idx_fk_chart_measure_chart_column on chart_measure_column(chart_column_id);

create index idx_fk_chart_measure_chart_query on chart_measure_column(query_id);

create index idx_fk_chart_owner on chart_definition(user_id);

create index idx_fk_chart_project_scope_chart_definition on chart_project_scope(chart_id);

create index idx_fk_chart_query on chart_definition(query_id);

create index idx_fk_chart_scope_chart_definition on chart_scope(chart_id);

create index idx_fk_cln_project on campaign_library_node(project_id);

create index idx_fk_column_query on chart_column_prototype(subquery_id);

create index idx_fk_column_role_chart_column on chart_column_role(chart_column_id);

create index idx_fk_crl_attachment_list on custom_report_library(attachment_list_id);

create index idx_fk_crln_custom_report_library_crl_id on custom_report_library_node(crl_id);

create index idx_fk_dataset_param_value_dataset on dataset_param_value(dataset_id);

create index idx_fk_dataset_param_value_param on dataset_param_value(param_id);

create index idx_fk_dataset_test_case on dataset(test_case_id);

create index idx_fk_df_option_dfv on denormalized_field_option(dfv_id);

create index idx_fk_dfb_render_loc_dfb on denormalized_field_rendering_location(dfv_id);

create index idx_fk_dfv_cfv_binding on denormalized_field_value(cfv_id);

create index idx_fk_dfv_option_dfv on denormalized_field_value_option(dfv_id);

create index idx_fk_disabled_exec_status_cl_id on disabled_execution_status(cl_id);

create index idx_fk_execution_attachment_list on execution(attachment_list_id);

create index idx_fk_execution_issue_list on execution(issue_list_id);

create index idx_fk_execution_step__attachment_list on execution_step(attachment_list_id);

create index idx_fk_execution_step_issue_list on execution_step(issue_list_id);

create index idx_fk_execution_test_case on execution(tcln_id);

create index idx_fk_executionstep_teststep on execution_step(test_step_id);

create index idx_fk_group_member_party on core_group_member(party_id);

create index idx_fk_grp_member_grp on core_group_member(group_id);

create index idx_fk_info_item_list on info_list_item(list_id);

create index idx_fk_issue_bugtracker on issue(bugtracker_id);

create index idx_fk_issue_issue_list on issue(issue_list_id);

create index idx_fk_iteration__attachment_list on iteration(attachment_list_id);

create index idx_fk_iteration_test_plan_item_dataset on iteration_test_plan_item(dataset_id);

create index idx_fk_iteration_test_suite_suite on iteration_test_suite(test_suite_id);

create index idx_fk_itertestplan_test_case on iteration_test_plan_item(tcln_id);

create index idx_fk_itertestplan_user on iteration_test_plan_item(user_id);

create index idx_fk_libplugin_property_libplugin on library_plugin_binding_property(plugin_binding_id);

create index idx_fk_milestone_binding_milestone on milestone_binding(milestone_id);

create index idx_fk_milestone_binding_perimeter_milestone on milestone_binding_perimeter(milestone_id);

create index idx_fk_milestone_binding_perimeter_project on milestone_binding_perimeter(project_id);

create index idx_fk_milestone_binding_project on milestone_binding(project_id);

create index idx_fk_milestone_owner on milestone(user_id);

create index idx_fk_parameter_test_case on parameter(test_case_id);

create index idx_fk_party_authority_party on core_party_authority(party_id);

create index idx_fk_party_preference_core_party_party_id on party_preference(party_id);

create index idx_fk_project_arl on project(arl_id);

create index idx_fk_project_attachment_list on project(attachment_list_id);

create index idx_fk_project_chart_definition_project_id on chart_definition(project_id);

create index idx_fk_project_cl on project(cl_id);

create index idx_fk_project_crl on project(crl_id);

create index idx_fk_project_custom_report_dashboard_project_id on custom_report_dashboard(project_id);

create index idx_fk_project_custom_report_folder_project_id on custom_report_folder(project_id);

create index idx_fk_project_report_definition_project_id on report_definition(project_id);

create index idx_fk_project_rl on project(rl_id);

create index idx_fk_project_scm_repository on project(scm_repository_id);

create index idx_fk_project_tcl on project(tcl_id);

create index idx_fk_project_template_id on project(template_id);

create index idx_fk_remote_sync__bugtracker__bugtracker_id on remote_synchronisation(server_id);

create index idx_fk_remote_sync__project__project_id on remote_synchronisation(project_id);

create index idx_fk_report_bindind_custom_report_dashboard_crd_id on custom_report_report_binding(crd_id);

create index idx_fk_report_owner on report_definition(user_id);

create index idx_fk_req_folder_simple_resource on requirement_folder(res_id);

create index idx_fk_req_folder_sync_extender__remote_sync_remote_sync_id on requirement_folder_sync_extender(remote_synchronisation_id);

create index idx_fk_req_nature on requirement_version(category);

create index idx_fk_req_sync_extender__remote_sync_remote_sync_id on requirement_sync_extender(remote_synchronisation_id);

create index idx_fk_req_version_link_req_version_link_type_link_type_id on requirement_version_link(link_type_id);

create index idx_fk_reqlib_attachment_list on requirement_library(attachment_list_id);

create index idx_fk_requirement_current_version on requirement(current_version_id);

create index idx_fk_requirement_version_link_related_requirement_version_id on requirement_version_link(related_requirement_version_id);

create index idx_fk_requirement_version_link_requirement_version_id on requirement_version_link(requirement_version_id);

create index idx_fk_requirement_version_requirement on requirement_version(requirement_id);

create index idx_fk_resource_attachment_list on resource(attachment_list_id);

create index idx_fk_resp_scope_acl_grp on acl_responsibility_scope_entry(acl_group_id);

create index idx_fk_resp_scope_obj_id on acl_responsibility_scope_entry(object_identity_id);

create index idx_fk_rln_project on requirement_library_node(project_id);

create index idx_fk_sc_auth_acl_class on acl_group_permission(class_id);

create index idx_fk_scm_repository_scm_server on scm_repository(server_id);

create index idx_fk_stored_credentials_user on stored_credentials(authenticated_user);

create index idx_fk_sync_extender_requirement on requirement_sync_extender(requirement_id);

create index idx_fk_sync_extender_server on requirement_sync_extender(server_id);

create index idx_fk_ta_project_ta_server on test_automation_project(server_id);

create index idx_fk_ta_project_tm_project on test_automation_project(tm_project_id);

create index idx_fk_tc_nature on test_case(tc_nature);

create index idx_fk_tc_type on test_case(tc_type);

create index idx_fk_tclib_attachment_list on test_case_library(attachment_list_id);

create index idx_fk_tcln_project on test_case_library_node(project_id);

create index idx_fk_tcnode_attachment_list on test_case_library_node(attachment_list_id);

create index idx_fk_team_member_team on core_team_member(team_id);

create index idx_fk_team_member_user on core_team_member(user_id);

create index idx_fk_test_case_ta_test on test_case(ta_test);

create index idx_fk_test_suite_attachment_list on test_suite(attachment_list_id);

create index idx_fk_test_suite_test_plan_item_test_plan_item on test_suite_test_plan_item(tpi_id);

create index idx_fk_test_suite_test_plan_item_test_suite on test_suite_test_plan_item(suite_id);

create index idx_fk_verified_req_version on requirement_version_coverage(verified_req_version_id);

create index idx_fk_verifying_step_action_test_step on verifying_steps(test_step_id);

create index idx_fk_verifying_step_requirement_version_coverage on verifying_steps(requirement_version_coverage_id);

create index idx_fk_verifying_test_case on requirement_version_coverage(verifying_test_case_id);

create index idx_milestone_camp_camp on milestone_campaign(campaign_id);

create index idx_milestone_camp_milestone on milestone_campaign(milestone_id);

create index idx_milestone_rqv_milestone on milestone_req_version(milestone_id);

create index idx_milestone_rqv_rqv on milestone_req_version(req_version_id);

create index idx_milestone_tc_milestone on milestone_test_case(milestone_id);

create index idx_milestone_tc_tc on milestone_test_case(test_case_id);

create index idx_proj_req_categories on project(req_categories_list);

create index idx_proj_tc_natures on project(tc_natures_list);

create index idx_proj_tc_types on project(tc_types_list);

create index idx_tm_project_ta_server on project(ta_server_id);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-fixing-postgresql-index', 'jthebault', '../tm/tm.changelog-1.19.0.xml', NOW(), 31, '8:20eefd2aeeab2a6918b3847c06490998', 'sql', '', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Changeset ../tm/tm.changelog-1.19.0.xml::tm-1.19.0-Mantis-7547::jprioux
-- Increase remote req id limit to 50 for jira
ALTER TABLE REQUIREMENT_SYNC_EXTENDER ALTER COLUMN REMOTE_REQ_ID TYPE VARCHAR(50) USING (REMOTE_REQ_ID::VARCHAR(50));

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.19.0-Mantis-7547', 'jprioux', '../tm/tm.changelog-1.19.0.xml', NOW(), 32, '8:6126f9f59100826dc05c3555f38986a5', 'modifyDataType columnName=REMOTE_REQ_ID, tableName=REQUIREMENT_SYNC_EXTENDER', 'Increase remote req id limit to 50 for jira', 'EXECUTED', NULL, NULL, '4.17.2', '9340187794');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

