-- *********************************************************************
-- Update Database Script
-- *********************************************************************
-- Change Log: upgrade.changelog-up-to-1.22.2.xml
-- Ran at: 25/06/2024 20:29
-- Against: squashtm@jdbc:postgresql://postgres/squashtest
-- Liquibase version: 4.17.2
-- *********************************************************************

-- Lock Database
UPDATE databasechangeloglock SET LOCKED = TRUE, LOCKEDBY = 'runner-yfpexrfv8-project-33554404-concurrent-0-kowxep0y (100.64.33.125)', LOCKGRANTED = NOW() WHERE ID = 1 AND LOCKED = FALSE;

-- Changeset ../tm/tm.changelog-1.22.2.xml::tm-1.22.2-SQUASH-5232-add-databasechangelog-new-columns::jprioux
-- Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table
ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS CONTEXTS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS LABELS VARCHAR(255) DEFAULT NULL;

ALTER TABLE DATABASECHANGELOG ADD COLUMN IF NOT EXISTS DEPLOYMENT_ID VARCHAR(10) DEFAULT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.22.2-SQUASH-5232-add-databasechangelog-new-columns', 'jprioux', '../tm/tm.changelog-1.22.2.xml', NOW(), 1, '8:aeea36396a9ec2a5a73082a8a593b123', 'sql', 'Add Contexts, labels and deployment_id columns to DATABASECHANGELOG Table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187989');

-- Changeset ../tm/tm.changelog-1.22.2.xml::tm-1.22.2::jprioux
-- Update TM database version number
UPDATE CORE_CONFIG SET VALUE = '1.22.2' WHERE STR_KEY = 'squashtest.tm.database.version';

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.22.2', 'jprioux', '../tm/tm.changelog-1.22.2.xml', NOW(), 2, '8:1d09c980a897f71d3d73c0ca2c47ce70', 'update tableName=CORE_CONFIG', 'Update TM database version number', 'EXECUTED', NULL, NULL, '4.17.2', '9340187989');

-- Changeset ../tm/tm.changelog-1.22.2.xml::tm-1.22.2-SQUASH-2701-1-add-tc-scm-repository-id-column::jprioux
-- Add a new column in test case for link to scm repository
ALTER TABLE TEST_CASE ADD SCM_REPOSITORY_ID BIGINT;

ALTER TABLE TEST_CASE ADD CONSTRAINT fk_tc_scm_repository FOREIGN KEY (SCM_REPOSITORY_ID) REFERENCES SCM_REPOSITORY (SCM_REPOSITORY_ID);

COMMENT ON COLUMN TEST_CASE.SCM_REPOSITORY_ID IS 'foreign key to SCM_REPOSITORY, link to associated scm repository.';

CREATE INDEX idx_fk_tc_scm_repository ON TEST_CASE(SCM_REPOSITORY_ID);

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.22.2-SQUASH-2701-1-add-tc-scm-repository-id-column', 'jprioux', '../tm/tm.changelog-1.22.2.xml', NOW(), 3, '8:fd3c66d334caa1b7a5d6069caf9439ab', 'addColumn tableName=TEST_CASE; createIndex indexName=idx_fk_tc_scm_repository, tableName=TEST_CASE', 'Add a new column in test case for link to scm repository', 'EXECUTED', NULL, NULL, '4.17.2', '9340187989');

-- Changeset ../tm/tm.changelog-1.22.2.xml::tm-1.22.2-SQUASH-2701-2-scm-repository-url-temporary-table::jprioux
-- Create temporary table for migration
CREATE TABLE SCM_REPOSITORY_URL_MIGRATION_TEMP (TCLN_ID BIGINT NOT NULL, SOURCE_CODE_REPOSITORY_URL VARCHAR(255), SERVER_URL_FROM_TC VARCHAR(255), REPOSITORY_NAME_FROM_TC VARCHAR(255), SCM_SERVER_ID BIGINT, SCM_REPOSITORY_ID BIGINT, CONSTRAINT "SCM_REPOSITORY_URL_MIGRATION_TEMP_pkey" PRIMARY KEY (TCLN_ID));

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.22.2-SQUASH-2701-2-scm-repository-url-temporary-table', 'jprioux', '../tm/tm.changelog-1.22.2.xml', NOW(), 4, '8:2847aa4932eaed45bfa918715620ac19', 'createTable tableName=SCM_REPOSITORY_URL_MIGRATION_TEMP', 'Create temporary table for migration', 'EXECUTED', NULL, NULL, '4.17.2', '9340187989');

-- Changeset ../tm/tm.changelog-1.22.2.xml::tm-1.22.2-SQUASH-2701-3-psql-migration-for-scm-repo-url::jprioux
-- Migration part if scm repository url has been added in tc
INSERT INTO SCM_REPOSITORY_URL_MIGRATION_TEMP
      SELECT tc.TCLN_ID,
             TRIM(TRAILING '/' FROM TRIM(tc.SOURCE_CODE_REPOSITORY_URL)),
             REGEXP_REPLACE(TRIM(TRAILING '/' FROM TRIM(tc.SOURCE_CODE_REPOSITORY_URL)), '\/[^\/]+$', ''),
             REGEXP_REPLACE(TRIM(TRAILING '/' FROM TRIM(tc.SOURCE_CODE_REPOSITORY_URL)), '.*[\/]', ''),
             null,
             null
      FROM TEST_CASE tc
      WHERE tc.SOURCE_CODE_REPOSITORY_URL IS NOT NULL;

UPDATE SCM_REPOSITORY_URL_MIGRATION_TEMP mig
      SET SCM_REPOSITORY_ID = repo.SCM_REPOSITORY_ID, SCM_SERVER_ID = repo.SERVER_ID
      FROM TEST_CASE_LIBRARY_NODE tcln
      JOIN PROJECT p ON tcln.PROJECT_ID = p.PROJECT_ID
      JOIN SCM_REPOSITORY repo ON p.SCM_REPOSITORY_ID = repo.SCM_REPOSITORY_ID
      JOIN THIRD_PARTY_SERVER server ON server.SERVER_ID = repo.SERVER_ID
      WHERE mig.TCLN_ID = tcln.TCLN_ID
        AND mig.REPOSITORY_NAME_FROM_TC = repo.NAME
        AND (mig.SERVER_URL_FROM_TC = server.URL or CONCAT(mig.SERVER_URL_FROM_TC, '/') = server.URL);

UPDATE SCM_REPOSITORY_URL_MIGRATION_TEMP mig
      SET SCM_SERVER_ID = repo.SERVER_ID
      FROM TEST_CASE_LIBRARY_NODE tcln
      JOIN PROJECT p ON tcln.PROJECT_ID = p.PROJECT_ID
      JOIN SCM_REPOSITORY repo ON p.SCM_REPOSITORY_ID = repo.SCM_REPOSITORY_ID
      JOIN THIRD_PARTY_SERVER server ON server.SERVER_ID = repo.SERVER_ID
      WHERE mig.SCM_SERVER_ID IS NULL
        AND mig.TCLN_ID = tcln.TCLN_ID
        AND (mig.SERVER_URL_FROM_TC = server.URL or CONCAT(mig.SERVER_URL_FROM_TC, '/') = server.URL);

UPDATE SCM_REPOSITORY_URL_MIGRATION_TEMP mig
      SET SCM_REPOSITORY_ID = repo.SCM_REPOSITORY_ID, SCM_SERVER_ID = repo.SERVER_ID
      FROM SCM_REPOSITORY repo
      JOIN THIRD_PARTY_SERVER server ON server.SERVER_ID = repo.SERVER_ID
      WHERE mig.SCM_REPOSITORY_ID IS NULL
        AND mig.REPOSITORY_NAME_FROM_TC = repo.NAME
        AND (mig.SERVER_URL_FROM_TC = server.URL or CONCAT(mig.SERVER_URL_FROM_TC, '/') = server.URL);

UPDATE SCM_REPOSITORY_URL_MIGRATION_TEMP mig
      SET SCM_SERVER_ID = scmserver.SERVER_ID
      FROM THIRD_PARTY_SERVER server
      JOIN SCM_SERVER scmserver ON server.SERVER_ID = scmserver.SERVER_ID
      WHERE mig.SCM_SERVER_ID IS NULL
        AND (mig.SERVER_URL_FROM_TC = server.URL or CONCAT(mig.SERVER_URL_FROM_TC, '/') = server.URL);

INSERT INTO THIRD_PARTY_SERVER (NAME, URL, AUTH_POLICY, AUTH_PROTOCOL)
      SELECT distinct on (mig.SERVER_URL_FROM_TC) CONCAT('mig_git_', mig.TCLN_ID),
             mig.SERVER_URL_FROM_TC,
             'APP_LEVEL',
             'BASIC_AUTH'
      FROM SCM_REPOSITORY_URL_MIGRATION_TEMP mig
      WHERE mig.SCM_SERVER_ID IS NULL;

INSERT INTO SCM_SERVER (SERVER_ID, KIND)
      SELECT server.SERVER_ID,
             'git'
      FROM THIRD_PARTY_SERVER server
      LEFT JOIN SCM_SERVER scm ON server.SERVER_ID = scm.SERVER_ID
      WHERE scm.SERVER_ID IS NULL
        and server.NAME LIKE 'mig_git_%';

UPDATE SCM_REPOSITORY_URL_MIGRATION_TEMP
      SET SCM_SERVER_ID = server.SERVER_ID
      FROM THIRD_PARTY_SERVER server
      WHERE server.URL = SERVER_URL_FROM_TC and SCM_SERVER_ID IS NULL;

INSERT INTO SCM_REPOSITORY (SERVER_ID, NAME, REPOSITORY_PATH, WORKING_BRANCH)
      SELECT distinct on (mig.SOURCE_CODE_REPOSITORY_URL) server.SERVER_ID,
             mig.REPOSITORY_NAME_FROM_TC,
             '',
             'master'
      FROM SCM_REPOSITORY_URL_MIGRATION_TEMP mig
      JOIN THIRD_PARTY_SERVER server ON mig.SCM_SERVER_ID = server.SERVER_ID
      WHERE mig.SCM_REPOSITORY_ID IS NULL;

UPDATE SCM_REPOSITORY_URL_MIGRATION_TEMP mig
      SET SCM_REPOSITORY_ID = repo.SCM_REPOSITORY_ID
      FROM SCM_REPOSITORY repo
      WHERE mig.SCM_SERVER_ID = repo.SERVER_ID
        and mig.REPOSITORY_NAME_FROM_TC = repo.NAME
        and mig.SCM_REPOSITORY_ID IS NULL;

UPDATE TEST_CASE tc
      SET SCM_REPOSITORY_ID = mig.SCM_REPOSITORY_ID
      FROM SCM_REPOSITORY_URL_MIGRATION_TEMP mig
      WHERE tc.TCLN_ID = mig.TCLN_ID
        and mig.SCM_REPOSITORY_ID IS NOT NULL;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.22.2-SQUASH-2701-3-psql-migration-for-scm-repo-url', 'jprioux', '../tm/tm.changelog-1.22.2.xml', NOW(), 5, '8:61aa8fd01f64129eb33564a8fb9703d9', 'sql; sql; sql; sql; sql', 'Migration part if scm repository url has been added in tc', 'EXECUTED', NULL, NULL, '4.17.2', '9340187989');

-- Changeset ../tm/tm.changelog-1.22.2.xml::tm-1.22.2-SQUASH-2701-4-drop-old-column-and-temp-table::jprioux
-- Drop unnecessary old column and the temporary table
ALTER TABLE TEST_CASE DROP COLUMN SOURCE_CODE_REPOSITORY_URL;

DROP TABLE SCM_REPOSITORY_URL_MIGRATION_TEMP;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.22.2-SQUASH-2701-4-drop-old-column-and-temp-table', 'jprioux', '../tm/tm.changelog-1.22.2.xml', NOW(), 6, '8:f96bcbcab7834eff17cc6da7d75d0b1d', 'dropColumn columnName=SOURCE_CODE_REPOSITORY_URL, tableName=TEST_CASE; dropTable tableName=SCM_REPOSITORY_URL_MIGRATION_TEMP', 'Drop unnecessary old column and the temporary table', 'EXECUTED', NULL, NULL, '4.17.2', '9340187989');

-- Changeset ../tm/tm.changelog-1.22.2.xml::tm-1.22.2-SQUASH-2834-modify-scm-repo-unique-constraint::jlor
-- Modify SCM_REPOSITORY unique constraint (name, server_id) to (name, working_branch, server_id)
CREATE TABLE SCM_REPOSITORY_DATA_TEMP (SCM_REPOSITORY_ID BIGINT NOT NULL, SERVER_ID BIGINT NOT NULL, NAME VARCHAR(255) NOT NULL, WORKING_BRANCH VARCHAR(255) NOT NULL, REPOSITORY_PATH VARCHAR(255) NOT NULL, WORKING_FOLDER_PATH VARCHAR(255), CONSTRAINT "SCM_REPOSITORY_DATA_TEMP_pkey" PRIMARY KEY (SCM_REPOSITORY_ID), CONSTRAINT fk_scm_repository_data_temp_scm_server FOREIGN KEY (SERVER_ID) REFERENCES SCM_SERVER(SERVER_ID));

INSERT INTO SCM_REPOSITORY_DATA_TEMP (SCM_REPOSITORY_ID, SERVER_ID, NAME, WORKING_BRANCH, REPOSITORY_PATH, WORKING_FOLDER_PATH)
      SELECT SCM_REPOSITORY_ID, SERVER_ID, NAME, WORKING_BRANCH, REPOSITORY_PATH, WORKING_FOLDER_PATH
      FROM SCM_REPOSITORY;

ALTER TABLE PROJECT DROP CONSTRAINT fk_project_scm_repository;

ALTER TABLE TEST_CASE DROP CONSTRAINT fk_tc_scm_repository;

DROP TABLE SCM_REPOSITORY;

CREATE TABLE SCM_REPOSITORY (SCM_REPOSITORY_ID BIGINT GENERATED BY DEFAULT AS IDENTITY NOT NULL, SERVER_ID BIGINT NOT NULL, NAME VARCHAR(255) NOT NULL, WORKING_BRANCH VARCHAR(255) NOT NULL, REPOSITORY_PATH VARCHAR(255) NOT NULL, WORKING_FOLDER_PATH VARCHAR(255), CONSTRAINT "SCM_REPOSITORY_pkey" PRIMARY KEY (SCM_REPOSITORY_ID), CONSTRAINT fk_scm_repository_scm_server FOREIGN KEY (SERVER_ID) REFERENCES SCM_SERVER(SERVER_ID));

COMMENT ON COLUMN SCM_REPOSITORY.SCM_REPOSITORY_ID IS 'The auto-generated id of the scm repository.';

COMMENT ON COLUMN SCM_REPOSITORY.SERVER_ID IS 'The foreign key to the related SCM_SEVER';

COMMENT ON COLUMN SCM_REPOSITORY.NAME IS 'The name of the repository.';

COMMENT ON COLUMN SCM_REPOSITORY.WORKING_BRANCH IS 'The name of the working branch on which SquashTM will push.';

COMMENT ON COLUMN SCM_REPOSITORY.REPOSITORY_PATH IS 'The absolute path to the local repository on the local server.';

COMMENT ON COLUMN SCM_REPOSITORY.WORKING_FOLDER_PATH IS 'The relative path of the working folder in which SquashTM will push.';

ALTER TABLE SCM_REPOSITORY ADD CONSTRAINT uniq_scm_repo_name_branch_server_id UNIQUE (NAME, WORKING_BRANCH, SERVER_ID);

CREATE INDEX idx_fk_scm_repository_scm_server ON SCM_REPOSITORY(SERVER_ID);

INSERT INTO SCM_REPOSITORY (SCM_REPOSITORY_ID, SERVER_ID, NAME, WORKING_BRANCH, REPOSITORY_PATH, WORKING_FOLDER_PATH)
      SELECT SCM_REPOSITORY_ID, SERVER_ID, NAME, WORKING_BRANCH, REPOSITORY_PATH, WORKING_FOLDER_PATH
      FROM SCM_REPOSITORY_DATA_TEMP;

ALTER TABLE PROJECT ADD CONSTRAINT fk_project_scm_repository FOREIGN KEY (SCM_REPOSITORY_ID) REFERENCES SCM_REPOSITORY (SCM_REPOSITORY_ID);

ALTER TABLE TEST_CASE ADD CONSTRAINT fk_tc_scm_repository FOREIGN KEY (SCM_REPOSITORY_ID) REFERENCES SCM_REPOSITORY (SCM_REPOSITORY_ID);

DROP TABLE SCM_REPOSITORY_DATA_TEMP;

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.22.2-SQUASH-2834-modify-scm-repo-unique-constraint', 'jlor', '../tm/tm.changelog-1.22.2.xml', NOW(), 7, '8:9be1e9071813ddbb3900c7789932d3ae', 'createTable tableName=SCM_REPOSITORY_DATA_TEMP; sql; dropForeignKeyConstraint baseTableName=PROJECT, constraintName=fk_project_scm_repository; dropForeignKeyConstraint baseTableName=TEST_CASE, constraintName=fk_tc_scm_repository; dropTable tableNa...', 'Modify SCM_REPOSITORY unique constraint (name, server_id) to (name, working_branch, server_id)', 'EXECUTED', NULL, NULL, '4.17.2', '9340187989');

-- Changeset ../tm/tm.changelog-1.22.2.xml::tm-1.22.2-add-auto-test-tech::aguilhem
-- Add new compatible auto. test tech.
insert into AUTOMATED_TEST_TECHNOLOGY(NAME, ACTION_PROVIDER_KEY)
      values ('SoapUI', 'soapui/execute@v1'),
      ('Agilitest', 'agilitest/execute@v1'),
      ('UFT', 'uft/execute@v1'),
      ('Ranorex', 'ranorex/execute@v1');

INSERT INTO databasechangelog (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('tm-1.22.2-add-auto-test-tech', 'aguilhem', '../tm/tm.changelog-1.22.2.xml', NOW(), 8, '8:bfa1aaf9176fea66ebdcbf35bf9601a8', 'sql', 'Add new compatible auto. test tech.', 'EXECUTED', NULL, NULL, '4.17.2', '9340187989');

-- Release Database Lock
UPDATE databasechangeloglock SET LOCKED = FALSE, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1;

